Comment 

_menu
	Don't forget to check if the menu will fit on screen! If it
	won't, just put it as far up (or to the left) as possible. _menu
	will handle menus higher than the screen, but NOT menus wider
	than the screen!

Misc
	Hmmm, when running HexIt as F3-viewer in NC4, you'll only get
	approx. 170Kb free conv mem.

Videomodes
	Change the following when adding new modes:
		o fontsize-list
		o all structures where you choose videomode (just ctrl+f1?)
		o config of mode at startup/shutdown

	HexIt reqs at least 66KB conv mem extra besides the number in
	the exeheader.


.386p

IFDEF   WIN32
.model flat, stdcall
.code
ENDIF

IFDEF   MSDOS
code32 segment para public use32
	assume cs:code32, ds:code32
public	_main
ENDIF

include sys.inc
include defines.inc
IFDEF   MSDOS
include file.inc
ENDIF
include dazmit.inc
include hexit.inc
include argc.inc
include funcs.inc
include bss.inc
include buildnum.inc
UNICODE = 0

;
; C o d e 
;
_main:
IFDEF   MSDOS
	sti
ENDIF
	cld

	call	_init			; allocate mem, load cmdline-files...
	jc	_end			; some problem occured
	call	_putbothscreens&cursor	; put screen & cursor

	cmp	___init_nofilesloaded,0
	je	mainlop
	lea	esi,newfilename
	lea	edi,openfilemenuname
__nofilesloaded:
	lodsb
	stosb
	or	al,al
	jnz	__nofilesloaded
	call	_do_loadfile

;
;
; MOO: check if the files given on cmdline were loaded properly
mainlop:
	call	_mouse

	call	_drawtoprow
	push	-1
	call	_drawbottomrow

IFDEF	MSDOS
	call	_checkkey
	jnz	mainkeypressed
	call	_slice
;	call	_drawtoprow
;	push	-1
;	call	_drawbottomrow
	jmp	mainlop
ENDIF

mainkeypressed:
	call	_getkey

	cmp	bl,SHIFTKEY_CTRL OR SHIFTKEY_ALT
	jne	__testkey

        cmp     ah,KEY_R
        jne     @@notr
        call    _runhelper
        jmp     mainlop
@@notr:

	cmp	ah,KEY_BS		; ^@BackSpace = Exit HexIt
	jne	__testkey_notcabackspace
	call	_do_exit
	jmp	mainlop
__testkey_notcabackspace:
	cmp	ah,KEY_ENTER		; ^@Enter = Setup
	jne	__testkey_notcaenter
	call	_do_setup
	jmp	mainlop
__testkey_notcaenter:

__testkey:
	mov	___testkey_twokeys,0
	movzx	ebp,activewindow
	mov	edx,offset keys-SIZEOF_KEYS
__testkey_lop:
	add	edx,SIZEOF_KEYS
        mov     bh,[edx]
        or      bh,bh
	jz	__editkey?
        test    mode[ebp],bh
	jz	__testkey_lop
        cmp     bl,[edx+1]
	jne	__testkey_lop
	cmp	[edx+2],ah
	jne	__testkey_lop
	cmp	byte ptr [edx+3],0
	je	__testkey_singlekey
	cmp	___testkey_twokeys,0
	je	__testkey_firsttime
        mov     bh,___testkey_2ndkey
        cmp     [edx+3],bh
	je	__testkey_singlekey
	jmp	__testkey_lop
__testkey_firsttime:
	push	eax
        push    ebx
__testkey_again:
	call	_getkey
	jc	__testkey_again
	mov	___testkey_twokeys,-1
	mov	___testkey_2ndkey,ah
	cmp	[edx+3],ah
        pop     ebx
	pop	eax
	jne	__testkey_lop
__testkey_singlekey:
	mov	edx,[edx+4]
	cmp	edx,MAX_FUNCTION
	ja	mainlop
	call	functions[edx*8]
	jmp	mainlop

;
; What happens when a key is pressed? 
;
; E D I T 
__editkey?:
	cmp	numberoffiles,0
	je	mainlop
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	cmp	mode[ebx],MODE_HEXMODE
	je	__editallowed
	cmp	mode[ebx],MODE_CODEMODE
	jne	mainlop
	jmp	_edit_hexfield
__editallowed:					; check if we're in hex-
	cmp	field[ebp*2+ebx],0		;  or textfield
	je	_edit_hexfield			; hex -> jump!
						; ok, we're in textfield
	cmp	al,0
	je	mainlop
	cmp	insert,1
	jne	_dont_insert_a_byte
	mov	esi,1
	call	_insert_x_bytes
	jnc	_dont_insert_a_byte
	mov	eax,1
	call	_reallocmainmem
	jc	mainlop
_dont_insert_a_byte:
	mov	nibble[ebp*2+ebx],1
	shl	ebx,2
	mov	edi,filebufferpos[ebp*8+ebx]

	cmp	insert,1
	je	dontworry1
	cmp	edi,filesize[ebp*4]
	jae	mainlop
dontworry1:

	add	edi,filebufferptr[ebp*4]
	mov	byte ptr [edi],al
	mov	eax,filesize[ebp*4]
	cmp	filebufferpos[ebp*8+ebx],eax
	jae	_donotincfilebufferpos
	inc	filebufferpos[ebp*8+ebx]
_donotincfilebufferpos:
	mov	filechanged[ebp],1
	call	_putbothscreens&cursor
	jmp	mainlop

_edit_hexfield:
	cmp	al,'0'                          ; make sure it's a valid
	jb	mainlop 			;  hexdigit
	cmp	al,'f'
	ja	mainlop
	cmp	al,'a'
	jae	_gemen
	cmp	al,'F'
	ja	mainlop
	cmp	al,'A'
	jae	_versalordigit
	cmp	al,'9'
	jbe	_versalordigit
	jmp	mainlop
_gemen:
	sub	al,32				; make it uppercase
_versalordigit:
	call	_hex2bin
	cmp	al,15
	ja	mainlop
	shl	ebx,2
	mov	edi,filebufferpos[ebp*8+ebx]

	cmp	insert,1
	je	dontworry2
	cmp	edi,filesize[ebp*4]
	jae	mainlop
dontworry2:

	add	edi,filebufferptr[ebp*4]
	shr	ebx,2
	mov	cl,nibble[ebp*2+ebx]
	cmp	insert,1
	jne	_not_low_nibble
	cmp	cl,1
	jne	_not_low_nibble
	mov	esi,1
	call	_insert_x_bytes
	jnc	_not_low_nibble
	push	eax
	mov	eax,1
	call	_reallocmainmem
	pop	eax
	jc	mainlop
_not_low_nibble:
	shl	cl,2
	mov	dl,11110000b
	rol	dl,cl
	and	byte ptr [edi],dl
	shl	al,cl
	or	byte ptr [edi],al
	neg	nibble[ebp*2+ebx]
	inc	nibble[ebp*2+ebx]
	cmp	nibble[ebp*2+ebx],1
	jne	_goingtolownibble
	shl	ebx,2
	mov	eax,filesize[ebp*4]
	cmp	filebufferpos[ebp*8+ebx],eax
	jae	_goingtolownibble
	inc	filebufferpos[ebp*8+ebx]
_goingtolownibble:
	mov	filechanged[ebp],1
	call	_putbothscreens&cursor
	cmp	mode[ebx],MODE_CODEMODE
	jne	mainlop
	call	_do_codeviewinit
	jmp	mainlop


;
;
_end:
	cmp	pastinit,1
	jne	nocfgchange
	mov	esi,offset firstconfigbyte
	mov	edi,offset oldconfig
	mov	ecx,bytesincfg
	repe	cmpsb
	or	ecx,ecx
	jz	nocfgchange
	call	_putbothscreens
	mov	esi,offset cfgchangestr
	call	_popupmenu
	cmp	dl,2
	ja	nocfgchange
	je	exitandsave
putscreensandgotomainlop:
	call	_putbothscreens&cursor
	jmp	mainlop
exitandsave:
	call	_putbothscreens
	call	_savesetup
	jc	putscreensandgotomainlop
nocfgchange:
	cmp     restorevideo,1
	je	okrestoreit
        mov     numberofrows,25
        lea     eax,[videomodesend+1]           ; # of videomodes + 1
        sub     eax,offset videomodes
        cmp     restorevideo,al
        ja      setvideoatexit
        movzx   eax,restorevideo
        mov     al,videomodes[eax-2]
        mov     numberofrows,eax
setvideoatexit:
	call	_setvideo
	jmp	donewithvideo
okrestoreit:
	cmp	videosaved,0
	jne	donewithvideo
	call	_restorevideo
donewithvideo:
	mov	edx,offset endmsg1
	call	_puts
	mov	eax,timesopened
	call	_printdec_dwordt
	mov	edx,offset endmsg2
	call	_puts

_end_restorecursor:
        jmp     _exithexit


;
; S u b f u n c t i o n s 
;
; _parsekeynames( dword mode, dword ptr functionslist );
; Steps through the list of functions and figures out what the keynames
; are called. It then prints those keynames to the designated buffers.
;	mode == what mode(s) (hexmode, textmode etc) to include
_parsekeynames:
	pushad
	mov	ebx,[esp+2*4+32]
	mov	___parsekeynames_mode,bl
	mov	ebp,[esp+4+32]
__parsekeynames_lop:
	mov	ebx,[ebp]
	cmp	ebx,-1
	je	__parsekeynames_end
	mov	ecx,[ebp+1*4]
	or	ecx,ecx
	jnz	__parsekeynames_notall1
	inc	ecx
__parsekeynames_notall1:
	mov	edi,offset keynamesbuffer
	mov	dl,___parsekeynames_mode
	call	_getfunctionkey
	mov	ebx,MAX_KEYNAMESIZE
	or	ah,ah
	jz	__parsekeynames_none
__parsekeynames_parse:
	test	al,3
	jz	__parsekeynames_notshift
	push	ecx
	mov	ecx,8
	mov	esi,offset keynamesshift
	sub	ebx,ecx
	rep	movsb
	pop	ecx
__parsekeynames_notshift:
	test	al,4
	jz	__parsekeynames_notctrl
	push	ecx
	mov	ecx,7
	mov	esi,offset keynamesctrl
	sub	ebx,ecx
	rep	movsb
	pop	ecx
__parsekeynames_notctrl:
	test	al,8
	jz	__parsekeynames_notalt
	push	ecx
	mov	ecx,6
	mov	esi,offset keynamesalt
	sub	ebx,ecx
	rep	movsb
	pop	ecx
__parsekeynames_notalt:
	mov	al,'<'
	stosb
	dec	ebx
	mov	esi,offset keynames-(1+4)
__parsekeynames_nameslop:
	add	esi,1+4
	cmp	byte ptr [esi],-1
	je	__parsekeynames_namesunknown
	cmp	[esi],ah
	jne	__parsekeynames_nameslop
	mov	esi,[esi+1]
	push	ecx
	movzx	ecx,byte ptr [esi]
	sub	ebx,ecx
	inc	esi
	rep	movsb
	pop	ecx
	mov	al,'>'
	stosb
	dec	ebx
	or	dh,dh
	jz	__parsekeynames_fill
	mov	al,'+'
	stosb
	dec	ebx
	mov	ah,dh
	xor	dh,dh
	jmp	__parsekeynames_notalt
__parsekeynames_namesunknown:
	push	ecx
	mov	ecx,9
	mov	esi,offset keynamesunknown
	rep	movsb
	pop	ecx
	mov	al,'>'
	stosb
	sub	ebx,10
	or	dh,dh
	jz	__parsekeynames_fill
	mov	al,'+'
	stosb
	dec	ebx
	mov	ah,dh
	xor	dh,dh
	jmp	__parsekeynames_notalt

__parsekeynames_none:
	cmp	ecx,1
	jbe	__parsekeynames_nonefound
	cmp	dword ptr [ebp+1*4],0
	je	__parsekeynames_fillnow
__parsekeynames_nonefound:
	push	ecx
	mov	ecx,6
	mov	esi,offset keynamesnone
	sub	ebx,ecx
	rep	movsb
	pop	ecx

__parsekeynames_fill:
	cmp	dword ptr [ebp+1*4],0
	jne	__parsekeynames_fillnow
	inc	ecx
	push	ebx
	mov	ebx,[ebp]
	mov	dl,___parsekeynames_mode
	call	_getfunctionkey
	pop	ebx
	or	ah,ah
	jz	__parsekeynames_none
	mov	word ptr [edi],' ,'
	add	edi,2
	sub	ebx,2
	jg	__parsekeynames_parse

__parsekeynames_fillnow:
	mov	ecx,ebx
	cmp	ecx,0
	jg	__parsekeynames_notfull
	je	__parsekeynames_copybuffer
	mov	edi,offset keynamesbuffer + MAX_KEYNAMESIZE - 3
	mov	byte ptr [edi],'.'
	mov	word ptr [edi+1],'..'
	jmp	__parsekeynames_copybuffer
__parsekeynames_notfull:
	mov	al,' '
	rep	stosb
__parsekeynames_copybuffer:
	mov	esi,offset keynamesbuffer
	mov	edi,[ebp+2*4]
	mov	ecx,MAX_KEYNAMESIZE
	rep	movsb
	add	ebp,3*4
	jmp	__parsekeynames_lop
__parsekeynames_all1:

__parsekeynames_end:
	popad
	ret	2*4


;
; adds a new keydefinition (or replaces the old one if that key is
; already defined)
; In:
;	AL	= key1: shiftkeys (shift, ctrl, alt. see int 16,2)
;	AH	= key1: scancode
;	DL	= mode (textmode, hexmode etc)
;	DH	= key2: scancode ( 0 == single-key functions )
;	EBX	= functionnumber
; Out:
;	CF	= Error ( 1 = yes, 0 = no )
_addkeyfunction:
	pushad
	mov	edi,offset keys-SIZEOF_KEYS
__addkeyfunction_prelop:
	add	edi,SIZEOF_KEYS
	cmp	byte ptr [edi],0
	jne	__addkeyfunction_prelop ; now edi points to where the new
					; keydata should be inserted

	cmp	edi,offset keys + ( MAXKEYS - 1 ) * SIZEOF_KEYS
	jae	__addkeyfunction_error
	mov	ebp,ebx
	push	offset keys
	call	_getkeyfunction
	cmp	ebx,-1
	je	__addkeyfunction_new

	push	edx
	mov	esi,offset keyexistsmenu
	call	_popupmenu
	call	_putbothscreens
	cmp	dl,1
	pop	edx
	jne	__addkeyfunction_end

	mov	bl,byte ptr [ecx]
	and	bl,dl
	cmp	bl,byte ptr [ecx]
	jne	__addkeyfunction_exists
__addkeyfunction_redundantkeyleft:
	mov	[ecx],dl			; overwrite old definition
	mov	[ecx+1],al
	mov	[ecx+2],ah
	mov	[ecx+3],dh
	mov	[ecx+4],ebp
	jmp	__addkeyfunction_end
__addkeyfunction_exists:
	mov	bl,dl
	not	bl
	and	byte ptr [ecx],bl
	cmp	byte ptr [ecx],0
	je	__addkeyfunction_redundantkeyleft
__addkeyfunction_new:
	mov	[edi],dl
	mov	[edi+1],al
	mov	[edi+2],ah
	mov	[edi+3],dh
	mov	[edi+4],ebp
	add	edi,SIZEOF_KEYS
	mov	ecx,SIZEOF_KEYS
	xor	al,al
	rep	stosb
__addkeyfunction_end:
	popad
	clc
	ret

__addkeyfunction_error: 		; too many keys!
	popad
	stc
	ret


;
; removes a keydefinition
; In:
;	AL	= key1: shiftkeys (shift, ctrl, alt. see int 16,2)
;	AH	= key1: scancode
;	DL	= mode (textmode, hexmode etc)
;	DH	= key2: scancode ( 0 == single-key functions )
_removekeyfunction:
	pushad
	push	offset keys
	call	_getkeyfunction
	cmp	ebx,-1			; is key defined?
	je	popad&stc&ret
	mov	edi,ecx
	lea	esi,[edi+SIZEOF_KEYS]
__removekeyfunction_lop:
	mov	ecx,SIZEOF_KEYS
	rep	movsb
	cmp	byte ptr [edi],0
	jne	__removekeyfunction_lop
	popad
	ret


;
; _getkeyfunction( ptr keydata );
; Checks what function a certain key corresponds to.
; In:
;	AL	= key1: shiftkeys (shift, ctrl, alt. see int 16,2)
;	AH	= key1: scancode
;	DL	= mode (textmode, hexmode etc)
;	DH	= key2: scancode ( 0 == single-key functions )
;	STACK	= ptr to keydata
; Out:
;	EBX	= functionnumber ( -1 == no function )
;	ECX	-> Keydefinition for requested key
_getkeyfunction:
	push	eax edx
	mov	ecx,[esp+4+4*2]
	sub	ecx,SIZEOF_KEYS
	xor	ebx,ebx
__getkeyfunction_lop:
	add	ecx,SIZEOF_KEYS
	mov	bl,[ecx]
	or	bl,bl
	jz	__getkeyfunction_end
	test	dl,bl
	jz	__getkeyfunction_lop
	mov	bl,[ecx+1]
	cmp	al,bl
	jne	__getkeyfunction_lop
	cmp	[ecx+2],ah
	jne	__getkeyfunction_lop
	cmp	dh,0
	je	__getkeyfunction_singlekey
	cmp	[ecx+3],dh
	jne	__getkeyfunction_lop
__getkeyfunction_singlekey:
	mov	ebx,[ecx+4]
	inc	ebx
__getkeyfunction_end:
	dec	ebx
	pop	edx eax
	ret	4


;
; Checks what key a certain function is bound to.
; In:
;	EBX	= functionnumber
;	ECX	= keycount ( 1 = first key that matches this function,
;			     2 = second key... etc )
;	DL	= mode (textmode, hexmode etc)
; Out:
;	AL	= key1: shiftkeys (shift, ctrl, alt. see int 16,2)
;	AH	= key1: scancode ( 0 == no key defined for this function )
;	DL	= mode (textmode, hexmode etc)
;	DH	= key2: scancode ( 0 == single-key functions )
_getfunctionkey:
	push	ecx esi
	mov	esi,offset keys-SIZEOF_KEYS
	xor	eax,eax
	xor	dh,dh
__getfunctionkey_lop:
	add	esi,SIZEOF_KEYS
	cmp	byte ptr [esi],0
	je	__getfunctionkey_end
	cmp	[esi],dl
	jne	__getfunctionkey_lop
	cmp	[esi+4],ebx
	jne	__getfunctionkey_lop
	dec	ecx
	jnz	__getfunctionkey_lop
;	 mov	 dl,[esi]		; already equal
	mov	ax,[esi+1]
	mov	dh,[esi+3]
__getfunctionkey_end:
	pop	esi ecx
	ret


;
; Pushes a key onto the keystack
; In:
;	EAX	= keyinfo
;		AL	= character
;		AH	= scancode
;		bits 23..16 = shiftkeys (shift, ctrl, alt. see int 16,2)
_pushkey:
	push	eax
	push	esi
	cmp	keysinbuffer,MAX_KEYSINBUFFER
	jae	__pushkey_done
	cmp	recmacro,0
	je	__pushkey_norec
	mov	esi,keysinrecbuffer
	cmp	esi,MAX_KEYSINBUFFER
	jb	__pushkey_sizeok
	cmp	___pushkey_recursed,1
	je	__pushkey_norec
	mov	___pushkey_recursed,1
	lea	esi,macrotoolongstr	; macro too long
	push	edx
	call	_popupmenu
	pop	edx
	call	_putbothscreens&cursor
	mov	___pushkey_recursed,0
	call	_do_togglemacrorec
	jmp	__pushkey_norec
__pushkey_sizeok:
	lea	esi,[esi*4]
	add	esi,precbuffer
	mov	[esi],eax
	inc	keysinrecbuffer
__pushkey_norec:

	mov	esi,keybufferpos
	add	esi,keysinbuffer
	and	esi,MAX_KEYSINBUFFER - 1
	lea	esi,[esi*4]
	add	esi,pkeybuffer
	mov	word ptr [esi],ax
	shr	eax,16
	mov	byte ptr [esi+2],al
	inc	keysinbuffer
__pushkey_done:
	pop	esi
	pop	eax
	ret


;
; Pops a key from the keystack
; Out:
;	AL	= character
;	AH	= scancode
;	BL      = shiftkeys (shift, ctrl, alt. see int 16,2)
;       CF      = 1 if stack is empty
_popkey:
        cmp     keysinbuffer,0
        je      _stc&ret
        push    esi
	mov	esi,keybufferpos
	and	esi,MAX_KEYSINBUFFER - 1
	lea	esi,[esi*4]
	add	esi,pkeybuffer
	mov	bl,byte ptr [esi+2]
	mov	ax,word ptr [esi]
	dec	keysinbuffer
	inc	keybufferpos
	pop	esi
        clc
	ret


;
_sync:
IFDEF	MSDOS
	push	eax edx
	mov	dx,3dah
s1:
	in	al,dx
	test	al,8
	jnz	s1
s2:
	in	al,dx
	test	al,8
	jz	s2
	pop	edx eax
ENDIF
	ret


;
_hexlineup:
	push	eax ebp
	movzx	eax,activewindow
	movzx	ebp,activefile[eax]
	shl	eax,2
	cmp	filebufferpos[ebp*8+eax],16
	ja	___notfirst16
	mov	filebufferpos[ebp*8+eax],16
___notfirst16:
	sub	filebufferpos[ebp*8+eax],16
	shr	eax,2
	cmp	nibblemove,1
	je	hlunonibblereset
	mov	nibble[ebp*2+eax],1
hlunonibblereset:
	pop	ebp eax
	ret

;
_hexlinedown:
	pushad
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	shl	ebx,2
	mov	eax,filesize[ebp*4]
	mov	edx,filebufferpos[ebp*8+ebx]
	add	edx,17
	cmp	edx,eax
	jbe	___notlast16
	sub	eax,16
	mov	filebufferpos[ebp*8+ebx],eax
	shr	ebx,2
	mov	nibble[ebp*2+ebx],1
	shl	ebx,2
___notlast16:
	add	filebufferpos[ebp*8+ebx],16
	shr	ebx,2
	cmp	nibblemove,1
	je	hldnonibblereset
	mov	nibble[ebp*2+ebx],1
hldnonibblereset:
	popad
	ret

;
_scrhexlineup:
	push	eax ebp
	movzx	eax,activewindow
	movzx	ebp,activefile[eax]
	shl	eax,2
	cmp	screenoffset[ebp*8+eax],16
	jb	__scrhexlineup_end
	sub	filebufferpos[ebp*8+eax],16
	sub	screenoffset[ebp*8+eax],16
__scrhexlineup_end:
	pop	ebp eax
	ret

;
_scrhexlinedown:
	pushad
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	shl	ebx,2
	mov	eax,filesize[ebp*4]
	mov	edx,filebufferpos[ebp*8+ebx]
	add	edx,16
	cmp	edx,eax
	ja	_popad&ret
	add	filebufferpos[ebp*8+ebx],16
	add	screenoffset[ebp*8+ebx],16
	popad
	ret

;
; Handles all things regarding the mouse (moving and pressing buttons)
_mouse:
	cmp	mouseavailable,1
	jne	_ret
	movzx	ebx,activewindow
	cmp	mode[ebx],MODE_HEXMODE
	je	mhex
	cmp	mode[ebx],MODE_TEXTVIEW
	jne	_ret

        call    _getmousebuttons
	test	ebx,1
	jnz	mlbutton
	test	ebx,2
	jnz	mrbutton
	test	ebx,4
	jnz	mmbutton
	cmp	txtmousemove,1
	je	mforcemovetest
	call	_resetmouse
	ret

mmbutton:					; middle pressed
	mov	dl,txtmbutton
	mov	eax,4				; buttoncode
	jmp	mbuttonaction
mlbutton:					; left pressed
	mov	dl,txtlbutton
	mov	eax,1				; buttoncode
	jmp	mbuttonaction
mrbutton:					; right pressed
	mov	dl,txtrbutton
	mov	eax,2				; buttoncode
mbuttonaction:					; determine action

; the "_do_" functions contain a ret that will return to right after
; _mouse was called, so we'll just jump to the _do_FUNCTION
; this was a source for some headache after a while... ;)

	cmp	dl,15
	je	mforcemovetest
	call	_resetmouse
	cmp	dl,0
	je	_do_onlinehelp
	cmp	dl,1
	je	_do_help
	cmp	dl,2
	jne	m3?
	push	eax
	call	_waitbuttonrelease
	jmp	_do_wrap
m3?:
	cmp	dl,3
	je	_do_choosefile
	cmp	dl,4
	jne	m5?
	push	eax
	call	_waitbuttonrelease
	jmp	_do_prevfile
m5?:
	cmp	dl,5
	jne	m6?
	push	eax
	call	_waitbuttonrelease
	jmp	_do_nextfile
m6?:
	cmp	dl,6
	jne	m7?
	movzx	ebx,activewindow
	push	eax
	call	_waitbuttonrelease
	jmp	togglemode
m7?:
	cmp	dl,7
	jne	m8?
	push	eax
	call	_waitbuttonrelease
	jmp	togglelinefeed
m8?:
	cmp	dl,8
	je	_do_search
	cmp	dl,9
	je	_do_replace
	cmp	dl,10
	jne	m11?
	push	eax
	call	_waitbuttonrelease
	jmp	_do_findnext
m11?:
	cmp	dl,11
	je	_do_choosevideomode
	cmp	dl,12
	je	_do_setup
	cmp	dl,13
	jne	m14?
	movzx	ecx,txtmousescrollspeed
	shl	ecx,14
	push	ecx
	call	_delay
	mov	ecx,1
	call	_xlinesup
	call	_sync
	call	_putscreen
	ret
m14?:
	cmp	dl,14
	jne	m16?
	movzx	ecx,txtmousescrollspeed
	shl	ecx,14
	push	ecx
	call	_delay
	mov	ecx,1
	call	_xlinesdown
	call	_sync
	call	_putscreen
	ret

m16?:
	cmp	dl,16
	jne	m17?
	call	_getnumdatarows
	dec	ecx
	mov	edx,ecx
	mov	ecx,1
m16lop:
	call	_xlinesup
	call	_sync
	call	_putscreen
	dec	edx
	jnz	m16lop
	ret

m17?:
	cmp	dl,17
	jne	m18?
	call	_getnumdatarows
	dec	ecx
	mov	edx,ecx
	mov	ecx,1
m17lop:
	call	_xlinesdown
	call	_sync
	call	_putscreen
	dec	edx
	jnz	m17lop
	ret

m18?:
	cmp	dl,18
	je	_do_firstbyte
	cmp	dl,19
	je	_do_lastbyte
	ret

mforcemovetest: 				; force move-test
;	mov	v86r_ax,0bh
;	mov	al,33h
;	int	33h
;	movsx	edx,v86r_dx
        call    _readmouse
        movsx   edx,dx
	mov	cl,txtmousescrollspeed
	cmp	edx,0
	je	_ret
	jg	mdown
	sar	edx,cl
	jz	_ret
	neg	edx
	mov	ecx,edx
	call	_xlinesup
	call	_putscreen
	jmp	_ret
mdown:
	sub	cl,1
	jna	mmaxspeed
	shr	edx,cl
	jz	_ret
mmaxspeed:
	mov	ecx,edx
	call	_xlinesdown
	call	_putscreen
	jmp	_ret

;----------------
mhex:
;	mov	v86r_ax,03h			; test buttons
;	mov	al,33h
;	int	33h
        call    _getmousebuttons
	test	ebx,1
	jnz	mlbutton2
	test	ebx,2
	jnz	mrbutton2
	test	ebx,4
	jnz	mmbutton2
	cmp	hexmousemove,1
	je	mforcemovetest2
	call	_resetmouse
	ret

mmbutton2:					; middle pressed
	mov	dl,hexmbutton
	mov	eax,4				; buttoncode
	jmp	mbuttonaction2
mlbutton2:					; left pressed
	mov	dl,hexlbutton
	mov	eax,1				; buttoncode
	jmp	mbuttonaction2
mrbutton2:					; right pressed
	mov	dl,hexrbutton
	mov	eax,2				; buttoncode
mbuttonaction2: 				; determine action
	cmp	dl,15
	je	mforcemovetest2
	call	_resetmouse
	cmp	dl,0
	je	_do_onlinehelp
	cmp	dl,1
	je	_do_help
	cmp	dl,2
	jne	m3?2
	push	eax
	call	_waitbuttonrelease
	jmp	_do_compare
m3?2:
	cmp	dl,3
	je	_do_choosefile
	cmp	dl,4
	jne	m5?2
	push	eax
	call	_waitbuttonrelease
	jmp	_do_prevfile
m5?2:
	cmp	dl,5
	jne	m6?2
	push	eax
	call	_waitbuttonrelease
	jmp	_do_nextfile
m6?2:
	cmp	dl,6
	jne	m7?2
	movzx	ebx,activewindow
	push	eax
	call	_waitbuttonrelease
	jmp	togglemode
m7?2:
	cmp	dl,7
	jne	m8?2
	push	eax
	call	_waitbuttonrelease
	jmp	_do_goto
m8?2:
	cmp	dl,8
	je	_do_search
	cmp	dl,9
	je	_do_replace
	cmp	dl,10
	jne	m11?2
	push	eax
	call	_waitbuttonrelease
	jmp	_do_findnext
m11?2:
	cmp	dl,11
	je	_do_choosevideomode
	cmp	dl,12
	je	_do_setup
	cmp	dl,13
	jne	m14?2
	movzx	ecx,hexmousescrollspeed
	shl	ecx,14
	push	ecx
	call	_delay
	call	_scrhexlineup
	call	_putscreen
	ret
m14?2:
	cmp	dl,14
	jne	m16?2
	movzx	ecx,hexmousescrollspeed
	shl	ecx,14
	push	ecx
	call	_delay
	call	_scrhexlinedown
	call	_putscreen
	ret

m16?2:
	cmp	dl,16
	jne	m17?2
	mov	ecx,16
m162lop:
	call	_scrhexlineup
	call	_sync
	call	_putscreen
	loop	m162lop
	ret
m17?2:
	cmp	dl,17
	jne	m18?2
	mov	ecx,16
m172lop:
	call	_scrhexlinedown
	call	_sync
	call	_putscreen
	loop	m172lop
	ret
m18?2:
	cmp	dl,18
	jne	m19?2
	mov	ecx,16
m182lop:
	call	_hexlineup
	call	_sync
	call	_putscreen
	loop	m182lop
	ret
m19?2:
	cmp	dl,19
	jne	m20?2
	mov	ecx,16
m192lop:
	call	_hexlinedown
	call	_sync
	call	_putscreen
	loop	m192lop
	ret
m20?2:
	cmp	dl,20
	je	_do_firstbyte
	cmp	dl,21
	je	_do_lastbyte
	ret

mforcemovetest2:				; force move-test
;	mov	v86r_ax,0bh
;	mov	al,33h
;	int	33h
;	movsx	edx,v86r_dx
        call    _readmouse
        movsx   edx,dx
	mov	cl,hexmousescrollspeed
	cmp	edx,0
	je	_ret
	jg	mdown2
	sar	edx,cl
	jz	_ret
	neg	edx
	mov	ecx,edx
muhlop:
	call	_scrhexlineup
	loop	muhlop
	call	_putscreen
	jmp	_ret
mdown2:
	sub	cl,1
	jna	mmaxspeed2
	shr	edx,cl
	jz	_ret
mmaxspeed2:
	mov	ecx,edx
mdhlop:
	call	_scrhexlinedown
	loop	mdhlop
	call	_putscreen
	jmp	_ret


IF	LOGGING
;
; Logs a string pointed to by str that ends with an endchar byte.
; Syntax: _log_string( ptr string, int endchar );
_log_string:
	pushad
	mov	edx,offset logfile
	call	_openfile
	jnc	_ls_opened
	call	_createfile
	jc	_ls_end
_ls_opened:
	mov	eax,0
	mov	ebx,2
	call	_lseekfile
	mov	ebx,[esp+4+4*8+0]
	mov	edx,[esp+4+4*8+4]
_ls_lop:
	cmp	byte ptr [edx],bl
	je	_ls_done
	mov	ecx,1
	call	_writefile
	inc	edx
	jmp	_ls_lop
_ls_done:
	call	_closefile
_ls_end:
	popad
	ret	4*2
ENDIF


;
; Draws the bottomrow with info on keys
; _drawbottomrow( ptr keyrowdata );
;	ptr = -1 => no override, check shiftkeys as usual
_drawbottomrow:
	pushad
        call    _getshiftkeys
        mov     bl,al
	movzx	eax,activewindow
	mov	esi,[esp+32+4]
	cmp	esi,-1
	jne	putbaroverride

	mov	ebp,KEY_F1
	movzx	eax,mode[eax]
	push	eax
        and     bl,0fh
        test    bl,3
	jz	__dbr_notshift
        or      bl,3
	mov	ebp,KEY_SHIFT_F1
__dbr_notshift:
        movzx   eax,bl
	push	eax
	test	eax,4
	jz	__dbr_notctrl
	mov	ebp,KEY_CTRL_F1
__dbr_notctrl:
	test	eax,8
	jz	__dbr_notalt
	mov	ebp,KEY_ALT_F1
__dbr_notalt:
	push	ebp
	call	_parsekeybar

	mov	esi,offset parsedkeybar
putbaroverride:
	mov     edi,numberofrows
	dec	edi
	shl	edi,4+(CELLSIZE/2)
	lea	edi,[edi*4+edi]
	add	edi,textscreenstart
	mov	dl,'1'
putbarlop:
	mov	ah,kbnumber_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,dl
	putcell
	inc	dl
	mov	ecx,6
	mov	ah,kbmsg_c
	shl	eax,(CELLSIZE-2)*4
putbarlop2:
	lodsb
	putcell
	loop	putbarlop2
	mov	ah,kbnumber_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	cmp	dl,'0'+10
	jb	putbarlop
	mov	al,'1'
	putcell
	dec	al
	putcell
	mov	ecx,6
	mov	ah,kbmsg_c
	shl	eax,(CELLSIZE-2)*4
putbarlop1:
	lodsb
	putcell
	loop	putbarlop1

	mov	eax,numberofrows
	dec	eax
	mov	ecx,1
	call	_updaterows

	popad
	ret	4


;
; Parses the keyconfig and outputs the short 6-letter names for the
; functions that are currently bound to the functionskeys.
; _parsekeybar(dword Mode, dword ShiftKeys, dword StartScancode);
;	StartScancode = the scancode for F1, Ctrl+F1 or Alt+F1 etc...
;	Mode = TextMode, HexMode, DumpMode etc
;	ShiftKeys = SHIFTKEY_CTRL etc
_parsekeybar:
	pushad
	mov	eax,[esp+32+1*4]
	mov	ah,al
	mov	edx,[esp+32+2*4]
	mov	al,dl
	mov	edx,[esp+32+3*4]
	mov	edi,offset parsedkeybar
	mov	ebp,10
__parsekeybar_lop:
	push	offset keys
	call	_getkeyfunction
	cmp	ebx,MAX_FUNCTION
	ja	__parsekeybar_nop
	cmp	ebx,-1
	jne	__parsekeybar_notnop
__parsekeybar_nop:
	mov	ebx,DO_NOP
__parsekeybar_notnop:
	mov	esi,functions[ebx*8+4]
	mov	ecx,6
	rep	movsb
	inc	ah			; next functionkey
	dec	ebp
	jnz	__parsekeybar_lop
	popad
	ret	3*4


;
; Out:	ECX = Number of rows available for data... (subtracts headlines etc)
_getnumdatarows:
	push	ebx
	movzx	ebx,activewindow
	mov     ecx,numberofrows
	cmp	numberofwindows,2
	jne	__getnumdatarows_notsplit
	shr	ecx,1
	sub	ecx,3
	cmp	mode[ebx],MODE_HEXMODE
	je	__getnumdatarows_hexmode
	inc	ecx		; no indexdigits
__getnumdatarows_hexmode:
	test	numberofrows,1
	jz	__getnumdatarows_end
	cmp	activewindow,0
	je	__getnumdatarows_end
	inc	ecx
	jmp	__getnumdatarows_end

__getnumdatarows_notsplit:
	sub	ecx,4		; headline+statusrow+indexdigits+keybar
	cmp	mode[ebx],MODE_HEXMODE
	je	__getnumdatarows_end
	inc	ecx		; no indexdigits
__getnumdatarows_end:
	pop	ebx
	ret


;
_choosefile:
	push	tempdw
	pushad
	mov	tempdw,0		; tempdw = first file in list (0=first)
	movzx	ecx,activewindow
	movzx	ebx,activefile[ecx]
	cmp	ebx,numberoffiles
	jb	okk2
        xor     ebx,ebx
okk2:
	add	tempdw,12
	sub	ebx,12
	jnc	okk2
	add	ebx,12
	sub	tempdw,12
	inc	ebx			; default must not be zero!
	mov	choosefilestr[4],bl


putthemenu:
	mov	eax,numberoffiles
	add	eax,2			; +1 for platehead and +1 for bottom
	cmp	tempdw,0
	je	noprevfiles
	sub	eax,tempdw
	add	eax,2
	cmp	eax,12+2+2
	ja	prevandmore
	mov	choosefilestr[1],al
	sub	eax,3
	mov	choosefilestr[2],al
	mov	choosefilestr[3],al
	dec	eax
	push	eax
	mov	ecx,eax
	mov	al,1
	mov	edi,offset chooseables
	rep	stosb
	mov	al,-1
	stosb
	mov	al,1
	stosb
	pop	eax

	push	eax
	mov	edi,offset hotkeys
	mov	ecx,eax
	cmp	ecx,10
	jbe	okay_3
	mov	ecx,10
okay_3:
	mov	ax,03b3bh		; 59 59 = F1
puthotkeys3:
	stosw
	add	ax,0101h
	loopd	puthotkeys3
	pop	eax
	push	eax
	cmp	eax,10
	jbe	okay3
	mov	ax,05e5eh		; 94 94 = ^F1
	stosw
	pop	eax
	push	eax
	cmp	eax,12
	jne	okay3
	mov	ax,05f5fh		; 95 95 = ^F2
	stosw
okay3:
	pop	eax
	push	eax
	mov	ecx,12
	sub	ecx,eax
	jecxz	gunnar2
	mov	ax,03b3bh
	rep	stosw
gunnar2:
	mov	ax,0194bh		; 49 77 = P & Cursleft
	stosw
	mov	ax,03b3bh
	stosw
	pop	eax

	push	eax
	inc	eax
	mov	edi,eax
	shl	edi,4
	lea	edi,[edi*4+edi]
	lea	esi,[eax*2+eax]
	sub	edi,esi
	add	edi,offset namestart
	mov	esi,offset prevmsg
	mov	ecx,37
	rep	movsb
	mov	al,0
	stosb
	pop	eax
	jmp	putfilenames

prevandmore:
	mov	choosefilestr[1],17
	mov	choosefilestr[2],15
	mov	choosefilestr[3],14
	sub	eax,4
	push	eax
	mov	ecx,12
	mov	al,1
	mov	edi,offset chooseables
	rep	stosb
	mov	al,-1
	stosb
	mov	al,1
	stosb
	stosb
	mov	al,0
	stosb
	pop	eax

	push	eax
	mov	edi,offset hotkeys
	mov	ecx,10
	mov	ax,03b3bh		; 59 59 = F1
puthotkeys4:
	stosw
	add	ax,0101h
	loopd	puthotkeys4
	mov	ax,05e5eh		; 94 94 = ^F1
	stosw
	mov	ax,05f5fh		; 95 95 = ^F2
	stosw
	mov	ax,0194bh		; 49 77 = P & Cursleft
	stosw
	mov	ax,0314dh		; 49 77 = N & CursRight
	stosw
	pop	eax

	push	eax
	mov	edi,offset prevwhenfull
	mov	esi,offset prevmsg
	mov	ecx,37
	rep	movsb
	mov	edi,offset nextwhenfull
	mov	esi,offset nextmsg
	mov	ecx,33
	rep	movsb
	pop	eax
	jmp	putfilenames




noprevfiles:
	cmp	eax,12+2
	ja	morefiles
	mov	choosefilestr[1],al
	dec	eax
	mov	choosefilestr[2],al
	dec	eax
	mov	choosefilestr[3],al
	push	eax
	mov	ecx,eax
	mov	edx,15
	sub	edx,ecx
	mov	al,1
	mov	edi,offset chooseables
	rep	stosb
	mov	ecx,edx
	mov	al,-1
	rep	stosb
	mov	al,0
	stosb
	pop	eax

	push	eax
	mov	edi,offset hotkeys
	mov	ecx,eax
	cmp	ecx,10
	jbe	okay_1
	mov	ecx,10
okay_1:
	mov	ax,03b3bh		; 59 59 = F1
puthotkeys1:
	stosw
	add	ax,0101h
	loopd	puthotkeys1
	pop	eax
	push	eax
	cmp	eax,10
	jbe	okay1
	mov	ax,05e5eh		; 94 94 = ^F1
	stosw
	pop	eax
	push	eax
	cmp	eax,12
	jne	okay1
	mov	ax,05f5fh		; 95 95 = ^F2
	stosw
okay1:
	pop	eax
	push	eax
	mov	ecx,14
	sub	ecx,eax
	mov	ax,03b3bh
	rep	stosw
	pop	eax

	push	eax
	mov	edi,eax
	shl	edi,4
	lea	edi,[edi*4+edi]
	lea	esi,[eax*2+eax]
	sub	edi,esi
	add	edi,offset namestart
	mov	al,0
	stosb
	stosb
	pop	eax
	jmp	putfilenames

morefiles:
	sub	eax,2
	mov	choosefilestr[1],16
	mov	choosefilestr[2],14
	mov	choosefilestr[3],13
	push	eax
	mov	ecx,12
	mov	al,1
	mov	edi,offset chooseables
	rep	stosb
	mov	al,-1
	stosb
	mov	al,1
	stosb
	pop	eax

	push	eax
	mov	edi,offset hotkeys
	mov	ecx,10
	mov	ax,03b3bh		; 59 59 = F1
puthotkeys2:
	stosw
	add	ax,0101h
	loopd	puthotkeys2
	mov	ax,05e5eh		; 94 94 = ^F1
	stosw
	mov	ax,05f5fh		; 95 95 = ^F2
	stosw
	mov	ax,0314dh		; 49 77 = N & CursRight
	stosw
	mov	ax,03b3bh
	stosw
	pop	eax

	push	eax
	mov	edi,offset prevwhenfull
	mov	esi,offset nextmsg
	mov	ecx,33
	rep	movsb
	mov	al,0
	stosb
	stosb
	pop	eax
	jmp	putfilenames



putfilenames:
	mov	ecx,eax
	mov	esi,tempdw
	shl	esi,7
	add	esi,offset filename
	mov	edi,offset namestart+4
	cmp	ecx,12
	jbe	preplopp1
	mov	ecx,12
	mov	eax,12
preplopp1:
	push	eax
plopp1:
	push	ecx
	push	esi
	mov	ecx,-1
gnulop1:
	inc	ecx
	lodsb
	or	al,al
	jnz	gnulop1
	pop	esi
	cmp	ecx,72
	jbe	noprobs3
	mov	edx,ecx
	sub	edx,72
	add	esi,edx
	sub	ecx,edx
noprobs3:
	mov	edx,72
	sub	edx,ecx
	rep	movsb
	mov	ecx,edx
	jecxz	fullrow
	add	esi,edx
	mov	al,' '
	rep	stosb
fullrow:
	add	edi,1+4
	add	esi,128-72
	pop	ecx
	loopd	plopp1
	sub	edi,4
	pop	eax
	push	eax
	cmp	numberoffiles,12
	je	nospaceputs
	cmp	tempdw,0
	jne	putspaces
	cmp	eax,12
	jb	nospaceputs
putspaces:
	mov	ecx,76
	mov	al,' '
	rep	stosb
nospaceputs:
	pop	eax

	mov	edi,offset namestart
	mov	dword ptr [edi],'  1F'
	add	edi,77
	cmp	eax,2
	jb	okpopitup
	mov	dword ptr [edi],'  2F'
	add	edi,77
	cmp	eax,3
	jb	okpopitup
	mov	dword ptr [edi],'  3F'
	add	edi,77
	cmp	eax,4
	jb	okpopitup
	mov	dword ptr [edi],'  4F'
	add	edi,77
	cmp	eax,5
	jb	okpopitup
	mov	dword ptr [edi],'  5F'
	add	edi,77
	cmp	eax,6
	jb	okpopitup
	mov	dword ptr [edi],'  6F'
	add	edi,77
	cmp	eax,7
	jb	okpopitup
	mov	dword ptr [edi],'  7F'
	add	edi,77
	cmp	eax,8
	jb	okpopitup
	mov	dword ptr [edi],'  8F'
	add	edi,77
	cmp	eax,9
	jb	okpopitup
	mov	dword ptr [edi],'  9F'
	add	edi,77
	cmp	eax,10
	jb	okpopitup
	mov	dword ptr [edi],' 01F'
	add	edi,77
	cmp	eax,11
	jb	okpopitup
	mov	dword ptr [edi],' 1F^'
	add	edi,77
	cmp	eax,12
	jb	okpopitup
	mov	dword ptr [edi],' 2F^'


okpopitup:
	mov	esi,offset choosefilestr
	call	_popupmenu
	call	_putbothscreens
	mov	choosefilestr[4],1
	cmp	dl,al
	jbe	gotananswer
	cmp	tempdw,0
	jne	prevcounts
	cmp	dl,15
	jne	notesc1
esc1:
	popad
	pop	tempdw
	xor	dl,dl
	ret
notesc1:
	add	tempdw,12
	jmp	putthemenu
prevcounts:
	cmp	dl,15
	je	esc1
	add	tempdw,12
	cmp	dl,14
	je	putthemenu
	sub	tempdw,24
	jmp	putthemenu

gotananswer:
	and	edx,0ffh
	add	tempdw,edx
	popad
	mov	edx,tempdw
	pop	tempdw
	ret


;
; In:	ECX = Number of lines to scroll up
_xlinesup:
	pushad
	mov	edi,plineoffset
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	shl	ebx,2
	cmp	textline[ebp*8+ebx],ecx
	jb	xluabovestart
	neg	ecx
	add	ecx,textline[ebp*8+ebx]
	jz	xluabovestart
	cmp	ecx,256
	jb	nostored
	mov	eax,ecx
	sub	eax,256 			; else we will use
	shr	eax,8				; lineoffset[1] instead of [0]
        shl     eax,2
        cmp     eax,MAX_LINEOFFSETS*4            ; 256th row. 2 for dwords
	jb	lessthan128000lines
        mov     eax,MAX_LINEOFFSETS*4-4
lessthan128000lines:
;	 mov	 esi,lineoffset[eax]
	mov	esi,[edi+eax]
	mov	screenoffset[ebp*8+ebx],esi
	mov	filebufferpos[ebp*8+ebx],esi
	shl	eax,8-2 			; eax=ecx/8*8
	add	eax,256
	mov	textline[ebp*8+ebx],eax
	sub	ecx,eax
	jz	_popad&ret
	call	_xlinesdown
	jmp	_popad&ret
nostored:
	mov	textline[ebp*8+ebx],0
	mov	screenoffset[ebp*8+ebx],0
	mov	filebufferpos[ebp*8+ebx],0
	call	_xlinesdown
	jmp	_popad&ret
xluabovestart:
	mov	textline[ebp*8+ebx],0
	mov	screenoffset[ebp*8+ebx],0
	mov	filebufferpos[ebp*8+ebx],0
	jmp	_popad&ret


;
_premoderoutines:
	pushad
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]

	cmp	mode[ebx],MODE_TEXTVIEW
	jne	__premoderoutines_nottv
	call	_pretextmoderoutine
	jmp	__premoderoutines_end

__premoderoutines_nottv:
	cmp	mode[ebx],MODE_CODEMODE
	jne	__premoderoutines_notcv
	shl	ebx,2
;	 mov	 eax,filebufferpos[ebp*8+ebx]
;	 mov	 screenoffset[ebp*8+ebx],eax
	call	_do_codeviewinit
	jmp	__premoderoutines_end

__premoderoutines_notcv:

__premoderoutines_end:
	popad
	ret


;
_pretextmoderoutine:
	pushad
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	shl	ebx,2
	mov	totaltextlines[ebp*8+ebx],-1
	mov	textline[ebp*8+ebx],0
	mov	eax,screenoffset[ebp*8+ebx]
	cmp	eax,0
	je	ptrhowmanylines
	mov	screenoffset[ebp*8+ebx],0
	mov	filebufferpos[ebp*8+ebx],0
xluonemore:
	mov	edx,screenoffset[ebp*8+ebx]
	mov	ecx,1
	mov	esi,textline[ebp*8+ebx]
	call	_xlinesdown
	cmp	esi,textline[ebp*8+ebx]
	je	ptrhowmanylines
	cmp	screenoffset[ebp*8+ebx],eax
	jb	xluonemore
	je	ptrhowmanylines
	mov	ecx,1
	call	_xlinesup

ptrhowmanylines:
	push	screenoffset[ebp*8+ebx]
	push	filebufferpos[ebp*8+ebx]
	push	textline[ebp*8+ebx]
	mov	textline[ebp*8+ebx],0
	mov	screenoffset[ebp*8+ebx],0
	mov	filebufferpos[ebp*8+ebx],0
	mov	ecx,2000000000			; we wanna get to the end! ;)
	mov	totaltextlines[ebp*8+ebx],-1
	call	_xlinesdown
	mov	eax,textline[ebp*8+ebx]
	mov	totaltextlines[ebp*8+ebx],eax
	pop	textline[ebp*8+ebx]
	pop	filebufferpos[ebp*8+ebx]
	pop	screenoffset[ebp*8+ebx]

	popad
	ret


;
; In:	ECX = Number of lines to scroll down
_xlinesdown:
	pushad
	push	temporary
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	shl	ebx,2
	mov	esi,filebufferptr[ebp*4]
	mov	edi,esi
	add	esi,screenoffset[ebp*8+ebx]
	add	edi,filesize[ebp*4]
	cmp	filesize[ebp*4],0
	jnz	flugh1
	pop	temporary
	jmp	_popad&ret
flugh1:
	dec	edi
	cmp	esi,edi
	jb	xldmorelines
	pop	temporary
	jmp	_popad&ret
xldmorelines:
	mov	temporary,0
	push	esi
	push	ecx
oneldlop:
	lodsb
	mov	ecx,linefeedtype
	shl	ecx,2
	mov	dh,byte ptr linefeed[ecx+3]
	shl	edx,8
	mov	dl,byte ptr linefeed[ecx+1]
	mov	dh,byte ptr linefeed[ecx+2]
	cmp	al,dl
	jne	oneldnolf
	cmp	byte ptr linefeed[ecx],1
	je	okonelinedown
	cmp	[esi],dh
	jne	oneldnolf
	inc	esi
	cmp	byte ptr linefeed[ecx],2
	je	okonelinedown
	push	edx
	ror	edx,8
	cmp	[esi+1],dh
	pop	edx
	jne	oneldnolf
	inc	esi
	jmp	okonelinedown
oneldnolf:
	cmp	al,9
	jne	oneldnotab
	push	ecx edx
	movzx	ecx,tabsize
	or	ecx,ecx
	jnz	__xlinesdown_cxok
	inc	ecx
__xlinesdown_cxok:
	mov	eax,temporary
	xor	edx,edx
	idiv	cx
	sub	cx,dx
	dec	ecx
	add	temporary,ecx
	pop	edx ecx
oneldnotab:
	inc	temporary
	cmp	temporary,80
	jb	oneldlop
	movzx	eax,activewindow
	cmp	wrap[ebp*2+eax],1
	je	okonelinedown
	cmp	temporary,maxcolumn
	jb	oneldlop
okonelinedown:
	pop	ecx
	pop	eax				; we pushed esi earlier...
	inc	textline[ebp*8+ebx]
	cmp	byte ptr textline[ebp*8+ebx],0
	jne	dontstoreoffset
	push	eax esi
	sub	esi,filebufferptr[ebp*4]
	mov	eax,textline[ebp*8+ebx]
	sub	eax,256
	shr	eax,8-2 			; 8 'cause we only want every
        cmp     eax,MAX_LINEOFFSETS*4           ; 256th row. 2 for dwords
	jae	WOWmorethan128000lines
	add	eax,plineoffset
;	 mov	 lineoffset[eax],esi
	mov	[eax],esi
WOWmorethan128000lines:
	pop	esi eax
dontstoreoffset:
	cmp	esi,edi
	ja	xldbelowend
	loopd	xldmorelines
	sub	esi,filebufferptr[ebp*4]	; cf set if above start
	mov	screenoffset[ebp*8+ebx],esi
	mov	filebufferpos[ebp*8+ebx],esi
	pop	temporary
	jmp	_popad&ret
xldbelowend:
	dec	textline[ebp*8+ebx]
	sub	eax,filebufferptr[ebp*4]
	mov	screenoffset[ebp*8+ebx],eax
	mov	filebufferpos[ebp*8+ebx],eax
	pop	temporary
	popad
	ret


;
; _menu(dword offset MenuStructure);	(The new, extended one)
; Out:	EDX = Item# selected ( 0 == Escape was pressed )
;	MenuBuffers are filled with new info
; Does NOT redraw screen, you must do that manually afterwards!
MenuWidth		equ	byte ptr [esi]
MenuHeight		equ	byte ptr [esi+1]
MenuX			equ	byte ptr [esi+2]
MenuY			equ	byte ptr [esi+3]
MenuDefault		equ	dword ptr [esi+4]
MenuBkgChar		equ	byte ptr [esi+8]
MenuBkgAttribPtr	equ	dword ptr [esi+9]
MenuFrame		equ	byte ptr [esi+13]
MenuFrameAttribPtr	equ	dword ptr [esi+14]
MenuFramePtr		equ	dword ptr [esi+18]
MenuKeyBarPtr		equ	dword ptr [esi+22]
MenuCtrlKeyBarPtr	equ	dword ptr [esi+26]
MenuAltKeyBarPtr	equ	dword ptr [esi+30]
MenuSpecial1		equ	dword ptr [esi+34]
MenuSpecial2		equ	dword ptr [esi+38]
MenuSpecial3		equ	dword ptr [esi+42]
MenuSpecial4		equ	dword ptr [esi+46]
MenuSpecial5		equ	dword ptr [esi+50]
MenuHeadlineAttribPtr	equ	dword ptr [esi+66]
MenuBottomlineAttribPtr equ	dword ptr [esi+70]
MenuHeadline		equ	[esi+74]
_menu:
	pushad
	call	_hidecursor
	mov	esi,[esp+32+4]
;
; Let's find out how big the window is
	movsx	edx,MenuWidth
	cmp	edx,-1
	jne	mdontcalcx
	lea	edi,MenuHeadline
	mov	ecx,-1
	xor	al,al
	repne	scasb
	neg	ecx
	mov	edx,ecx
	mov	ecx,-1
	repne	scasb
	neg	ecx
	cmp	ecx,edx
	jbe	mcalcxl1
	mov	edx,ecx
mcalcxl1:
	cmp	dword ptr [edi],0
	je	mdontcalcx		; no more fields
	mov	ebx,dword ptr [edi]
	add	edi,4*2+4
	xor	al,al
	mov	ecx,-1
	repne	scasb
	neg	ecx
	add	ebx,ecx
	mov	ecx,-1
	repne	scasb			; search past helptext
	repne	scasb			; search past scancodes
	movsx	eax,byte ptr [edi+5]	; width of inputfield
	add	ebx,eax
	cmp	ebx,edx
	jbe	mcalcxl2
	mov	edx,ebx
mcalcxl2:
	add	edi,6			; skip type, width of input & colorptr
	movzx	ecx,word ptr [edi]
	add	edi,4+1+2*4		; +1 for trailing zero
	add	edi,ecx
	jmp	mcalcxl1

mdontcalcx:
	mov	mwidth,edx
	movsx	edx,MenuHeight
	cmp	edx,-1
	jne	mdontcalcy
	lea	edi,MenuHeadline
	mov	ecx,-1
	xor	al,al
	repne	scasb
	repne	scasb
	xor	edx,edx
	cmp	dword ptr [edi],0
	je	mynofields
mcalcyl1:
	mov	ebx,dword ptr [edi+4]
	cmp	ebx,edx
	jbe	mcalcyl2
	mov	edx,ebx
mcalcyl2:
	add	edi,4*2+4
	mov	ecx,-1
	repne	scasb			; skip ItemText
	repne	scasb			; search past helptext
	repne	scasb			; skip Scancodes
	add	edi,6			; skip type, width of input & colorptr
	movzx	ecx,word ptr [edi]
	add	edi,4+1+2*4		; +1 for trailing zero
	add	edi,ecx
	cmp	dword ptr [edi],0
	jne	mcalcyl1		; ok, check next field
mynofields:
	add	edx,2

mdontcalcy:
	mov	mheight,edx
;
; Where shall I put the window?
	movsx	edx,MenuX
	cmp	edx,-1
	jg	mforcedx
	jl	mxcenter
	call	_getcursorpos
	and	edx,0ffh		; cursorX in DL
	jmp	mforcedx
mxcenter:
	mov	edx,mwidth
	shr	edx,1
	neg	edx
	add	edx,40

mforcedx:
	mov	mx,edx
	movsx	edx,MenuY
	cmp	edx,-1
	jg	mforcedy
	jl	mycenter
	call	_getcursorpos
	movzx	edx,dh			; cursorY in DH
	jmp	mforcedy
mycenter:
	cmp	edx,-2
	jl	mycenterscreen
	mov	edx,mheight
	shr	edx,1
	neg	edx
	mov	eax,numberofrows
	cmp	numberofwindows,2
	jb	mywin1
	shr	eax,1
	cmp	activewindow,1
	jne	mywin1
	add	edx,eax
mywin1:
	shr	eax,1
	add	edx,eax
	mov	eax,edx
	add	eax,mheight
	cmp	eax,numberofrows
	jbe	mywin_checkneg
	mov	edx,numberofrows
	dec	edx
	sub	edx,mheight
mywin_checkneg:
	or	edx,edx
	jns	mforcedy
	xor	edx,edx
	jmp	mforcedy
mycenterscreen:
	mov	edx,mheight
	shr	edx,1
	neg	edx
	mov	eax,numberofrows
	shr	eax,1
	add	edx,eax
	jmp	mforcedy

mforcedy:
	mov	my,edx
;
; Draw the window
	mov	edi,my			; calc screenaddress
	shl	edi,4;+(CELLSIZE/2)
	lea	edi,[edi*4+edi]
	add	edi,mx
;	add	edi,mx
	shl	edi,CELLSIZE/2
	add	edi,textscreenstart
	mov	eax,MenuFrameAttribPtr
	mov	ah,[eax]
	shl	eax,(CELLSIZE-2)*4
	mov	al,MenuFrame
	cmp	al,1
	jne	mframe2
	lea	esi,frame1data
	jmp	mdrawgenframe
mframe2:
	cmp	al,2
	jne	mframe3
	lea	esi,frame2data
	jmp	mdrawgenframe
mframe3:
	cmp	al,3
	jne	mframe4
	lea	esi,frame3data
	jmp	mdrawgenframe
mframe4:
	cmp	al,4
	jne	mframe5
	lea	esi,frame4data
	jmp	mdrawgenframe
mframe5:
	cmp	al,5
	jne	mframe6
	lea	esi,frame5data
	jmp	mdrawgenframe
mframe6:
	cmp	al,6
	jne	mframe7
	lea	esi,frame6data
	jmp	mdrawgenframe
mframe7:
	cmp	al,7
	jne	mframe8
	lea	esi,frame7data
	jmp	mdrawgenframe
mframe8:
	cmp	al,8
	jne	mframe9
	lea	esi,frame8data
	jmp	mdrawgenframe
mframe9:
	cmp	al,9
	jne	mframe10
	lea	esi,frame9data
	jmp	mdrawgenframe
mframe10:
	cmp	al,10
	jne	mframe11
	lea	esi,frame10data
	jmp	mdrawgenframe
mframe11:
	cmp	al,11
	jne	mframe12
	lea	esi,frame11data
	jmp	mdrawgenframe
mframe12:
	cmp	al,12
	jne	mframe13
	lea	esi,frame12data
	jmp	mdrawgenframe
mframe13:
	cmp	al,13
	jne	mframe14
	lea	esi,frame13data
	jmp	mdrawgenframe
mframe14:
	lea	esi,frame1data		; choose this if nothing else matches
	cmp	al,14
	jne	mdrawgenframe

mdrawgenframe:
	mov	ecx,mwidth
	lodsb
	putcell
	sub	ecx,2
	push	ecx esi edi
	mov	esi,[esp+32+4+4*3]
	lea	edi,MenuHeadline
	xor	al,al
	mov	ecx,-1
	repne	scasb
	neg	ecx
	sub	ecx,2
	mov	edx,ecx
	pop	edi esi ecx
	sub	ecx,edx
	mov	ebx,ecx
	shr	ecx,1
	sub	ebx,ecx
	mov	al,byte ptr [esi]
	jecxz	mdgfm1
	rep
	putcell
mdgfm1:
	mov	ecx,edx
	jecxz	mdgfm2
	push	eax esi
	mov	esi,[esp+32+4+4*2]
	mov	eax,MenuHeadlineAttribPtr
	mov	ah,[eax]
	shl	eax,(CELLSIZE-2)*4
	lea	esi,MenuHeadline
mdgflop2:
	lodsb
	putcell
	loop	mdgflop2
	pop	esi eax
mdgfm2:
	mov	ecx,ebx
	lodsb
	jecxz	mdgfm3
	rep
	putcell
mdgfm3:
	lodsb
	putcell
	mov	ecx,mheight
	add	esi,2
	sub	ecx,2
	jle	mdgfdonesides
	sub	esi,2

	mov	edx,mwidth
	shl	edx,CELLSIZE/2

mdgflop1:
	add	edi,80*CELLSIZE
	sub	edi,edx
	lodsb
	putcell
	lea	edi,[edi+edx-2*CELLSIZE]
	lodsb
	putcell
	sub	esi,2
	loop	mdgflop1
	add	esi,2
	add	edi,80*CELLSIZE
	sub	edi,edx
mdgfdonesides:
	mov	ecx,mwidth
	lodsb
	putcell
	sub	ecx,2
	push	ecx esi edi
	mov	esi,[esp+32+4+4*3]
	lea	edi,MenuHeadline
	xor	al,al
	mov	ecx,-1
	repne	scasb
	mov	ecx,-1
	repne	scasb
	neg	ecx
	sub	ecx,2
	mov	edx,ecx
	pop	edi esi ecx
	sub	ecx,edx
	mov	ebx,ecx
	shr	ecx,1
	sub	ebx,ecx
	mov	al,byte ptr [esi]
	jecxz	mdgfm4
	rep
	putcell
mdgfm4:
	mov	ecx,edx
	jecxz	mdgfm5
	push	eax esi edi ecx
	mov	esi,[esp+32+4+4*4]
	mov	eax,MenuBottomlineAttribPtr
	mov	ah,[eax]
	shl	eax,(CELLSIZE-2)*4
	lea	edi,MenuHeadline
	mov	ecx,-1
	xor	al,al
	repne	scasb
	mov	esi,edi
	pop	ecx edi
mdgflop3:
	lodsb
	putcell
	loop	mdgflop3
	pop	esi eax
mdgfm5:
	mov	ecx,ebx
	lodsb
	jecxz	mdgfm6
	rep
	putcell
mdgfm6:
	lodsb
	putcell
;
; Draw the menubkg
	mov	esi,[esp+32+4]
	mov	edi,my			; calc screenaddress
	shl	edi,4+(CELLSIZE/2)
	lea	edi,[edi*4+edi]
	add	edi,textscreenstart
	mov	eax,mx
	lea	edi,[edi+eax*CELLSIZE]
	mov	mscreenpos,edi
	add	edi,1*CELLSIZE
	mov	edx,mheight
	sub	edx,2
	jle	mdtmdone
	mov	eax,MenuBkgAttribPtr
	mov	ah,[eax]
	shl	eax,(CELLSIZE-2)*4
	mov	al,MenuBkgChar
mdtmlop:
	add	edi,80*CELLSIZE
	mov	ecx,mwidth
	sub	ecx,2
	lea	ebx,[ecx*CELLSIZE]
	rep
	putcell
	sub	edi,ebx
	dec	edx
	jnz	mdtmlop
mdtmdone:
;
; Draw all the Items
	mov	esi,[esp+32+4]
	lea	edi,scancode		;  (used in scancodetable)
	mov	ecx,256 		; Zerofill scancodetable
	xor	eax,eax
	rep	stosd
	push	0
	push	-1
	push	0
	call	_menudrawitem		; draw all items

;
; Lets start checking keypresses and such
	mov	esi,[esp+32+4]
	mov	ebp,MenuDefault 	; ebp == Current Item#
	mov	keyfromedit,0

mgknewitem:
	push	ebp
	call	_menugetiteminfo
	mov	itemtype,eax		; store itemtype for future reference
	mov	itemxpos,ebx
	mov	itemypos,ecx
	push	ebp
	push	-1
	push	0
	call	_menudrawitem		; draw current item

	cmp	keyfromedit,0
	jnz	mgkkfenz

	cmp	itemtype,ITEM_SSTRING
	je	menueditstring
	cmp	itemtype,ITEM_SNUMBER
	je	menueditnumber
	cmp	itemtype,ITEM_SCHK
	je	menueditchk
	cmp	itemtype,ITEM_SHEXSTRING
	je	menuedithexstring

	call	_menugetkey
	jmp	mgkcheckcurs

mgkkfenz:
	mov	ah,keyfromedit
	mov	keyfromedit,0

mgkcheckcurs:
	cmp	ah,72			; CursUp
	jne	mgknotup
	push	ebp
	push	1
	call	_menutestdir
	or	eax,eax
	jz	mgknewitem
	mov	ebp,eax
	jmp	mgknewitem
mgknotup:

	cmp	ah,80			; CursDown
	jne	mgknotdown
	push	ebp
	push	2
	call	_menutestdir
	or	eax,eax
	jz	mgknewitem
	mov	ebp,eax
	jmp	mgknewitem
mgknotdown:

	cmp	ah,75			; CursLeft
	jne	mgknotleft
	push	ebp
	push	3
	call	_menutestdir
	or	eax,eax
	jz	mgknewitem
	mov	ebp,eax
	jmp	mgknewitem
mgknotleft:

	cmp	ah,77			; CursRight
	jne	mgknotright
	push	ebp
	push	4
	call	_menutestdir
	or	eax,eax
	jz	mgknewitem
	mov	ebp,eax
	jmp	mgknewitem
mgknotright:

;	 cmp	 ah,15			 ; Tab
;	 jne	 mgknottab
;	 mov	 eax,ebp
;	 test	 shiftstatus,3
;	 jnz	 mgkshifttab
;	 inc	 eax
;	 push	 eax
;	 call	 _menugetiteminfo
;	 cmp	 eax,3
;	 jb	 mgknewitem
;	 inc	 ebp
;	 jmp	 mgknewitem
;mgkshifttab:
;	 dec	 eax
;	 push	 eax
;	 call	 _menugetiteminfo
;	 cmp	 eax,3
;	 jb	 mgknewitem
;	 dec	 ebp
;	 jmp	 mgknewitem
;mgknottab:

	jmp	mgknewitem


;
; Main-routine for getting keypresses and such, called from MGK, MEN and MES
; In:	EBP = Current itemnumber
; Out:	AH = ScanCode
;	AL = Character
_menugetkey:
	pushad

	mov	eax,my
	mov	ecx,mheight
	call	_updaterows

	mov	esi,[esp+32+4+32+4]	; esi -> start of menu
	mov	mgkfirstlop,1
menugetkeylop1:
	cmp	MenuSpecial1,-1
	je	mgknospecial1
	cmp	MenuSpecial1,1
	jne	mgks1not1
	pushad
	mov	eax,exeheader08
	add	eax,exeheader16
	shl	eax,4
	add	eax,exeheader14
	mov	exeheaderprogramstart,eax
	movzx	eax,insert
	push	eax
	push	ebp
	call	_menugetiteminfo
	cmp	eax,7
	jne	mgkspec1notnumber
	mov	insert,42 ; spec
mgkspec1notnumber:
	push	itemtype
	mov	itemtype,8
	push	3
	push	-2
	push	0
	call	_menudrawitem		; draw all items
	pop	itemtype
	pop	eax
	mov	insert,al
	popad
	jmp	mgknospecial1
mgks1not1:
	cmp	MenuSpecial1,2
	jne	mgks1not2
@@lop:
	call	_getkey
	jc	@@lop
	cmp	al,0
	je	@@lop
;	mov	al,v86r_al
;	mov	getkeymenubuffer[0],al
	mov	getkeymenubuffer[0],bl
	mov	getkeymenubuffer[1],ah
	jmp	menuexit
mgks1not2:
	cmp	MenuSpecial1,4
	jne	mgks1not4
	cmp	mgk1s_4_dirty,0
	je	mgknospecial1
	cmp	ebp,MenuSpecial2
	je	mgks1_4_first
	cmp	ebp,MenuSpecial4
	je	mgks1_4_first2
	cmp	ebp,MenuSpecial5
	je	mgks1_4_last2
	cmp	ebp,MenuSpecial3
	jne	mgknospecial1
	mov	eax,MenuSpecial2
	mov	ebx,MenuSpecial3
	mov	MenuSpecial2,ebx
	mov	MenuSpecial3,eax
mgks1_4_first:
	push	itemtype
	push	esi
	push	MenuSpecial2
	call	_menugetiteminfo
	mov	edi,itembufptr
	movzx	edx,word ptr [edi-2]
	push	MenuSpecial3
	call	_menugetiteminfo
	mov	itemtype,eax
	mov	esi,edi
	mov	edi,itembufptr
	mov	word ptr [edi-2],dx
	mov	ecx,edx
	rep	movsb
	mov	byte ptr [edi],0
	pop	esi
	push	MenuSpecial3
	push	-2
	push	0
	call	_menudrawitem
	pop	itemtype
	mov	mgk1s_4_dirty,0
;	mov	v86r_ax,0
        mov     mgkretval,0
	jmp	mgknotenter
mgks1_4_last2:
	mov	eax,MenuSpecial4
	mov	ebx,MenuSpecial5
	mov	MenuSpecial4,ebx
	mov	MenuSpecial5,eax
mgks1_4_first2:
	push	itemtype
	push	esi
	push	MenuSpecial4
	call	_menugetiteminfo
	mov	edi,itembufptr
	movzx	edx,word ptr [edi-2]
	push	MenuSpecial5
	call	_menugetiteminfo
	mov	itemtype,eax
	mov	esi,edi
	mov	edi,itembufptr
	mov	word ptr [edi-2],dx
	mov	ecx,edx
	rep	movsb
	mov	byte ptr [edi],0
	pop	esi
	push	MenuSpecial5
	push	-2
	push	0
	call	_menudrawitem
	pop	itemtype
	mov	mgk1s_4_dirty,0
        mov     mgkretval,0
	jmp	mgknotenter
mgks1not4:

mgknospecial1:
        call    _getshiftkeys
	mov	shiftstatus,al
        test    al,4
	jz	mgknotctrl
	push	MenuCtrlKeyBarPtr
	call	_drawbottomrow
	jmp	mgklop2
mgknotctrl:
        test    al,8
	jz	mgknotalt
	push	MenuAltKeyBarPtr
	call	_drawbottomrow
	jmp	mgklop2
mgknotalt:
	push	MenuKeyBarPtr
	call	_drawbottomrow
mgklop2:
	call	_slice

IFDEF	MSDOS			; not sure why anymore
	cmp	mgkfirstlop,1
	je	mgkfl
ENDIF
	cmp	MenuSpecial1,5
	jne	mgks1not5
	mov	edx,ebp
	jmp	menuexit
mgks1not5:
mgkfl:

	mov	mgkfirstlop,0
IFDEF	MSDOS
	call	_checkkey
	jz	menugetkeylop1
ENDIF

	mov	mgk1s_4_dirty,1

	call	_getkey
        mov     mgkretval,ax

	xor	edx,edx
        cmp     ah,1                    ; Escape exits
	je	menuexit

	cmp	MenuSpecial1,3		; are we inside the keysetup?
	jne	mgkms1not3
	mov	definedkeysdelpressed,0
        cmp     ah,KEY_DEL
	jne	mgkms1not3
	mov	definedkeysdelpressed,-1
	mov	edx,ebp
	jmp	menuexit
mgkms1not3:

        movzx   eax,ah                  ; Test if key is a defined scancode
	mov	edx,scancode[eax*4]
	cmp	edx,0
	je	mgksczero
	push	eax ebx ecx
	push	edx
	call	_menugetiteminfo
	test	eax,1
	pop	ecx ebx eax
	jnz	menuexit		; Yes it is -> exit with edx == item#
mgksczero:

        cmp     mgk_ah,28               ; <Enter>
	jne	mgknotenter
	cmp	MenuSpecial1,6
	jne	mgkms1not6
	pushad
	lea	esi,calcitmenuxpr
	movzx	ecx,calcitmenulen
	call	_getxpr

	push	eax
	lea	edi,getxprerrors
	jnc	@@puterrmsg
	mov	ecx,getxprerr
	jecxz	@@puterrmsg
	xor	al,al
@@errlop:
	cmp	byte ptr [edi],0
	je	@@genericerr
	push	ecx
	mov	ecx,-1
	repne	scasb
	pop	ecx
	loop	@@errlop
@@puterrmsg:
	mov	esi,edi
	lea	edi,calcitmenuerr
@@puterrlop:
	lodsb
	stosb
	or	al,al
	jnz	@@puterrlop
	jmp	@@errdone
@@genericerr:
	lea	edi,getxprerrors_generic
	jmp	@@puterrmsg
@@errdone:
	pop	eax

	mov	calcitmenuhex,eax
	mov	calcitmenuoct,eax
	mov	calcitmenubin,eax
	mov	ebx,eax
	mov	calcitmenudecsign,2	; sign unknown
	or	eax,eax
	jge	mgkms16p
	mov	calcitmenudecsign,0	; negative
	neg	eax
mgkms16p:
	mov	calcitmenudec,eax
	rol	bx,8
	rol	ebx,16
	rol	bx,8
	mov	calcitmenuasc,ebx
	mov	calcitmenuasclen,4

	popad
	push	itemtype
	mov	itemtype,ITEM_SSTRING
	push	0
	push	-1
	push	0
	call	_menudrawitem		; draw all items
	pop	itemtype
        mov     mgkretval,0
	jmp	mgknotenter
mgkms1not6:
	mov	edx,ebp
	jmp	menuexit

mgknotenter:
	popad
        mov     ax,mgkretval
	ret

menuexit:
	mov	itemnumber,ebp
	mov	[esp+4*5],edx
	popad
	add	esp,4			; remove pushed eip
	mov	[esp+4*5],edx
	popad
	ret	4


;
menueditnumber:
	mov	meneraseold,1

	mov	edx,1			; Itemnumber being drawn
	lea	edi,MenuHeadline
	mov	ecx,-1
	xor	eax,eax
	repne	scasb
	repne	scasb
menlop0:
	cmp	dword ptr [edi],0
	je	mgknewitem		; This should NOT be able to happen!
	add	edi,2*4+4
	xor	al,al
	mov	ecx,-1
	repne	scasb
	repne	scasb
	repne	scasb
	add	edi,6
	cmp	edx,ebp
	je	menfound
	movzx	eax,word ptr [edi]
	add	edi,eax
	add	edi,4+1+2*4		; dword + 1 for buffers trailing zero
	inc	edx
	jmp	menlop0
menfound:				; edi -> Maximum length of inputstring
	movzx	eax,byte ptr [edi-1]
	mov	menfieldwidth,eax
	movzx	eax,word ptr [edi]
	mov	menmaxlength,eax
	add	edi,4
	mov	eax,[edi]		; get number
	mov	menorigvalue,eax
	mov	menvalue,eax
	mov	menvalueptr,edi
	add	edi,menmaxlength
	inc	edi
	mov	eax,[edi]
	mov	menmaxvalue,eax
	add	edi,4
	movzx	eax,word ptr [edi+2]
	cmp	eax,0
	jne	menbasenotzero
	movzx	eax,defaultbase
menbasenotzero:
	mov	menbase,eax
	movzx	eax,word ptr [edi]
	mov	menorigsign,eax
	mov	mensign,eax
	mov	mensignptr,edi

	mov	menbufferpos,0

	cmp	menbase,1
	je	mendmainlop
	cmp	menbase,2
	je	menhmainlop
	jmp	mgknewitem

mendmainlop:
	mov	esi,[esp+8*4+4]
	movzx	eax,insert
	push	eax
	mov	insert,42	; spec
	push	ebp
	mov	eax,menfieldwidth
	sub	eax,menbufferpos
	push	eax
	push	0
	mov	eax,menvalue
	mov	edi,menvalueptr
	mov	[edi],eax
	mov	eax,mensign
	mov	edi,mensignptr
	mov	[edi],ax
	call	_menudrawitem
	pop	eax
	mov	insert,al
;	 call	 _setinsertcursor
	call	_setnummenufieldcursor

	call	_menugetkey
	cmp	ah,28			; Enter
	je	menenter
	cmp	ah,1			; Escape
	je	menesc
	cmp	ah,14			; BackSpace
	je	menbs
	cmp	ah,83			; Delete
	je	menbs
	cmp	ah,75			; CursLeft
	je	menleft
	cmp	ah,77			; CursRight
	je	menright
	cmp	ah,72			; CursUp
	je	menup
	cmp	ah,71			; Home
	je	menhome
	cmp	ah,80			; CursDown
	je	mendown
	cmp	ah,79			; End
	je	menend
	cmp	ah,148			; Ctrl+Tab
	je	menctrltab
	cmp	ah,15			; Tab
	je	mendtab

	cmp	mensign,3
	je	mendnotminusorplus
	cmp	al,'-'
	je	mendminusorplus
	cmp	al,'+'
	jne	mendnotminusorplus
mendminusorplus:
	cmp	meneraseold,1
	jne	mendonteraseold3
	mov	menvalue,0
	mov	meneraseold,0
	cmp	mensign,3
	je	mendonteraseold3
	mov	mensign,2
mendonteraseold3:
	push	eax
	mov	eax,1
	mov	ecx,menbufferpos
	jecxz	men3endlop
	mov	ebx,10
men3lop:
	mul	ebx
	jo	mendoverflow
	dec	ecx
	jnz	men3lop
	jmp	men3endlop
mendoverflow:
	pop	eax
	jmp	mendforcesign
men3endlop:
	cmp	menvalue,eax
	pop	eax
	ja	mendmainlop
mendforcesign:
	mov	mensign,0
	cmp	al,'-'
	je	mendmainlop
	mov	mensign,1
	jmp	mendmainlop
mendnotminusorplus:
	cmp	al,'0'
	jb	mendmainlop
	cmp	al,'9'
	ja	mendmainlop

	cmp	meneraseold,1
	jne	mendonteraseold
	mov	menvalue,0
	mov	meneraseold,0
	cmp	mensign,3
	je	mendonteraseold
	mov	mensign,2
mendonteraseold:

	movzx	edi,al
	sub	edi,'0'
	mov	eax,1
	mov	ecx,menbufferpos
	jecxz	men1endlop
	mov	ebx,10
men1lop:
	mul	ebx
	jo	mendmainlop
	dec	ecx
	jnz	men1lop
men1endlop:
	mov	ebx,eax
	mov	eax,menvalue
	xor	edx,edx
	div	ebx
	mov	esi,edx
	mov	ecx,10
	mul	ecx
	jo	mendmainlop
	add	eax,edi
	jc	mendmainlop
	mul	ebx
	or	edx,edx
	jnz	mendmainlop
	add	eax,esi
	jc	mendmainlop
	cmp	menmaxvalue,0
	je	menanyvalueallowed
	cmp	eax,menmaxvalue
	ja	mendmainlop
menanyvalueallowed:
	mov	menvalue,eax
	jmp	mendmainlop

menup:
	mov	keyfromedit,ah
	push	ebp
	push	1
	call	_menutestdir
	or	eax,eax
	jz	mendmainlop
	jmp	mgknewitem

menhome:
	mov	eax,1
	mov	ecx,menbufferpos
	jecxz	menupendlop
	mov	ebx,10
menuplop:
	mul	ebx
	dec	ecx
	jnz	menuplop
menupendlop:
	cmp	eax,menvalue
	jg	mendmainlop
	inc	menbufferpos
	cmp	menbufferpos,10
	jae	mendmainlop
	jmp	menhome

mendown:
	mov	keyfromedit,ah
	push	ebp
	push	2
	call	_menutestdir
	or	eax,eax
	jz	mendmainlop
	jmp	mgknewitem

menend:
	mov	menbufferpos,0
	jmp	mendmainlop

menleft:
	mov	meneraseold,0
	mov	eax,1
	mov	ecx,menbufferpos
	jecxz	menleftendlop
	mov	ebx,10
menleftlop:
	mul	ebx
	jc	mendmainlop
	dec	ecx
	jnz	menleftlop
menleftendlop:
	cmp	eax,menvalue
	ja	mendmainlop
	inc	menbufferpos
	jmp	mendmainlop

menright:
	mov	meneraseold,0
	cmp	menbufferpos,0
	je	mendmainlop
	dec	menbufferpos
	jmp	mendmainlop

menbs:
	cmp	meneraseold,1
	jne	mendonteraseold2
	mov	menvalue,0
	mov	meneraseold,0
	cmp	mensign,3
	je	mendmainlop
	mov	mensign,2
	jmp	mendmainlop
mendonteraseold2:
	mov	ecx,menbufferpos
	mov	mentemp,ah
	cmp	ah,83
	je	menbsdel
	inc	ecx
menbsdel:
	mov	eax,1
	jecxz	men2endlop
	mov	ebx,10
men2lop:
	mul	ebx
	jo	mendforcesignkill?
	dec	ecx
	jnz	men2lop
men2endlop:
	cmp	menvalue,eax
	jae	men2nosignkill
mendforcesignkill?:
	cmp	mensign,0
	je	mendforcesignkill
	cmp	mensign,1
	je	mendforcesignkill
	cmp	mentemp,83
	je	mendbsdelgnu
	cmp	menbufferpos,0
	jne	mendmainlop
	mov	menvalue,0
	jmp	mendmainlop
mendbsdelgnu:
	cmp	menbufferpos,0
	je	mendmainlop
	dec	menbufferpos
	mov	ah,83
	jmp	menbs
mendforcesignkill:
	cmp	mensign,3
	je	mendmainlop
	mov	mensign,2
	jmp	mendmainlop
men2nosignkill:
	mov	ebx,eax
	mov	eax,menvalue
	xor	edx,edx
	div	ebx
	mov	esi,edx
	xor	edx,edx
	mov	ecx,10
	div	ecx
	mul	ebx
	add	eax,esi
	cmp	menvalue,eax
	jne	mendmovit
	xor	eax,eax
mendmovit:
	mov	menvalue,eax
	jmp	mendmainlop

menesc:
	mov	keyfromedit,ah
	mov	eax,menorigvalue
	mov	edi,menvalueptr
	mov	[edi],eax
	mov	eax,menorigsign
	mov	edi,mensignptr
	mov	[edi],ax
	jmp	mgknewitem

menenter:
	mov	keyfromedit,ah
	jmp	mgknewitem

menctrltab:
	mov	menbufferpos,0
	neg	menbase 		; only works dec <-> hex
	add	menbase,3
	mov	edi,mensignptr
	mov	eax,menbase
	mov	[edi+2],ax
	cmp	byte ptr [edi+2],1
	je	mendmainlop
	cmp	byte ptr [edi+2],2
	je	menhmainlop
	cmp	defaultbase,1
	je	mendmainlop
	cmp	defaultbase,2
	je	menhmainlop
	jmp	menhmainlop

mendtab:
	call	_menutab
	jc	mendmainlop
	jmp	mgknewitem

;------------------------------------
_menutab:
	pushad
	mov	keyfromedit,0
	push	ebp
	call	_menugetiteminfo
	test	eax,eax
	jz	popad&stc&ret
	mov	itemtype,eax		; store itemtype for future reference
	mov	itemxpos,ebx
	mov	itemypos,ecx
	test	shiftstatus,3
	jnz	@@shift
	push	ebp
	push	4
	call	_menutestdir
	or	eax,eax
	jz	@@down
	mov	[esp+2*4],eax
	jmp	popad&clc&ret
@@down:
	push	ebp
	push	2
	call	_menutestdir
	or	eax,eax
	jz	popad&stc&ret
@@downleft:
	mov	ebp,eax
	push	ebp
	call	_menugetiteminfo
	mov	itemtype,eax		; store itemtype for future reference
	mov	itemxpos,ebx
	mov	itemypos,ecx
	push	ebp
	push	3
	call	_menutestdir
	mov	[esp+2*4],ebp
	or	eax,eax
	jz	popad&clc&ret
	jmp	@@downleft

@@shift:
	push	ebp
	push	3
	call	_menutestdir
	or	eax,eax
	jz	@@up
	mov	[esp+2*4],eax
	jmp	popad&clc&ret
@@up:
	push	ebp
	push	1
	call	_menutestdir
	or	eax,eax
	jz	popad&stc&ret
@@upright:
	mov	ebp,eax
	push	ebp
	call	_menugetiteminfo
	mov	itemtype,eax		; store itemtype for future reference
	mov	itemxpos,ebx
	mov	itemypos,ecx
	push	ebp
	push	4
	call	_menutestdir
	mov	[esp+2*4],ebp
	or	eax,eax
	jz	popad&clc&ret
	jmp	@@upright


;---------------------------------------
menhmainlop:
	mov	esi,[esp+8*4+4]
	movzx	eax,insert
	push	eax
	mov	insert,42
	push	ebp
	mov	eax,menfieldwidth
	sub	eax,menbufferpos
	push	eax
	push	0
	mov	eax,menvalue
	mov	edi,menvalueptr
	mov	[edi],eax
	mov	eax,mensign
	mov	edi,mensignptr
	mov	[edi],ax
	call	_menudrawitem
	pop	eax
	mov	insert,al
;	 call	 _setinsertcursor
	call	_setnummenufieldcursor

	call	_menugetkey
	cmp	ah,28			; Enter
	je	menhenter
	cmp	ah,1			; Escape
	je	menhesc
	cmp	ah,14			; BackSpace
	je	menhbs
	cmp	ah,83			; Delete
	je	menhbs
	cmp	ah,75			; CursLeft
	je	menhleft
	cmp	ah,77			; CursRight
	je	menhright
	cmp	ah,72			; CursUp
	je	menhup
	cmp	ah,71			; Home
	je	menhhome
	cmp	ah,80			; CursDown
	je	menhdown
	cmp	ah,79			; End
	je	menhend
	cmp	ah,148			; Ctrl+Tab
	je	menctrltab
	cmp	ah,15			; Tab
	je	menhtab

	cmp	mensign,3
	je	menhnotminusorplus
	cmp	al,'-'
	je	menhminusorplus
	cmp	al,'+'
	jne	menhnotminusorplus
menhminusorplus:
	cmp	meneraseold,1
	jne	menhdonteraseold3
	mov	menvalue,0
	mov	meneraseold,0
	cmp	mensign,3
	je	menhdonteraseold3
	mov	mensign,2
menhdonteraseold3:
	push	eax
	mov	eax,1
	mov	ecx,menbufferpos
	jecxz	menh3endlop
menh3lop:
	shl	eax,4
	jo	menhoverflow
	dec	ecx
	jnz	menh3lop
	jmp	menh3endlop
menhoverflow:
	pop	eax
	jmp	menhforcesign
menh3endlop:
	cmp	menvalue,eax
	pop	eax
	ja	menhmainlop
menhforcesign:
	mov	mensign,0
	cmp	al,'-'
	je	menhmainlop
	mov	mensign,1
	jmp	menhmainlop
menhnotminusorplus:

	cmp	al,'0'
	jb	menhmainlop
	cmp	al,'9'
	jbe	menhdec
	and	al,0dfh
	cmp	al,'A'
	jb	menhmainlop
	cmp	al,'F'
	ja	menhmainlop
menhdec:
	call	_hex2bin
	cmp	meneraseold,1
	jne	menhdonteraseold
	mov	menvalue,0
	mov	meneraseold,0
	cmp	mensign,3
	je	menhdonteraseold
	mov	mensign,2
menhdonteraseold:

	movzx	edi,al
	mov	eax,1
	mov	ecx,menbufferpos
	jecxz	menh1endlop
menh1lop:
	shl	eax,4
	jc	menhmainlop
	dec	ecx
	jnz	menh1lop
menh1endlop:
	cmp	insert,1
	je	menhinsertactive1
	cmp	menbufferpos,0
	je	menhinsertactive1
	shr	eax,4
menhinsertactive1:
	mov	ebx,eax
	mov	eax,menvalue
	xor	edx,edx
	div	ebx
	mov	esi,edx
	cmp	insert,1
	je	menhinsertactive
	cmp	menbufferpos,0
	je	menhinsertactive
	shr	eax,4
menhinsertactive:
	shl	eax,4
	jc	menhmainlop
	add	eax,edi
	jc	menhmainlop
	mul	ebx
	or	edx,edx
	jnz	menhmainlop
	add	eax,esi
	jc	menhmainlop
	cmp	menmaxvalue,0
	je	menhanyvalueallowed
	cmp	eax,menmaxvalue
	ja	menhmainlop
menhanyvalueallowed:
	cmp	insert,1
	jne	menhlessisok
	cmp	eax,menvalue
	jb	menhmainlop
menhlessisok:
	mov	menvalue,eax
	cmp	insert,1
	je	menhmainlop
	cmp	menbufferpos,0
	je	menhmainlop
	dec	menbufferpos
	jmp	menhmainlop

menhup:
	mov	keyfromedit,ah
	push	ebp
	push	1
	call	_menutestdir
	or	eax,eax
	jz	menhmainlop
	jmp	mgknewitem

menhhome:
	mov	eax,1
	mov	ecx,menbufferpos
	jecxz	menhupendlop
menhuplop:
	shl	eax,4
	jc	menhmainlop
	dec	ecx
	jnz	menhuplop
menhupendlop:
	cmp	eax,menvalue
	jg	menhmainlop
	inc	menbufferpos
	cmp	menbufferpos,8
	jae	menhmainlop
	jmp	menhhome

menhdown:
	mov	keyfromedit,ah
	push	ebp
	push	2
	call	_menutestdir
	or	eax,eax
	jz	menhmainlop
	jmp	mgknewitem

menhend:
	mov	menbufferpos,0
	jmp	menhmainlop

menhinsert:
	mov	meneraseold,0
	neg	insert
	inc	insert
	call	_setinsertcursor
	cmp	insert,1
	je	menhmainlop
	call	_setoverwritecursor
	jmp	menhmainlop

menhleft:
	mov	meneraseold,0
	mov	eax,1
	mov	ecx,menbufferpos
	jecxz	menhleftendlop
menhleftlop:
	shl	eax,4
	jo	menhmainlop
	dec	ecx
	jnz	menhleftlop
menhleftendlop:
	cmp	eax,menvalue
	ja	menhmainlop
	inc	menbufferpos
	jmp	menhmainlop

menhright:
	mov	meneraseold,0
	cmp	menbufferpos,0
	je	menhmainlop
	dec	menbufferpos
	jmp	menhmainlop

menhbs:
	cmp	meneraseold,1
	jne	menhdonteraseold2
	mov	menvalue,0
	mov	meneraseold,0
	cmp	mensign,3
	je	menhmainlop
	mov	mensign,2
	jmp	menhmainlop
menhdonteraseold2:
	mov	ecx,menbufferpos
	cmp	ah,83
	jne	menhbsnotdel
	jecxz	menhmainlop
	dec	ecx
	dec	menbufferpos
menhbsnotdel:
	mov	eax,1
	jecxz	menh2endlop
menh2lop:
	shl	eax,4
	jo	menhforcesignkill
	dec	ecx
	jnz	menh2lop
menh2endlop:
	cmp	menvalue,eax
	jae	menh2nosignkill
menhforcesignkill:
	cmp	mensign,3
	je	menhmainlop
	mov	mensign,2
	jmp	menhmainlop
menh2nosignkill:
	mov	ebx,eax
	mov	eax,menvalue
	xor	edx,edx
	div	ebx
	mov	esi,edx
	shr	eax,4
	mul	ebx
	add	eax,esi
	mov	menvalue,eax
	jmp	menhmainlop

menhesc:
	mov	keyfromedit,ah
	mov	eax,menorigvalue
	mov	edi,menvalueptr
	mov	[edi],eax
	mov	eax,menorigsign
	mov	edi,mensignptr
	mov	[edi],ax
	jmp	mgknewitem

menhenter:
	mov	keyfromedit,ah
	jmp	mgknewitem

menhtab:
	call	_menutab
	jc	menhmainlop
	jmp	mgknewitem


;
menueditstring:
	mov	meseraseold,1

	mov	edx,1			; Itemnumber being drawn

	lea	edi,MenuHeadline

	mov	eax,MenuSpecial1
	mov	messpecial1,eax
	mov	eax,MenuSpecial2
	mov	messpecial2,eax
	mov	eax,MenuSpecial3
	mov	messpecial3,eax
	mov	eax,MenuSpecial4
	mov	messpecial4,eax
	mov	eax,MenuSpecial5
	mov	messpecial5,eax

	mov	ecx,-1
	xor	eax,eax
	repne	scasb
	repne	scasb
meslop0:
	cmp	dword ptr [edi],0
	je	mgknewitem		; This should NOT be able to happen!
	add	edi,2*4+4
	xor	al,al
	mov	ecx,-1
	repne	scasb
	repne	scasb
	repne	scasb
	add	edi,6
	cmp	edx,ebp
	je	mesfound
	movzx	eax,word ptr [edi]
	add	edi,eax
	add	edi,4+1+2*4		; dword + 1 for buffers trailing zero
	inc	edx
	jmp	meslop0
mesfound:
	movzx	eax,byte ptr [edi-1]
	mov	mesfieldwidth,eax
	movzx	eax,word ptr [edi]
	mov	mesmaxlength,eax
	add	edi,2
	mov	ax,word ptr [edi]
	mov	mesoriglength,ax
	mov	mescurrentlengthptr,edi
	movzx	ecx,word ptr [edi]
	add	edi,2
	mov	mesbufferptr,edi
	mov	esi,edi
	pushad
	mov	edi,offset menufieldbuffer
	mov	ecx,mesmaxlength
	inc	ecx
	rep	movsb
	popad
	mov	mesfieldoffset,0
	mov	mesbufferpos,0
	mov	meslength,0
meslop1:
	lodsb
	or	ecx,ecx
	jnz	mesecxnz
	or	al,al
	jz	mesmainlop
	inc	mesbufferpos
	inc	meslength
	mov	eax,mesbufferpos
	inc	eax
	cmp	eax,mesfieldwidth
	jb	meslop1
	inc	mesfieldoffset
	jmp	meslop1
mesecxnz:
	inc	mesbufferpos
	inc	meslength
	dec	ecx
	jz	mesmainlop
	mov	eax,mesbufferpos
	inc	eax
	cmp	eax,mesfieldwidth
	jb	meslop1
	inc	mesfieldoffset
	jmp	meslop1

mesmainlop:
	mov	esi,[esp+8*4+4]

	pushad
	cmp	messpecial1,4
	jne	messynchend
	cmp	ebp,messpecial2
	je	messynch2
	cmp	ebp,messpecial3
	je	messynch3
	cmp	ebp,messpecial4
	je	messynch4
	cmp	ebp,messpecial5
	jne	messynchend
	mov	ebp,messpecial4
	jmp	messynch
messynch2:
	mov	ebp,messpecial3
	jmp	messynch
messynch3:
	mov	ebp,messpecial2
	jmp	messynch
messynch4:
	mov	ebp,messpecial5
messynch:
	push	ebp
	mov	edi,mescurrentlengthptr
	mov	eax,meslength
	mov	word ptr [edi],ax
	mov	eax,mesbufferpos
	mov	ebx,mesfieldoffset
	sub	eax,ebx
	push	eax
	push	ebx
	call	_menudrawitem
messynchend:
	popad

	push	ebp
	mov	edi,mescurrentlengthptr
	mov	eax,meslength
	mov	word ptr [edi],ax
	mov	eax,mesbufferpos
	mov	ebx,mesfieldoffset
	sub	eax,ebx
	push	eax
	push	ebx
	call	_menudrawitem

	call	_menugetkey
	cmp	ah,28			; <Enter>
	je	mesenter
	cmp	ah,1			; <Escape>
	je	mesesc
	cmp	ah,14			; <BackSpace>
	je	mesbs
	cmp	ah,72			; CursUp
	je	mesup
	cmp	ah,80			; CursDown
	je	mesdown
	cmp	ah,75			; CursLeft
	je	mesleft
	cmp	ah,77			; CursRight
	je	mesright
	cmp	ah,71			; <Home>
	je	meshome
	cmp	ah,79			; <End>
	je	mesend
	cmp	ah,83			; <Delete>
	je	mesdelete
	cmp	ah,82			; <Insert>
	je	mesinsert
	cmp	ah,15			; <Tab>
	je	mestab

	push	eax
;	movzx	eax,v86r_ah		; Test if key is a defined scancode
        movzx   eax,mgk_ah
	mov	edx,scancode[eax*4]
	cmp	edx,0
	pop	eax
	je	messczero
	push	eax ebx ecx
	push	edx
	call	_menugetiteminfo
	test	eax,1
	pop	ecx ebx eax
	jnz	menuexit		; Yes it is -> exit with edx == item#
messczero:

	cmp	al,0
	je	mesmainlop

	cmp	meseraseold,1
	jne	mesdonteraseold
	push	eax
	mov	meslength,0
	mov	mesbufferpos,0
	mov	mesfieldoffset,0
	mov	ecx,mesmaxlength
	mov	edi,mesbufferptr
	xor	al,al
	rep	stosb
	mov	meseraseold,0
	pop	eax
mesdonteraseold:

	mov	ebx,meslength
	cmp	ebx,mesmaxlength
	jb	meslengthok		; buffer is not full
	cmp	insert,1
	je	mesmainlop		; buffer is full and insert active
	cmp	ebx,mesbufferpos
	jae	mesmainlop
meslengthok:
	mov	edi,mesbufferptr
	cmp	insert,1
	je	mesinsertactive
	add	edi,mesbufferpos
	stosb
	inc	mesbufferpos
	cmp	ebx,mesbufferpos
	jae	mestestfieldwidth
	inc	meslength
	xor	al,al
	stosb
	jmp	mestestfieldwidth
mesinsertactive:
	push	edi
	add	edi,meslength
	inc	edi;
	lea	esi,[edi-1]
	mov	ecx,meslength
	inc	ecx;
	sub	ecx,mesbufferpos
	jecxz	mesecxz
	std
	rep	movsb
	cld
mesecxz:
	pop	edi
	add	edi,mesbufferpos
	stosb
	inc	mesbufferpos
	inc	meslength
mestestfieldwidth:
	mov	eax,mesbufferpos
	sub	eax,mesfieldoffset
	cmp	eax,mesfieldwidth
	jb	mesmainlop
	inc	mesfieldoffset
	jmp	mesmainlop

mesinsert:
	mov	meseraseold,0
	dec	insert
	neg	insert
	call	_drawtoprow
	call	_putcursor
	jmp	mesmainlop

mesdelete:
	cmp	meseraseold,1
	jne	mesdonteraseold2
	mov	meslength,0
	mov	mesbufferpos,0
	mov	mesfieldoffset,0
	mov	ecx,mesmaxlength
	mov	edi,mesbufferptr
	xor	al,al
	rep	stosb
	mov	meseraseold,0
	jmp	mesmainlop
mesdonteraseold2:
	mov	eax,mesbufferpos
	cmp	eax,meslength
	jae	mesmainlop
	mov	edi,eax
	add	edi,mesbufferptr
	lea	esi,[edi+1]
	mov	ecx,meslength
	sub	ecx,mesbufferpos
	rep	movsb
	dec	meslength
	jmp	mesmainlop

mesup:
	mov	keyfromedit,ah
	push	ebp
	push	1
	call	_menutestdir
	or	eax,eax
	jz	mesmainlop
	jmp	mgknewitem

meshome:
	mov	mesfieldoffset,0
	mov	mesbufferpos,0
	mov	meseraseold,0
	jmp	mesmainlop

mesdown:
	mov	keyfromedit,ah
	push	ebp
	push	2
	call	_menutestdir
	or	eax,eax
	jz	mesmainlop
	jmp	mgknewitem

mesend:
	mov	meseraseold,0
	mov	eax,meslength
	mov	mesbufferpos,eax
	inc	eax
	sub	eax,mesfieldwidth
	mov	mesfieldoffset,eax
	jnc	mesmainlop
	mov	mesfieldoffset,0
	jmp	mesmainlop

mesleft:
	mov	meseraseold,0
	cmp	mesbufferpos,0
	je	mesmainlop
	dec	mesbufferpos
	mov	eax,mesbufferpos
	cmp	eax,mesfieldoffset
	jae	mesmainlop
	dec	mesfieldoffset
	jmp	mesmainlop

mesright:
	mov	meseraseold,0
	mov	eax,mesbufferpos
	cmp	eax,meslength
	jae	mesmainlop
	inc	mesbufferpos
	mov	eax,mesbufferpos
	sub	eax,mesfieldoffset
	cmp	eax,mesfieldwidth
	jb	mesmainlop
	inc	mesfieldoffset
	jmp	mesmainlop

mesbs:
	cmp	meseraseold,1
	jne	mesdonteraseold3
	mov	meslength,0
	mov	mesbufferpos,0
	mov	mesfieldoffset,0
	mov	ecx,mesmaxlength
	mov	edi,mesbufferptr
	xor	al,al
	rep	stosb
	mov	meseraseold,0
	jmp	mesmainlop
mesdonteraseold3:
	cmp	mesbufferpos,0
	je	mesmainlop
	mov	esi,mesbufferptr
	add	esi,mesbufferpos
	lea	edi,[esi-1]
	mov	ecx,meslength
	sub	ecx,mesbufferpos
	inc	ecx			; move trailing zero too
	rep	movsb
	dec	mesbufferpos
	dec	meslength
	mov	eax,mesbufferpos
	cmp	eax,mesfieldoffset
	jae	mesmainlop
	cmp	mesfieldoffset,0
	je	mesmainlop
	dec	mesfieldoffset
	jmp	mesmainlop

mesesc:
	mov	keyfromedit,ah
	pushad
	mov	ax,mesoriglength
	mov	edi,mescurrentlengthptr
	mov	word ptr [edi],ax
	mov	esi,offset menufieldbuffer
	mov	edi,mesbufferptr
	mov	ecx,mesmaxlength
	inc	ecx
	rep	movsb
	popad
	jmp	mgknewitem
mesenter:
	mov	keyfromedit,ah
	mov	edi,mescurrentlengthptr
	mov	eax,meslength
	mov	word ptr [edi],ax
	mov	edi,mesbufferptr
	add	edi,eax
	mov	ecx,mesmaxlength
	sub	ecx,eax
	xor	al,al
	inc	ecx			; +1 for trailing zero
	rep	stosb
	jmp	mgknewitem

mestab:
	call	_menutab
	jc	mesmainlop
	jmp	mgknewitem


;
menueditchk:
	mov	edx,1			; Itemnumber being drawn
	lea	edi,MenuHeadline
	mov	ecx,-1
	xor	eax,eax
	repne	scasb
	repne	scasb
mechklop0:
	cmp	dword ptr [edi],0
	je	mgknewitem		; This should NOT be able to happen!
	add	edi,2*4+4
	xor	al,al
	mov	ecx,-1
	repne	scasb
	repne	scasb
	repne	scasb
	add	edi,6
	cmp	edx,ebp
	je	mechkfound
	movzx	eax,word ptr [edi]
	add	edi,eax
	add	edi,4+1+2*4		; dword + 1 for buffers trailing zero
	inc	edx
	jmp	mechklop0
mechkfound:
	add	edi,4
	mov	mechkbufferptr,edi

mechkmainlop:
	mov	esi,[esp+8*4+4]
	push	ebp
	push	0
	push	0
	call	_menudrawitem

	call	_menugetkey
	cmp	ah,28			; <Enter>
	je	mechkenter
	cmp	ah,1			; <Escape>
	je	mechkesc
	cmp	ah,57			; <Space>
	je	mechkspace
	cmp	ah,72			; CursUp
	je	mechkup
	cmp	ah,80			; CursDown
	je	mechkdown
	cmp	ah,75			; CursLeft
	je	mechkleft
	cmp	ah,77			; CursRight
	je	mechkright
	cmp	ah,15			; Tab
	je	mechktab

	push	eax
;	movzx	eax,v86r_ah		; Test if key is a defined scancode
        movzx   eax,mgk_ah
	mov	edx,scancode[eax*4]
	cmp	edx,0
	pop	eax
	je	mechksczero
	push	eax ebx ecx
	push	edx
	call	_menugetiteminfo
	test	eax,1
	pop	ecx ebx eax
	jnz	menuexit		; Yes it is -> exit with edx == item#
mechksczero:

	jmp	mechkmainlop

mechkspace:
	mov	edi,mechkbufferptr
	neg	byte ptr [edi]
	inc	byte ptr [edi]
	jmp	mechkmainlop

mechkup:
	mov	keyfromedit,ah
	push	ebp
	push	1
	call	_menutestdir
	or	eax,eax
	jz	mechkmainlop
	jmp	mgknewitem

mechkdown:
	mov	keyfromedit,ah
	push	ebp
	push	2
	call	_menutestdir
	or	eax,eax
	jz	mechkmainlop
	jmp	mgknewitem

mechkleft:
	mov	keyfromedit,ah
	push	ebp
	push	3
	call	_menutestdir
	or	eax,eax
	jz	mechkmainlop
	jmp	mgknewitem

mechkright:
	mov	keyfromedit,ah
	push	ebp
	push	4
	call	_menutestdir
	or	eax,eax
	jz	mechkmainlop
	jmp	mgknewitem

mechkesc:
	mov	keyfromedit,ah
	jmp	mgknewitem

mechkenter:
	mov	keyfromedit,ah
	jmp	mgknewitem

mechktab:
	call	_menutab
	jc	mechkmainlop
	jmp	mgknewitem


;
menuedithexstring:
	mov	meseraseold,1

	mov	edx,1			; Itemnumber being drawn
	lea	edi,MenuHeadline
	mov	ecx,-1
	xor	eax,eax
	repne	scasb
	repne	scasb
mehslop0:
	cmp	dword ptr [edi],0
	je	mgknewitem		; This should NOT be able to happen!
	add	edi,2*4+4
	xor	al,al
	mov	ecx,-1
	repne	scasb
	repne	scasb
	repne	scasb
	add	edi,6
	cmp	edx,ebp
	je	mehsfound
	movzx	eax,word ptr [edi]
	add	edi,eax
	add	edi,4+1+2*4		; dword + 1 for buffers trailing zero
	inc	edx
	jmp	mehslop0
mehsfound:
	movzx	eax,byte ptr [edi-1]
	mov	mesfieldwidth,eax
	movzx	eax,word ptr [edi]
	mov	mesmaxlength,eax
	add	edi,2
	mov	ax,word ptr [edi]
	mov	mesoriglength,ax
	mov	mescurrentlengthptr,edi
	movzx	ecx,word ptr [edi]
	add	edi,2
	mov	mesbufferptr,edi
	mov	esi,edi
	pushad
	mov	edi,offset menufieldbuffer
	mov	ecx,mesmaxlength
	inc	ecx
	rep	movsb
	popad
	mov	mesfieldoffset,0
	mov	mesbufferpos,0
	mov	meslength,0
	mov	mehslownibble,0
mehslop1:
	lodsb
	or	ecx,ecx
	jnz	mehsecxnz
	or	al,al
	jz	mehsmainlop
	inc	mesbufferpos
	inc	meslength
	mov	eax,mesbufferpos
	inc	eax
	lea	eax,[eax*2+eax]
	cmp	eax,mesfieldwidth
	jb	mehslop1
	inc	mesfieldoffset
	jmp	mehslop1
mehsecxnz:
	inc	mesbufferpos
	inc	meslength
	dec	ecx
	jz	mehsmainlop
	mov	eax,mesbufferpos
	inc	eax
	lea	eax,[eax*2+eax]
	cmp	eax,mesfieldwidth
	jb	mehslop1
	inc	mesfieldoffset
	jmp	mehslop1

mehsmainlop:
	mov	esi,[esp+8*4+4]
	push	ebp
	mov	edi,mescurrentlengthptr
	mov	eax,meslength
	mov	word ptr [edi],ax
	mov	eax,mesbufferpos
	mov	ebx,mesfieldoffset
	sub	eax,ebx
	lea	eax,[eax*2+eax]
	add	eax,mehslownibble
	push	eax
	push	ebx
	call	_menudrawitem

	call	_menugetkey
	cmp	ah,28			; <Enter>
	je	mehsenter
	cmp	ah,1			; <Escape>
	je	mehsesc
	cmp	ah,14			; <BackSpace>
	je	mehsbs
	cmp	ah,72			; CursUp
	je	mehsup
	cmp	ah,80			; CursDown
	je	mehsdown
	cmp	ah,75			; CursLeft
	je	mehsleft
	cmp	ah,77			; CursRight
	je	mehsright
	cmp	ah,71			; <Home>
	je	mehshome
	cmp	ah,79			; <End>
	je	mehsend
	cmp	ah,83			; <Delete>
	je	mehsdelete
	cmp	ah,82			; <Insert>
	je	mehsinsert
	cmp	ah,15			; <Tab>
	je	mehstab

	push	eax
;	movzx	eax,v86r_ah		; Test if key is a defined scancode
        movzx   eax,mgk_ah
	mov	edx,scancode[eax*4]
	cmp	edx,0
	pop	eax
	je	mehssczero
	push	eax ebx ecx
	push	edx
	call	_menugetiteminfo
	test	eax,1
	pop	ecx ebx eax
	jnz	menuexit		; Yes it is -> exit with edx == item#
mehssczero:

	call	_ishex
	jc	mehsmainlop
	call	_toupper
	call	_hex2bin

	cmp	meseraseold,1
	jne	mehsdonteraseold
	push	eax
	mov	meslength,0
	mov	mesbufferpos,0
	mov	mesfieldoffset,0
	mov	ecx,mesmaxlength
	mov	edi,mesbufferptr
	xor	al,al
	rep	stosb
	mov	meseraseold,0
	pop	eax
mehsdonteraseold:

	mov	ebx,meslength
	cmp	ebx,mesmaxlength
	jb	mehslengthok		 ; buffer is not full
	cmp	insert,1
	je	mehsmainlop		 ; buffer is full and insert active
	cmp	ebx,mesbufferpos
	jae	mehsmainlop
mehslengthok:
	mov	edi,mesbufferptr
	cmp	insert,1
	je	mehsinsertactive
	add	edi,mesbufferpos
	cmp	mehslownibble,1
	je	mehs1l
	and	byte ptr [edi],0fh
	shl	al,4
	add	byte ptr [edi],al
	mov	mehslownibble,1
	cmp	ebx,mesbufferpos
	ja	mehsmainlop
	stosb
	inc	meslength
	xor	al,al
	stosb
	jmp	mehsmainlop
mehs1lpre:
	add	edi,mesbufferpos
mehs1l:
	and	byte ptr [edi],0f0h
	add	byte ptr [edi],al
	mov	mehslownibble,0
	inc	mesbufferpos
	jmp	mehstestfieldwidth
mehsinsertactive:
	cmp	mehslownibble,1
	je	mehs1lpre
	push	edi
	add	edi,meslength
	inc	edi;
	lea	esi,[edi-1]
	mov	ecx,meslength
	inc	ecx;
	sub	ecx,mesbufferpos
	jecxz	mehsecxz
	std
	rep	movsb
	cld
mehsecxz:
	pop	edi
	add	edi,mesbufferpos
	shl	al,4
	stosb
	inc	meslength
	mov	mehslownibble,1
	jmp	mehsmainlop
mehstestfieldwidth:
	mov	eax,mesbufferpos
	sub	eax,mesfieldoffset
	lea	eax,[eax*2+eax]
	cmp	eax,mesfieldwidth
	jb	mehsmainlop
	inc	mesfieldoffset
	jmp	mehsmainlop

mehsinsert:
	mov	meseraseold,0
	dec	insert
	neg	insert
	call	_drawtoprow
	call	_putcursor
	jmp	mehsmainlop

mehsdelete:
	mov	mehslownibble,0
	cmp	meseraseold,1
	jne	mehsdonteraseold2
	mov	meslength,0
	mov	mesbufferpos,0
	mov	mesfieldoffset,0
	mov	ecx,mesmaxlength
	mov	edi,mesbufferptr
	xor	al,al
	rep	stosb
	mov	meseraseold,0
	jmp	mehsmainlop
mehsdonteraseold2:
	mov	eax,mesbufferpos
	cmp	eax,meslength
	jae	mehsmainlop
	mov	edi,eax
	add	edi,mesbufferptr
	lea	esi,[edi+1]
	mov	ecx,meslength
	sub	ecx,mesbufferpos
	rep	movsb
	dec	meslength
	jmp	mehsmainlop

mehsup:
	mov	keyfromedit,ah
	push	ebp
	push	1
	call	_menutestdir
	or	eax,eax
	jz	mehsmainlop
	jmp	mgknewitem

mehshome:
	mov	mesfieldoffset,0
	mov	mesbufferpos,0
	mov	meseraseold,0
	mov	mehslownibble,0
	jmp	mehsmainlop

mehsdown:
	mov	keyfromedit,ah
	push	ebp
	push	2
	call	_menutestdir
	or	eax,eax
	jz	mehsmainlop
	jmp	mgknewitem

mehsend:
	mov	meseraseold,0
	mov	mehslownibble,0
	mov	eax,meslength
	mov	mesbufferpos,eax
	inc	eax
	lea	eax,[eax*2+eax]
	sub	eax,mesfieldwidth
	jnc	mehsend_mfook
	mov	mesfieldoffset,0
	jmp	mehsmainlop
mehsend_mfook:
	mov	eax,meslength
	inc	eax
	lea	eax,[eax*2+eax]
	sub	eax,mesfieldwidth
	push	ebx edx
	mov	ebx,3
	xor	edx,edx
	div	ebx
	pop	edx ebx
	mov	mesfieldoffset,eax
	jmp	mehsmainlop


mehsleft:
	mov	meseraseold,0
	cmp	mehslownibble,0
	je	mehslefth
	mov	mehslownibble,0
	jmp	mehsmainlop
mehslefth:
	cmp	mesbufferpos,0
	je	mehsmainlop
	dec	mesbufferpos
	mov	eax,mesbufferpos
	cmp	eax,mesfieldoffset
	jae	mehsmainlop
	dec	mesfieldoffset
	jmp	mehsmainlop

mehsright:
	mov	meseraseold,0
	mov	mehslownibble,0
	mov	eax,mesbufferpos
	cmp	eax,meslength
	jae	mehsmainlop
	inc	mesbufferpos
	mov	eax,mesbufferpos
	sub	eax,mesfieldoffset
	lea	eax,[eax*2+eax]
	cmp	eax,mesfieldwidth
	jb	mehsmainlop
	inc	mesfieldoffset
	jmp	mehsmainlop

mehsbs:
	cmp	meseraseold,1
	jne	mehsdonteraseold3
	mov	meslength,0
	mov	mesbufferpos,0
	mov	mesfieldoffset,0
	mov	ecx,mesmaxlength
	mov	edi,mesbufferptr
	xor	al,al
	rep	stosb
	mov	meseraseold,0
	jmp	mehsmainlop
mehsdonteraseold3:
	mov	esi,mesbufferptr
	add	esi,mesbufferpos
	cmp	mehslownibble,0
	je	mehsbsh
	mov	mehslownibble,0
	and	byte ptr [esi],0fh
	jmp	mehsmainlop
mehsbsh:
	cmp	mesbufferpos,0
	je	mehsmainlop
	lea	edi,[esi-1]
	mov	ecx,meslength
	sub	ecx,mesbufferpos
	inc	ecx			; move trailing zero too
	rep	movsb
	dec	mesbufferpos
	dec	meslength
	mov	eax,mesbufferpos
	cmp	eax,mesfieldoffset
	jae	mehsmainlop
	cmp	mesfieldoffset,0
	je	mehsmainlop
	dec	mesfieldoffset
	jmp	mehsmainlop

mehsesc:
	mov	keyfromedit,ah
	pushad
	mov	ax,mesoriglength
	mov	edi,mescurrentlengthptr
	mov	word ptr [edi],ax
	mov	esi,offset menufieldbuffer
	mov	edi,mesbufferptr
	mov	ecx,mesmaxlength
	inc	ecx
	rep	movsb
	popad
	jmp	mgknewitem
mehsenter:
	mov	keyfromedit,ah
	mov	edi,mescurrentlengthptr
	mov	eax,meslength
	mov	word ptr [edi],ax
	mov	edi,mesbufferptr
	add	edi,eax
	mov	ecx,mesmaxlength
	sub	ecx,eax
	xor	al,al
	inc	ecx			; +1 for trailing zero
	rep	stosb
	jmp	mgknewitem

mehstab:
	call	_menutab
	jc	mehsmainlop
	jmp	mgknewitem


;
; _menutestdir( dword itemnumber, dword direction );
; In:	itemxpos and itemypos must be correctly filled!
; Out:	EAX = itemnumber ( 0 == No item found in that direction )
; Note: Directions:	1 == UP, 2 == DOWN, 3 == LEFT, 4 == RIGHT
_menutestdir:
	pushad
	mov	edx,[esp+8*4+4+4]	; get itemnumber
	mov	ebx,[esp+8*4+4] 	; get direction

	mov	ebp,1			; Itemnumber being drawn
	lea	edi,MenuHeadline
	mov	ecx,-1
	xor	eax,eax
	repne	scasb
	repne	scasb
	mov	mtdbestsofar,0
	mov	mtdprimoffset,999999
	mov	mtdsecoffset,-999999
mtdlop0:
	cmp	dword ptr [edi],0
	je	mtddone
	cmp	ebp,edx
	je	mtddonttest
	push	ebx ecx
	push	ebp
	call	_menugetiteminfo
	pop	ecx ebx
	test	eax,1			; is item selectable?
	jz	mtddonttest
	cmp	eax,14			; is item only common text?
	je	mtddonttest
	cmp	eax,1			; is item only scancode?
	je	mtddonttest
	cmp	ebx,1
	jne	mtdnotup
	mov	eax,[edi+4]
	cmp	eax,itemypos
	ja	mtddonttest
	jb	mtub
	mov	eax,-999999
	add	eax,itemypos
mtub:
	neg	eax
	add	eax,itemypos
	cmp	eax,mtdprimoffset
	ja	mtddonttest
	je	mtdup
	mov	mtdsecoffset,-999999
	mov	mtdprimoffset,eax
mtdup:
	mov	eax,[edi]
	neg	eax
	add	eax,itemxpos
	cmp	mtdsecoffset,0
	jl	mtusl
	cmp	eax,mtdsecoffset
	ja	mtddonttest
	mov	mtdsecoffset,eax
	mov	mtdbestsofar,ebp
	jmp	mtddonttest
mtusl:
	cmp	eax,mtdsecoffset
	jle	mtddonttest
	cmp	mtdprimoffset,999999
	jne	mtune
	cmp	eax,0
	jl	mtddonttest
mtune:
	mov	mtdsecoffset,eax
	mov	mtdbestsofar,ebp
	jmp	mtddonttest
mtdnotup:
	cmp	ebx,2
	jne	mtdnotdown
	mov	eax,[edi+4]
	cmp	eax,itemypos
	jb	mtddonttest
	ja	mtda
	mov	eax,999999
	add	eax,itemypos
mtda:
	sub	eax,itemypos
	cmp	eax,mtdprimoffset
	ja	mtddonttest
	je	mtddown
	mov	mtdsecoffset,-999999
	mov	mtdprimoffset,eax
mtddown:
	mov	eax,[edi]
	neg	eax
	add	eax,itemxpos
	cmp	mtdsecoffset,0
	jl	mtdsl
	cmp	eax,mtdsecoffset
	ja	mtddonttest
	mov	mtdsecoffset,eax
	mov	mtdbestsofar,ebp
	jmp	mtddonttest
mtdsl:
	cmp	eax,mtdsecoffset
	jle	mtddonttest
	cmp	mtdprimoffset,999999
	jne	mtdne
	cmp	eax,0
	jg	mtddonttest
mtdne:
	mov	mtdsecoffset,eax
	mov	mtdbestsofar,ebp
	jmp	mtddonttest
mtdnotdown:
	cmp	ebx,3
	jne	mtdnotleft
	mov	eax,[edi]
	cmp	eax,itemxpos
	ja	mtddonttest
	jb	mtlb
	mov	eax,-999999
	add	eax,itemxpos
mtlb:
	neg	eax
	add	eax,itemxpos
	cmp	eax,mtdprimoffset
	ja	mtddonttest
	mov	mtdtempprimoffset,eax
	mov	eax,[edi+4]
	neg	eax
	add	eax,itemypos
	cmp	mtdsecoffset,0
	jl	mtlsl
	cmp	eax,mtdsecoffset
	ja	mtddonttest
	mov	mtdsecoffset,eax
	mov	mtdbestsofar,ebp
	mov	eax,mtdtempprimoffset
	mov	mtdprimoffset,eax
	jmp	mtddonttest
mtlsl:
	cmp	eax,mtdsecoffset
	jle	mtddonttest
	cmp	mtdprimoffset,999999
	jne	mtlne
	cmp	eax,0
	jl	mtddonttest
mtlne:
	mov	mtdsecoffset,eax
	mov	mtdbestsofar,ebp
	mov	eax,mtdtempprimoffset
	mov	mtdprimoffset,eax
	jmp	mtddonttest
mtdnotleft:
	mov	eax,[edi]
	cmp	eax,itemxpos
	jb	mtddonttest
	ja	mtrb
	mov	eax,999999
	add	eax,itemxpos
mtrb:
	sub	eax,itemxpos
	cmp	eax,mtdprimoffset
	ja	mtddonttest
	mov	mtdtempprimoffset,eax
	mov	eax,[edi+4]
	neg	eax
	add	eax,itemypos
	cmp	mtdsecoffset,0
	jl	mtrsl
	cmp	eax,mtdsecoffset
	ja	mtddonttest
	mov	mtdsecoffset,eax
	mov	mtdbestsofar,ebp
	mov	eax,mtdtempprimoffset
	mov	mtdprimoffset,eax
	jmp	mtddonttest
mtrsl:
	cmp	eax,mtdsecoffset
	jle	mtddonttest
	cmp	mtdprimoffset,999999
	jne	mtrne
	cmp	eax,0
	jg	mtddonttest
mtrne:
	mov	mtdsecoffset,eax
	mov	mtdbestsofar,ebp
	mov	eax,mtdtempprimoffset
	mov	mtdprimoffset,eax
	jmp	mtddonttest

mtddonttest:
	add	edi,2*4+4
	xor	al,al
	mov	ecx,-1
	repne	scasb
	repne	scasb
	repne	scasb
	add	edi,6
	movzx	eax,word ptr [edi]
	add	edi,eax
	add	edi,4+1+2*4		; dword + 1 for buffers trailing zero
	inc	ebp
	jmp	mtdlop0

mtddone:
	popad
	mov	eax,mtdbestsofar
	ret	2*4

;
; _menugetiteminfo( dword itemnumber );
; Out:	EAX = Typenumber ( 0 == Invalid itemnumber (EndOfStructure) )
;	EBX = X-Pos
;	ECX = Y-Pos
;	itembufptr -> Items buffer (for text/value etc)
_menugetiteminfo:
	pushad
	mov	edx,[esp+8*4+4] 	; get itemnumber
	xor	ebx,ebx

	mov	ebp,1			; Itemnumber being drawn
	lea	edi,MenuHeadline
	mov	ecx,-1
	xor	eax,eax
	repne	scasb
	repne	scasb
mgitlop0:
	cmp	ebp,edx
	ja	mgitdone
	cmp	dword ptr [edi],0
	je	mgiterror
	mov	eax,[edi]
	mov	[esp+4*4],eax
	mov	eax,[edi+4]
	mov	[esp+6*4],eax
	add	edi,2*4+4
	xor	al,al
	mov	ecx,-1
	repne	scasb
	repne	scasb
	repne	scasb
	mov	bl,[edi]
	add	edi,6
	movzx	eax,word ptr [edi]
	add	edi,4
	mov	itembufptr,edi
	add	edi,eax
	add	edi,1+2*4	      ; + 1 for buffers trailing zero
	inc	ebp
	jmp	mgitlop0

mgiterror:
	xor	ebx,ebx

mgitdone:
	mov	dword ptr [esp+7*4],ebx
	popad
	ret	4

;
; _menudrawitem( dword itemnumber, dword cursorpos, dword stringoffset );
; In:	itemtype == type of current item (IMPORTANT!)
; Note: If itemnumber == 0 -> draw all items.
;	If cursorpos == -1 -> hide cursor.
;	Cursorpos is only used in current items with inputfields.
;	Stringoffset is the offset in the string to start writing from.
_menudrawitem:
	pushad
	mov	edx,[esp+8*4+3*4]	  ; get itemnumber
	mov	eax,[esp+8*4+2*4]	  ; get cursorpos
	mov	mdaticursoradd,eax
	mov	eax,[esp+8*4+1*4]	  ; get stringoffset
	mov	mdatistringoffset,eax

	cmp	mdaticursoradd,-1
	jne	mdatignuff1
	call	_hidecursor
	jmp	mdatignuff2
mdatignuff1:
	cmp	insert,42	; spec
	je	mdatignuff2
	cmp	insert,1
	jne	mdatignuff3
	call	_setinsertcursor
	jmp	mdatignuff2
mdatignuff3:
	call	_setoverwritecursor
mdatignuff2:

	mov	ebp,1			; Itemnumber being drawn
	lea	edi,MenuHeadline
	mov	ecx,-1
	xor	eax,eax
	repne	scasb
	repne	scasb
mdatilop0:
	mov	mdatibufflop11st,1
	mov	mdaticursorpos,0
	cmp	dword ptr [edi],0
	je	mdatidone
	mov	esi,edi
	mov	edi,mscreenpos
	mov	eax,[esi+4]
	shl	eax,4+(CELLSIZE/2)
	lea	eax,[eax*4+eax]
	add	edi,eax
;	add	edi,[esi]
;	add	edi,[esi]
	mov	eax,[esi]
	lea	edi,[edi+eax*CELLSIZE]
	add	esi,4*2+4
	mov	eax,[esi-4]
	cmp	eax,-1
	je	mdatidontuseptr1
	mov	ah,byte ptr [eax]
mdatidontuseptr1:
	push	ecx eax esi
	mov	esi,[esp+3*4+1*4]	; get esi from stack
	push	ebp
	call	_menugetiteminfo
	cmp	eax,14
	jne	mdatignu1
	mov	eax,13
mdatignu1:
	test	eax,1
	pop	esi eax
	jnz	mdatisel
	mov	ah,menu_notselectable_c
mdatisel:
	pop	ecx
	mov	mdatiitemcolor,ah
	cmp	ebp,edx 		; invert colors if item is current
	jne	mdatilop1		;  and itemtype == 3
	cmp	itemtype,3
	jne	mdatinot3
	ror	ah,4
	and	ah,07fh
	jmp	mdatilop1
mdatinot3:
mdatilop1:
	shl	eax,(CELLSIZE-2)*4
mdatilop1lop:
	lodsb
	or	al,al
	jz	mdatilop1end
	putcell
	inc	mdaticursorpos
	jmp	mdatilop1lop
mdatilop1end:
	shr	eax,(CELLSIZE-2)*4
	mov	mdatitextc,ah
	push	edi
	xor	al,al
	mov	ecx,-1
	mov	edi,esi
	repne	scasb
	mov	esi,edi
	pop	edi
mdatilop2:
	lodsb
	or	al,al
	jz	mdatilop2end
	and	eax,0ffh
	mov	scancode[eax*4],ebp
	jmp	mdatilop2
mdatilop2end:
	lodsb
	mov	fieldtype,al
	add	esi,5
	movzx	eax,word ptr [esi]	;	 lodsd
	add	esi,4
	add	esi,eax
	cmp	fieldtype,4
	jbe	mdatinofield
	cmp	fieldtype,14
	je	mdatinofield
	sub	esi,eax
	sub	esi,4
	movzx	ebx,byte ptr [esi-1]
	mov	mdatifieldwidth,ebx
	mov	eax,[esi-5]
	mov	ah,byte ptr [eax]

	cmp	fieldtype,11
	je	mdatichksel
	cmp	fieldtype,12
	je	mdatichknosel

	push	eax ebx ecx esi
	mov	esi,[esp+4*4+1*4]	; get esi from stack
	push	ebp
	call	_menugetiteminfo
	test	eax,1
	pop	esi ecx ebx eax
	jnz	mdatisel2
	mov	ah,menu_notselectable_c
mdatisel2:
	shl	eax,(CELLSIZE-2)*4
;	 cmp	 ebp,edx
;	 jne	 mdatinotcurrent3
;	 cmp	 mdaticursoradd,-1
;	 jne	 mdatinotcurrent3
;	 ror	 ah,4
;	 and	 ah,07fh
;mdatinotcurrent3:
	mov	mdatioverflow,0
	movzx	ecx,word ptr [esi+2]
	mov	mdaticurrentlength,ecx
	movzx	ecx,word ptr [esi]	; esi -> maximum length of inputstring
	add	esi,4
	cmp	ebp,edx
	jne	mdatinocursor2
	cmp	fieldtype,7
	je	mdatiit7active
	cmp	fieldtype,8
	je	mdatiit7active
	cmp	mdaticursoradd,-1
	je	mdatinocursor2
	push	eax
	mov	eax,mdatistringoffset
	add	esi,eax
	sub	ecx,eax
	sub	mdaticurrentlength,eax
	pop	eax
	jecxz	mdatibufflop1end2
	jmp	mdatibufflop1
mdatinocursor2:
	cmp	fieldtype,7
	je	mdatiit7active
	cmp	fieldtype,8
	jne	mdatiitnot7
mdatiit7active:
	cmp	edx,0
	je	mdatii7drawit
	cmp	edx,ebp
	je	mdatii7drawit
	add	esi,ecx
	jmp	mdatinofield
mdatii7drawit:
	pushad
	push	ebx
	movzx	ebx,word ptr [esi+ecx+1+4]
	mov	mdatisign,ebx
	movzx	ebx,word ptr [esi+ecx+1+4+2]
	cmp	ebx,0
	jne	mdatinotdefaultbase
	movzx	ebx,defaultbase
mdatinotdefaultbase:
	mov	mdatibase,ebx
	pop	ebx
	cmp	mdatibase,1
	jne	mdatinotdec			; decimal?
	mov	edx,ecx
	lea	ecx,[ebx-10]
	mov	ebx,[esi]
	add	esi,edx
	cmp	ebx,1000000000
	jae	mdatii7decok
	inc	ecx
	cmp	ebx,100000000
	jae	mdatii7decok
	inc	ecx
	cmp	ebx,10000000
	jae	mdatii7decok
	inc	ecx
	cmp	ebx,1000000
	jae	mdatii7decok
	inc	ecx
	cmp	ebx,100000
	jae	mdatii7decok
	inc	ecx
	cmp	ebx,10000
	jae	mdatii7decok
	inc	ecx
	cmp	ebx,1000
	jae	mdatii7decok
	inc	ecx
	cmp	ebx,100
	jae	mdatii7decok
	inc	ecx
	cmp	ebx,10
	jae	mdatii7decok
	inc	ecx
mdatii7decok:
	cmp	mdatisign,2
	je	mdatii7nosign
	cmp	mdatisign,3
	je	mdatii7nosign
	dec	ecx
	jecxz	mdatii7nofill
mdatii7nosign:
	or	ecx,ecx
	jle	mdatii7nofill
	mov	al,misc_menufieldbkgchar
	rep
	putcell
mdatii7nofill:
	mov	al,'-'
	cmp	mdatisign,2
	je	mdatii7nosign2
	cmp	mdatisign,3
	je	mdatii7nosign2
	cmp	mdatisign,0
	je	mdatii7minus
	mov	al,'+'
mdatii7minus:
	putcell
mdatii7nosign2:
	shr	eax,(CELLSIZE-2)*4
	mov	ch,ah
	mov	eax,ebx
	call	_printdec_dword
	add	edi,addededi
	mov	ah,ch
	shl	eax,(CELLSIZE-2)*4
	mov	al,'d'
	putcell
	sub	edi,CELLSIZE
	jmp	mdatii7end
mdatinotdec:
	cmp	mdatibase,2
	jne	mdatinothex			; hex?
	mov	edx,ecx
	lea	ecx,[ebx-8]
	mov	ebx,[esi]
	add	esi,edx
	cmp	ebx,10000000h
	jae	mdatii7hexok
	inc	ecx
	cmp	ebx,1000000h
	jae	mdatii7hexok
	inc	ecx
	cmp	ebx,100000h
	jae	mdatii7hexok
	inc	ecx
	cmp	ebx,10000h
	jae	mdatii7hexok
	inc	ecx
	cmp	ebx,1000h
	jae	mdatii7hexok
	inc	ecx
	cmp	ebx,100h
	jae	mdatii7hexok
	inc	ecx
	cmp	ebx,10h
	jae	mdatii7hexok
	inc	ecx
mdatii7hexok:
	cmp	mdatisign,2
	je	mdatii7hnosign
	cmp	mdatisign,3
	je	mdatii7hnosign
	dec	ecx
	jecxz	mdatii7hnofill
mdatii7hnosign:
	or	ecx,ecx
	jle	mdatii7hnofill
	mov	al,misc_menufieldbkgchar
	rep
	putcell
mdatii7hnofill:
	mov	al,'-'
	cmp	mdatisign,2
	je	mdatii7hnosign2
	cmp	mdatisign,3
	je	mdatii7hnosign2
	cmp	mdatisign,0
	je	mdatii7hminus
	mov	al,'+'
mdatii7hminus:
	putcell
mdatii7hnosign2:
	shr	eax,(CELLSIZE-2)*4
	mov	ch,ah
	mov	eax,ebx
	call	_printhexx_dword
	add	edi,addededi
	mov	ah,ch
	shl	eax,(CELLSIZE-2)*4
	mov	al,'h'
	putcell
	sub	edi,CELLSIZE
	jmp	mdatii7end
mdatinothex:
	cmp	mdatibase,3
	jne	mdatinotoct			; octal?
	mov	edx,ecx
	lea	ecx,[ebx-11]
	mov	ebx,[esi]
	add	esi,edx
	cmp	ebx,10000000000o
	jae	mdatii7octok
	inc	ecx
	cmp	ebx,1000000000o
	jae	mdatii7octok
	inc	ecx
	cmp	ebx,100000000o
	jae	mdatii7octok
	inc	ecx
	cmp	ebx,10000000o
	jae	mdatii7octok
	inc	ecx
	cmp	ebx,1000000o
	jae	mdatii7octok
	inc	ecx
	cmp	ebx,100000o
	jae	mdatii7octok
	inc	ecx
	cmp	ebx,10000o
	jae	mdatii7octok
	inc	ecx
	cmp	ebx,1000o
	jae	mdatii7octok
	inc	ecx
	cmp	ebx,100o
	jae	mdatii7octok
	inc	ecx
	cmp	ebx,10o
	jae	mdatii7octok
	inc	ecx
mdatii7octok:
	cmp	mdatisign,2
	je	mdatii7onosign
	cmp	mdatisign,3
	je	mdatii7onosign
	dec	ecx
	jecxz	mdatii7onofill
mdatii7onosign:
	or	ecx,ecx
	jle	mdatii7onofill
	mov	al,misc_menufieldbkgchar
	rep
	putcell
mdatii7onofill:
	mov	al,'-'
	cmp	mdatisign,2
	je	mdatii7onosign2
	cmp	mdatisign,3
	je	mdatii7onosign2
	cmp	mdatisign,0
	je	mdatii7ominus
	mov	al,'+'
mdatii7ominus:
	putcell
mdatii7onosign2:
	shr	eax,(CELLSIZE-2)*4
	mov	ch,ah
	mov	eax,ebx
	call	_printoct_dword
	add	edi,addededi
	mov	ah,ch
	shl	eax,(CELLSIZE-2)*4
	mov	al,'o'
	putcell
	sub	edi,CELLSIZE
	jmp	mdatii7end
mdatinotoct:

	cmp	mdatibase,4
	jne	mdatinotbin			; binary?
	mov	edx,ecx
	lea	ecx,[ebx-1]
	xor	ebx,ebx
	bsr	ebx,dword ptr [esi]
	sub	ecx,ebx
	mov	ebx,[esi]
	add	esi,edx
mdatii7binok:
;	 cmp	 mdatisign,2
;	 je	 mdatii7bnosign
;	 cmp	 mdatisign,3
;	 je	 mdatii7bnosign
;	 dec	 ecx
;	 jecxz	 mdatii7bnofill
;mdatii7bnosign:
	or	ecx,ecx
	jle	mdatii7bnofill
	mov	al,misc_menufieldbkgchar
	rep
	putcell
mdatii7bnofill:
;	 mov	 al,'-'
;	 cmp	 mdatisign,2
;	 je	 mdatii7bnosign2
;	 cmp	 mdatisign,3
;	 je	 mdatii7bnosign2
;	 cmp	 mdatisign,0
;	 je	 mdatii7bminus
;	 mov	 al,'+'
;mdatii7bminus:
;	 stosw
;mdatii7bnosign2:
	shr	eax,(CELLSIZE-2)*4
	mov	ch,ah
	mov	eax,ebx
	call	_printbin_dword
	add	edi,addededi
	cmp	mdatisign,4	; don't output trailing 'b'
	je	mdatii7end
	mov	ah,ch
	shl	eax,(CELLSIZE-2)*4
	mov	al,'b'
	putcell
	sub	edi,CELLSIZE
	jmp	mdatii7end
mdatinotbin:


mdatii7end:
	cld
	mov	[esp+4],esi
	cmp	mdaticursoradd,-1
	je	mdatii7nocursor
	cmp	mdaticursoradd,-2
	je	mdatii7nocursor
	mov	eax,mdaticursorpos
	add	eax,mdaticursoradd
	add	eax,itemxpos
	add	eax,mx
	cmp	itemtype,7
	jne	mdatii7nonumber
	dec	al
mdatii7nonumber:
        mov     dl,al
	mov	eax,itemypos
	add	eax,my
        mov     dh,al
        call    _setcursorpos
mdatii7nocursor:
	popad
	jmp	mdatinofield

mdatiitnot7:
	jecxz	mdatibufflop1end2
	push	eax ecx edi
	mov	ecx,mdaticurrentlength
	cmp	ecx,0
	jne	mdatil1
	xor	al,al
	mov	edi,esi
	mov	ecx,-1
	repne	scasb
	neg	ecx
	sub	ecx,2
mdatil1:
	cmp	ecx,ebx
	pop	edi ecx eax
	jbe	mdatibufflop1
;	 dec	 ebx
;;	  jl	  mdatibufflop1overflow
;	 mov	 mdatioverflow,1
mdatibufflop1:
	lodsb
	cmp	mdaticurrentlength,0
	jne	mdaticlnz
	or	al,al
	jz	mdatibufflop1end
	dec	ebx
	jl	mdatibufflop1overflow
	cmp	fieldtype,ITEM_SHEXSTRING
	je	mdatihexstring
	cmp	fieldtype,ITEM_NHEXSTRING
	je	mdatihexstring
	putcell
	jmp	mdatistring
mdatihexstring:
	cmp	mdatibufflop11st,0
	jne	mdatibufflop1n1st
	dec	ebx
	jl	mdatibufflop1overflow
	push	eax
	mov	al,' '
	putcell
	pop	eax
mdatibufflop1n1st:
	mov	mdatibufflop11st,0
	push	eax
	shr	al,4
	cmp	al,10
	sbb	al,69h
	das
	putcell
	pop	eax
	dec	ebx
	jl	mdatibufflop1overflow
	and	al,0fh
	cmp	al,10
	sbb	al,69h
	das
	putcell
mdatistring:
	loop	mdatibufflop1
	jmp	mdatibufflop1end2
mdaticlnz:
	dec	ebx
	jl	mdatibufflop1overflow
	cmp	fieldtype,ITEM_SHEXSTRING
	je	mdatihexstring2
	cmp	fieldtype,ITEM_NHEXSTRING
	je	mdatihexstring2
	putcell
	jmp	mdatistring2
mdatihexstring2:
	cmp	mdatibufflop11st,0
	jne	mdatibufflop1n1st2
	dec	ebx
	jl	mdatibufflop1overflow
	push	eax
	mov	al,' '
	putcell
	pop	eax
mdatibufflop1n1st2:
	mov	mdatibufflop11st,0
	push	eax
	shr	al,4
	cmp	al,10
	sbb	al,69h
	das
	putcell
	pop	eax
	dec	ebx
	jl	mdatibufflop1overflow
	and	al,0fh
	cmp	al,10
	sbb	al,69h
	das
	putcell
mdatistring2:
	dec	mdaticurrentlength
	jz	mdatibufflop1end
	loop	mdatibufflop1
mdatibufflop1end2:
	inc	ecx
	jmp	mdatibufflop1end
mdatibufflop1overflow:
	mov	mdatioverflow,1
mdatibufflop1end:
	push	ecx
	mov	ecx,ebx
	cmp	ecx,0
	jle	mdatinofill
	mov	al,misc_menufieldbkgchar
	rep
	putcell
mdatinofill:
	pop	ecx
	cmp	mdatioverflow,1
	jne	mdatinooverflow
	mov	ah,mdatiitemcolor
	shl	eax,(CELLSIZE-2)*4
	mov	al,''
	putcell
	jmp	mdatiofok
mdatinooverflow:
	mov	al,' '
	putcell
mdatiofok:
	lea	edi,[esi+ecx+2*4]
	cmp	ebp,edx
	jne	mdatinotcurrent2
	cmp	mdaticursoradd,-1
	je	mdatinotcurrent2
	cmp	mdaticursoradd,-2
	je	mdatinotcurrent2
	mov	eax,mdaticursorpos
	add	eax,mdaticursoradd
	add	eax,itemxpos
	add	eax,mx
        push    edx
        mov     dl,al
	mov	eax,itemypos
	add	eax,my
        mov     dh,al
        call    _setcursorpos
        pop     edx
mdatinotcurrent2:
	inc	ebp			; inc item-number being drawn

;	push	ecx
;	mov	eax,my
;	add	eax,itemypos
;	mov	ecx,1
;	call	_updaterows
;	pop	ecx

	jmp	mdatilop0

mdatichksel:
	cmp	ebp,edx 		; set cursor only if item is current
	jne	mdatichknosel
	push	eax ebx ecx esi
	cmp	mdaticursoradd,-1
	je	mdatii11nocursor
	cmp	mdaticursoradd,-2
	je	mdatii11nocursor
	call	_setoverwritecursor
	mov	esi,[esp+4*4+1*4]	; get esi from stack
	push	ebp
	call	_menugetiteminfo
	mov	eax,mdaticursorpos
	add	eax,mdaticursoradd
	add	eax,itemxpos
	add	eax,mx
	add	al,1
        push    edx
        mov     dl,al
	mov	eax,itemypos
	add	eax,my
        mov     dh,al
        call    _setcursorpos
        pop     edx
mdatii11nocursor:
	pop	esi ecx ebx eax
mdatichknosel:
	shl	eax,(CELLSIZE-2)*4
	mov	ecx,eax
	movzx	eax,word ptr [esi]
	add	esi,4
	add	esi,eax
	xor	eax,eax
	mov	ah,mdatitextc
	shl	eax,(CELLSIZE-2)*4
	mov	al,'['
	putcell
	xchg	eax,ecx
	mov	al,' '
	cmp	byte ptr [esi-1],0
	je	mdatichkfalse
	mov	al,'X'
mdatichkfalse:
	putcell
	xchg	eax,ecx
	mov	al,']'
	putcell


mdatinofield:
	lea	edi,[esi+1+2*4] 	; add 1 for buffers trailing zero
	inc	ebp
	jmp	mdatilop0

mdatidone:
	popad
	ret	3*4


;
; PopUpMenu
; In:	ESI -> PopUpMenuStructure
; Out:	DL = Item selected (1 = first item)
Width		equ	byte ptr [esi]
Height		equ	byte ptr [esi+1]
Selectables	equ	byte ptr [esi+2]
VisSelectables	equ	byte ptr [esi+3]
DefaultItem	equ	byte ptr [esi+4]
_popupmenu:
	pushad
	call	_hidecursor
	push	offset keybarempty
	call	_drawbottomrow
	call	_getcursorpos
	movzx	edi,dh
	inc	edi
	mov	eax,edi
	add	al,Height
	mov	ebx,numberofrows
	cmp	numberofwindows,2
	jne	_gluhj1
	cmp	activewindow,0
	jne	_gluhj1
	shr	ebx,1
_gluhj1:
	cmp	al,bl
	jbe	_putit1
	sub	edi,1
	movzx	eax,Height
	sub	edi,eax
	jnc	_putit1
	mov	edi,0
_putit1:
	mov	___popupmenu_y,edi
	shl	edi,4+(CELLSIZE/2)
	lea	edi,[edi*4+edi]
	add	edi,textscreenstart
	mov	eax,80
	sub	al,Width
	shr	eax,1
	shl	eax,CELLSIZE/2
	add	edi,eax
	movzx	eax,Width
	movzx	ebx,Height
	mov	dh,menu_menus_c
	mov	dl,1
	push	esi
	add	esi,4
	push	edi
	mov	edi,esi
	push	eax
	xor	al,al
	mov	ecx,65535
	repne	scasb
	repne	scasb		; search past selectable-table too
	pop	eax
	mov	esi,edi
	pop	edi
	call	_draw_plate
	add	edi,(80+1)*CELLSIZE
	pop	esi
	push	esi edi
	add	edi,1*CELLSIZE
	push	edi
	xor	al,al
	mov	edi,esi
	add	edi,4
	mov	ecx,65535
	xor	al,al
	repne	scasb
	repne	scasb
	repne	scasb
	mov	esi,edi
	pop	edi
	xor	ecx,ecx
	lodsb
_putstrlop1:
	stosb
	lodsb
	inc	ecx
	add	edi,CELLSIZE-1
	or	al,al
	jnz	_putstrlop1
	add	edi,80*CELLSIZE
	shl	ecx,CELLSIZE/2
	sub	edi,ecx
	xor	ecx,ecx
	lodsb
	or	al,al
	jnz	_putstrlop1
	pop	edi esi
	push	edi
	lea	edi,[esi+4]
	mov	ecx,65535
	xor	al,al
	repne	scasb
	mov	ebp,edi
	pop	edi
	mov	dl,DefaultItem
	mov	selection,dl
	add	edi,CELLSIZE/2          ; move to attribbyte
_selectionlop:
	mov	ecx,1
	push	edi ebp
_sellop1:
	inc	ebp
	cmp	byte ptr [ebp-1],1
	je	_selectable
	cmp	byte ptr [ebp-1],0
	je	_endofstrings
	add	edi,80*CELLSIZE
	jmp	_sellop1
_selectable:
	mov	al,menu_menus_c
	cmp	cl,selection
	jne	_not_active_selection1
	rol	al,4
_not_active_selection1:
	push	ecx
	movzx	ecx,Width
	sub	ecx,2
_sellop2:
	stosb
	add	edi,CELLSIZE-1
	loop	_sellop2
	add	edi,80*CELLSIZE
	movzx	eax,Width
	sub	eax,2
	shl	eax,CELLSIZE/2
	sub	edi,eax
	pop	ecx
	inc	ecx
	cmp	cl,VisSelectables
	jbe	_sellop1
_endofstrings:
	pop	ebp edi
_sel_pull_key:

	pushad
	mov	eax,___popupmenu_y
	movzx	ecx,Height
	call	_updaterows
	popad

	call	_getkey
	cmp	Selectables,0
	je	_popad&ret
	cmp	ah,72
	jne	_sel_not_up
	cmp	selection,1
	jbe	_sel_not_up
	dec	selection
	jmp	_selectionlop
_sel_not_up:
	cmp	ah,80
	jne	_sel_not_down
	mov	al,VisSelectables
	cmp	selection,al
	jae	_sel_pull_key
	inc	selection
	jmp	_selectionlop
_sel_not_down:
	push	esi
	add	esi,4				; skip to DefaultItem
	mov	cl,0
_checkkeyslop:
	inc	esi
	inc	cl
	cmp	byte ptr [esi],0
	je	_chekenter
	cmp	ah,[esi]
	jne	_chek2ndscancode
	mov	selection,cl
	jmp	_selected_
_chek2ndscancode:
	inc	esi
	cmp	ah,[esi]
	jne	_checkkeyslop
	mov	selection,cl
	jmp	_selected_
_chekenter:
	pop	esi
	cmp	al,13
	jne	_sel_pull_key
	push	esi		; just laziness... :)
_selected_:
	pop	esi
	popad
	mov	dl,selection
	ret


;
; In: EDI -> Address to start writing to
;     ESI -> Platehead
;     EAX = Plate-width
;     EBX = Plate-height
;     DH  = Color
;     DL  = 1 if platehead, 0 if no platehead
; WARNING!!!!!!!!!!!!! DO NOT USE DL=0!!!! You won't get a solid topline!
_draw_plate:
	pushfd
	pushad
	cld
	xor	ecx,ecx
	cmp	dl,1
	jne	_noplatehead
	mov	ecx,-1
	push	esi eax
_longerhead:
	lodsb
	inc	ecx
	or	al,al
	jnz	_longerhead
	pop	eax esi
_noplatehead:
	mov	ebp,eax
	sub	ebp,ecx
	shr	ebp,1
	shl	ebp,CELLSIZE/2
	add	ebp,edi
	sub	ebp,2*CELLSIZE

	push	eax
	mov	al,menu_menus_c
	shl	eax,CELLSIZE*4
	mov	al,''
	putcell
	mov	ecx,eax
	pop	eax

	push	eax
	sub	eax,2			; subtract first and last byte
					;  ('' & '')
_putplatetop_lop:
	cmp	edi,ebp
	jne	_not_at_head
	mov	ebp,eax
	mov	eax,ecx
	mov	al,''
	putcell
	mov	al,' '
	putcell
	cmp	dl,0
	je	_head_is_put
_puthead:
	lodsb
	or	al,al
	jz	_head_is_put
	dec	ebp
	putcell
	jmp	_puthead
_head_is_put:
	mov	al,' '
	putcell
	mov	al,''
	putcell
	mov	eax,ebp
	sub	eax,2+2
	xor	ebp,ebp
_not_at_head:
	push	eax
	mov	eax,ecx
	mov	al,''
	putcell
	pop	eax
	dec	eax
	jnz	_putplatetop_lop

	mov	eax,ecx
	mov	al,''
	putcell

	pop	eax
	sub	ebx,2			; subtract first and last byte
_putplatesides_lop:			;  ('' & '')
	mov	ebp,80
	sub	ebp,eax
	shl	ebp,CELLSIZE/2
	add	edi,ebp
	xchg	eax,ecx
	mov	al,''
	putcell
	push	ecx
	mov	al,' '
	sub	ecx,2
	rep
	putcell
	pop	ecx
	mov	al,''
	putcell
	xchg	eax,ecx
	dec	ebx
	jnz	_putplatesides_lop

	mov	ebp,80
	sub	ebp,eax
	shl	ebp,CELLSIZE/2
	add	edi,ebp
	push	eax
	mov	eax,ecx
	mov	al,''
	putcell
	pop	eax
	sub	eax,2			; subtract first and last byte
					;  ('' & '')
_putplatebottom_lop:
	push	eax
	mov	eax,ecx
	mov	al,''
	putcell
	pop	eax
	dec	eax
	jnz	_putplatebottom_lop

	mov	eax,ecx
	mov	al,''
	putcell

	popad
	popfd
	ret


;
; Returns offset to the active window's headline, e.g 25*80*2+b8000h-_code32a
; Out:	EDI = Offset-address from _code32a to headline
;	ECX = Row headline starts on
_get_screen_offset:
	push	eax
	mov	edi,textscreenstart
	cmp	numberofwindows,2
	jne	_gso2
	cmp	activewindow,1
	jne	_gso2
	mov	eax,numberofrows
	shr	eax,1
	mov	ecx,eax
	shl	eax,4+(CELLSIZE/2)
	lea	eax,[eax*4+eax]
	add	edi,eax
	pop	eax
	ret
_gso2:
	add	edi,80*CELLSIZE         ; we have a row at the top!
	mov	ecx,1
	pop	eax
	ret


;
; In:	ESI = Number of bytes to be deleted
_delete_x_bytes:
	pushad
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	shl	ebx,2
	cmp	filesize[ebp*4],esi
	jb	popad&stc&ret
	add	freehimemory,esi
	sub	filesize[ebp*4],esi
	mov	eax,filebufferptr[ebp*4]
        xor     ecx,ecx
___decvariableslop:
	cmp	filebufferptr[ecx*4],eax
	jbe	___notaboveactivefile
	sub	filebufferptr[ecx*4],esi
___notaboveactivefile:
	inc	ecx
	cmp	ecx,numberoffiles
	jb	___decvariableslop
	mov	edx,esi
	mov	edi,filebufferptr[ebp*4]
	add	edi,filebufferpos[ebp*8+ebx]
	mov	ecx,clipptr
	add	ecx,clipsize
	sub	ecx,edi
	sub	ecx,edx
	mov	esi,edi
	add	esi,edx
	rep	movsb
	sub	clipptr,edx
	mov	eax,filesize[ebp*4]
	cmp	filebufferpos[ebp*8+ebx],eax
	jbe	___didnotdellastbyte1
	sub	filebufferpos[ebp*8+ebx],edx	; mov fbpos,filesize-1 ?
___didnotdellastbyte1:
	neg	ebx
	add	ebx,4
	cmp	filebufferpos[ebp*8+ebx],eax
	jbe	___didnotdellastbyte2
	sub	filebufferpos[ebp*8+ebx],edx
___didnotdellastbyte2:
	mov	filechanged[ebp],1

	neg	ebx
	add	ebx,4
	cmp	edx,1
	ja	_clipnicht0
	cmp	marked,2
	jne	_clipnicht0
	mov	edx,filebufferptr[ebp*4]
	add	edx,filebufferpos[ebp*8+ebx]
	mov	eax,mark1ptr
	cmp	eax,mark2ptr
	ja	_mark1_above
	cmp	edx,mark1ptr
	jb	_lab1
	cmp	edx,mark2ptr
	ja	_clipnicht0
	cmp	markedsize,0
	je	_clipnicht0
	dec	markedsize
	dec	mark2ptr
	jmp	_clipnicht0
_lab1:
	dec	mark1ptr
	dec	mark2ptr
	jmp	_clipnicht0
_mark1_above:
	cmp	edx,mark2ptr
	jb	_lab2
	cmp	edx,mark1ptr
	ja	_clipnicht0
	cmp	markedsize,0
	je	_clipnicht0
	dec	markedsize
	dec	mark1ptr
	jmp	_clipnicht0
_lab2:
	dec	mark2ptr
	dec	mark1ptr
	jmp	_clipnicht0

_clipnicht0:
	jmp	popad&clc&ret


;
; In:
;	ESI == number of bytes to insert
; Out:
;	CF == 1 if error
;	CF == 0 if no error
; Note: WARNING! If HexIt runs out of memory and has to allocate more,
;	memory pointers may have changed after a call to this routine.
;	Therefore, always reload pointers after calling it!
_insert_x_bytes:
	pushad
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	shl	ebx,2
	add	esi,clipsize
	cmp	freehimemory,esi	   ; check if there is mem free
;	jbe	popad&stc&ret

	ja	@@memok
	pushad
	mov	eax,esi
	sub	eax,freehimemory
	call	_reallocmainmem
	popad
	jc	popad&stc&ret
@@memok:

	sub	esi,clipsize
	sub	freehimemory,esi
	add	filesize[ebp*4],esi
	mov	eax,filebufferptr[ebp*4]
	mov	edx,eax 		   ; highest basepointer
	mov	edi,ebp 		   ; file# with highest baseptr
        xor     ecx,ecx
___incvariableslop:
	cmp	filebufferptr[ecx*4],eax
	jb	___notaboveactivefile2
	ja	___aboveactivefile2
	cmp	ecx,ebp
	je	___notaboveactivefile2
___aboveactivefile2:
	add	filebufferptr[ecx*4],esi
	cmp	filebufferptr[ecx*4],edx
	jb	___notaboveactivefile2	   ; no suitable name really
	mov	edx,filebufferptr[ecx*4]   ; store highest baseptr
	mov	edi,ecx 		   ; store file# with highest...
___notaboveactivefile2:
	inc	ecx
	cmp	ecx,numberoffiles
	jb	___incvariableslop
	add	clipptr,esi
	mov	edx,esi
	mov	esi,filebufferptr[ebp*4]
	add	esi,filebufferpos[ebp*8+ebx]
	add	esi,edx
	mov	ecx,clipptr
	add	ecx,clipsize
	mov	edi,ecx
	sub	ecx,esi
	mov	esi,edi
	sub	esi,edx
	inc	ecx
	std
	rep	movsb
	cld
	mov	edi,filebufferptr[ebp*4]
	add	edi,filebufferpos[ebp*8+ebx]
	mov	al,0
	mov	ecx,edx
	rep	stosb

	cmp	edx,1
	ja	_clipnicht1
	cmp	marked,2
	jne	_clipnicht1
	mov	edx,filebufferptr[ebp*4]
	add	edx,filebufferpos[ebp*8+ebx]
	mov	eax,mark1ptr
	cmp	eax,mark2ptr
	ja	_mark1_above_2
	cmp	edx,mark1ptr
	jbe	_lab3
	cmp	edx,mark2ptr
	ja	_clipnicht1
	inc	markedsize
	inc	mark2ptr
	jmp	_clipnicht1
_lab3:
	inc	mark1ptr
	inc	mark2ptr
	jmp	_clipnicht1
_mark1_above_2:
	cmp	edx,mark2ptr
	jbe	_lab4
	cmp	edx,mark1ptr
	ja	_clipnicht1
	inc	markedsize
	inc	mark1ptr
	jmp	_clipnicht1
_lab4:
	inc	mark2ptr
	inc	mark1ptr
	jmp	_clipnicht1

_clipnicht1:
	mov	filechanged[ebp],1
	jmp	popad&clc&ret


;
_saveactivefile:
	pushad
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	shl	ebp,7
	mov	edx,offset filename
	add	edx,ebp
	shr	ebp,7
	mov	ax,1
	mov	fileattribs,020h	; set archive flag
	call	_getfileattribs
	jc	_createit
	mov	fileattribs,cx
	test	cx,7
	jz	_createit
	push	edx
	mov	esi,offset saverostr
	call	_putbothscreens
	call	_popupmenu
	call	_setinsertcursor
	cmp	insert,1
	je	_nju3
	call	_setoverwritecursor
_nju3:
	xchg	eax,edx
	pop	edx
	cmp	al,1
	jne	popad&stc&ret
	xor	ecx,ecx
	call	_setfileattribs
_createit:
	push	eax edx
	call	_createfile
	jnc	_createdok2
	pop	edx eax
	jmp	_createerror
_createdok2:
	mov	edx,filebufferptr[ebp*4]
	mov	ecx,filesize[ebp*4]
	call	_writefile
	pushfd
	call	_closefile
	popfd
	pop	edx eax
	jc	_createerror
	mov	filechanged[ebp],0
	jmp	_createdok
_createerror:
	push	edx
	call	_cantcreatefile
	cmp	dl,1
	pop	edx
	je	_createit
	mov	filechanged[ebp],1
	cmp	al,1
	jne	popad&stc&ret
	mov	cx,fileattribs
	call	_setfileattribs
	jmp	popad&stc&ret
_createdok:
	cmp	al,1
	jne	popad&stc&ret
	mov	cx,fileattribs
	call	_setfileattribs
	jmp	popad&clc&ret


;
; Out:	CF = 1 if some ERROR occured.
_savesetup:
	pushad
	mov	edx,offset configpath
	mov	cx,20h
	call	_setfileattribs
	call	_createfile
	jnc	_savefileopened
	mov	esi,offset openfileerrstr
	call	_popupmenu
	call	_putbothscreens
	jmp	popad&stc&ret
_savefileopened:
	mov	ecx,bytesincfg		; write some bytes
	add	ecx,4			; we will write the first dword too!
	mov	edx,offset configcontents
	call	_writefile
	jnc	_savefilewritten
	mov	esi,offset writefileerrstr
	call	_popupmenu
	call	_putbothscreens
	jmp	popad&stc&ret
_savefilewritten:
	call	_closefile		; close configfile
	mov	esi,offset firstconfigbyte
	mov	edi,offset oldconfig
	mov	ecx,bytesincfg
	rep	movsb
	mov	esi,offset configsavedstr
	call	_popupmenu
	call	_putbothscreens
	jmp	popad&clc&ret


;
_saveconfigwithnopopups:
	pushad
	mov	edx,offset configpath
	mov	cx,20h
	call	_setfileattribs
	call	_createfile
	jc	popad&stc&ret
	mov	ecx,bytesincfg		; write some bytes
	add	ecx,4			; we will write the first dword too!
	mov	edx,offset configcontents
	call	_writefile
	pushfd
	call	_closefile		; close configfile
	popfd
	jc	popad&stc&ret
	mov	esi,offset firstconfigbyte
	mov	edi,offset oldconfig
	mov	ecx,bytesincfg
	rep	movsb
	jmp	popad&clc&ret


;
_putscreen_hex:
	mov	brightlast,0
	pushad
	movzx	ebx,activewindow		; make sure we use the
	movzx	ebp,activefile[ebx]		;  correct variables
	shl	ebx,2

_checkifbelowscreen:
	mov	eax,screenoffset[ebp*8+ebx]	; check if filebufferpos
	call	_getnumdatarows 		;  is greater than screenoffset
	shl	ecx,4
	add	eax,ecx
	cmp	eax,filebufferpos[ebp*8+ebx]
	ja	_notbelowscreen
	add	screenoffset[ebp*8+ebx],16
	jmp	_checkifbelowscreen
_notbelowscreen:				; check if filebufferpos
	mov	eax,screenoffset[ebp*8+ebx]	;  is less than screenoffset
	cmp	eax,filebufferpos[ebp*8+ebx]
	jbe	_notabovescreen
	sub	screenoffset[ebp*8+ebx],16
	jnc	_notbelowscreen
	mov	screenoffset[ebp*8+ebx],0
_notabovescreen:

	mov	eax,filebufferpos[ebp*8+ebx]	; move to correct pos
	sub	eax,screenoffset[ebp*8+ebx]	;  on screen
	and	eax,0fh
	call	_get_screen_offset
	pushad					; ok, now put statusbar
	mov	eax,ebx 			; print filepos
	mov	dh,headline_c
	mov	ebx,filebufferpos[ebp*8+eax]
	call	_printhex_dword
	add	edi,8*CELLSIZE
	mov	ah,dh
	shl	eax,(CELLSIZE-2)*4
	mov	al,'/'
	putcell

	mov	eax,ebx 			; print filesize

	mov	ebx,filesize[ebp*4]
	call	_printhex_dword

	push	ebx
	mov	ebx,100
	mul	ebx
	push	eax edx

	add	edi,8*CELLSIZE 			; print "Text" or "Hex"
	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	putcell
	mov	esi,offset textmsg
	movzx	ebx,activewindow
	cmp	field[ebp*2+ebx],0
	jne	_print_field
	mov	esi,offset hexmsg
_print_field:
	lodsb
	putcell
	lodsb
	putcell
	lodsb
	putcell
	lodsb
	putcell
	mov	al,' '
	putcell
	putcell

	cmp	nibblemove,0
	je	__putscreen_hexmode_notnibblemove
	mov	al,''
__putscreen_hexmode_notnibblemove:
	putcell

	mov	al,' '
	putcell
	putcell


	pop	edx eax
	pop	ebx
	or	ebx,ebx
	jz	dontdiv
	idiv	ebx
dontdiv:
	call	_putpercent			; print percentage

	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	putcell

	mov	esi,offset filename
	mov	edx,ebp
	shl	edx,7
	add	esi,edx
	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	cmp	filechanged[ebp],1
	jne	_dont_put_star
	mov	al,'*'
	jmp	_put_marker
_dont_put_star:
	mov	al,' '
_put_marker:
	putcell
	mov	ecx,-1
	push	esi
_chkpathlength:
	lodsb
	inc	ecx
	or	al,al
	jnz	_chkpathlength
	pop	esi
	mov	edx,26				; maxlength of filename&path
	sub	edx,ecx
	jae	_putfilename&path
	xor	edx,edx
	add	esi,ecx
	sub	esi,23				; maxlength of filename&path-3
	mov	al,'.'
	putcell
	putcell
	putcell
_putfilename&path:
	lodsb
	putcell
	or	al,al
	jnz	_putfilename&path
	mov	al,' '
	lea	ecx,[edx+1]
	rep
	putcell

	push	ebx
	movzx	ebx,activewindow
	shl	ebx,2
	mov	ebx,filebufferpos[ebp*8+ebx]
	cmp	ebx,filesize[ebp*4]
	jb	putstatusdecl1
	xor	bl,bl
	jmp	putstatusdecl2
putstatusdecl1:
	add	ebx,filebufferptr[ebp*4]
	mov	bl,[ebx]
putstatusdecl2:

	mov	ch,ah
	mov	al,bl
	cbw
	xor	al,ah
	sub	al,ah
	mov	ah,ch
	xor	ecx,ecx
	cmp	al,100
	jae	__puthexstatus_dec_1
	inc	ecx
	cmp	al,10
	jae	__puthexstatus_dec_1
	inc	ecx
__puthexstatus_dec_1:
	push	eax
	mov	al,' '
	rep
	putcell

	mov	al,' '
	test	bl,080h
	jns	__puthexstatus_dec2_ns
	mov	al,'-'
__puthexstatus_dec2_ns:
	putcell

	pop	eax
	mov	ch,headline_c
	call	_printdec_byte
	add	edi,addededi

	mov	ecx,1
	cmp	bl,100
	jae	__puthexstatus_dec_2
	inc	ecx
	cmp	bl,10
	jae	__puthexstatus_dec_2
	inc	ecx
__puthexstatus_dec_2:

	mov	al,' '
	rep
	putcell

	mov	al,bl
	mov	ch,headline_c
	call	_printdec_byte

	add	edi,addededi
	mov	al,' '
	putcell

	test	bl,80h
	setnz	al
	add	al,'0'
	putcell
	test	bl,40h
	setnz	al
	add	al,'0'
	putcell
	test	bl,20h
	setnz	al
	add	al,'0'
	putcell
	test	bl,10h
	setnz	al
	add	al,'0'
	putcell
	test	bl,8h
	setnz	al
	add	al,'0'
	putcell
	test	bl,4h
	setnz	al
	add	al,'0'
	putcell
	test	bl,2h
	setnz	al
	add	al,'0'
	putcell
	test	bl,1h
	setnz	al
	add	al,'0'
	putcell
	pop	ebx
	popad
	add	edi,80*CELLSIZE

	push	eax				; put active-msg if ok
	mov	ah,active_msg_c
	shl	eax,(CELLSIZE-2)*4
	mov	ecx,8
	mov	esi,offset inactivemsg
	cmp	trulyactive,1
	jne	_putactive_lop
	mov	esi,offset activemsg
_putactive_lop:
	lodsb
	putcell
	loop	_putactive_lop

	mov	ah,bkg_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	putcell
	putcell
	pop	eax
	mov	ebx,0				; put index-digits above
	mov	ecx,4				;  hexfield
	movzx	esi,activewindow
_putindex_lop0:
	push	ecx
	mov	ecx,4
_putindex_lop1:
	cmp	ebx,eax
	jne	_not_active_index
	mov	dh,dark_indexdigit_c
	cmp	field[ebp*2+esi],0	       ; determine correct color
	jne	_active_index
	mov	dh,light_indexdigit_c
	jmp	_active_index
_not_active_index:
	mov	dh,orig_indexdigit_c
_active_index:
	call	_printhex_byte
	inc	bx
	add	edi,2*CELLSIZE
	push	eax
	mov	ah,bkg_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	pop	eax
	loop	_putindex_lop1
	push	eax
	mov	ah,bkg_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	pop	eax
	pop	ecx
	loop	_putindex_lop0

	xchg	eax,ebx			; (filebufferpos&0fh) now in ebx
	mov	ecx,16			; put above textfield
	mov	ah,bkg_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	mov	eax,0
_putindex_lop2:
	cmp	eax,ebx
	jne	_not_active_index2
	mov	dh,dark_indexdigit_c
	cmp	field[ebp*2+esi],1	      ; determine correct color
	jne	_active_index2
	mov	dh,light_indexdigit_c
	jmp	_active_index2
_not_active_index2:
	mov	dh,orig_indexdigit_c
_active_index2:
	call	_printhex_nibble
	inc	al
	add	edi,1*CELLSIZE
	loop	_putindex_lop2

	call	_get_screen_offset	      ; put address-field
	add	edi,80*2*CELLSIZE

	shl	esi,2			; mul esi,4 (for screenoffset-
					;  addressing with win-index...)

	mov	ebx,screenoffset[ebp*8+esi]
	call	_getnumdatarows
__putaddress_lop:
	mov	eax,filesize[ebp*4]
	cmp	ebx,eax 			; check if at eof
	ja	_nomore_addresses		; if so, then jump
	mov	eax,filebufferpos[ebp*8+esi]
	sub	eax,ebx
	cmp	eax,0fh
	ja	_not_active_baseaddress
	mov	dh,light_address_c
	jmp	_activebase
_not_active_baseaddress:
	mov	dh,orig_address_c
_activebase:
	call	_printhex_dword
	mov	ah,bkg_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	add	edi,8*CELLSIZE
	putcell
	putcell
	putcell
	add	ebx,10h
	add	edi,(80-11)*CELLSIZE
	loop	__putaddress_lop
	jmp	_addresses_are_put
_nomore_addresses:
	call	_getnumdatarows 	; only CX here!!!!!!!!!!!!!!!!!!!!!!!!!!
					; put spaces to hide rest of
					; nonexisting addresses
	mov	eax,ebx
	mov	ebx,screenoffset[ebp*8+esi]
	sub	eax,ebx
	shr	eax,4
	sub	ecx,eax
	mov	al,bkg_c
	shl	eax,(CELLSIZE)*4
__clear_addresses_lop:
	putcell
	putcell
	putcell
	putcell
	putcell
	putcell
	putcell
	putcell

	putcell
	putcell
	putcell

	add	edi,80*CELLSIZE-8*CELLSIZE-3*CELLSIZE
	loop	__clear_addresses_lop

_addresses_are_put:

	movzx	eax,activewindow	; mul eax,4 (for screenoffset-
	shl	eax,2			;  addressing with win-index...)

	mov	esi,filebufferptr[ebp*4]	; main putscreen-lop
	add	esi,screenoffset[ebp*8+eax]
	call	_get_screen_offset
	add	edi,(80*2+10)*CELLSIZE
	call	_getnumdatarows 	; only CX here!!!!!!!!!!!!!!!!!!!!!!!!!!
__putscreen_lop0:
	push	ecx
	mov	ecx,16				; put hex-field
__puthex_lop0:
	test	cl,3
	jnz	_no_quad
	add	edi,1*CELLSIZE
	cmp	cl,16
	je	_no_quad
	mov	ah,bkg_c
	push	ebx
	push	edx
	cmp	marked,0
	je	_put_prequad_space
	cmp	mark1file,bp
	jne	_put_prequad_space
	mov	edx,mark2ptr
	cmp	marked,2
	je	_marked_2_gnu1
	movzx	edx,activewindow
	shl	edx,2
	mov	edx,filebufferpos[ebp*8+edx]
	add	edx,filebufferptr[ebp*4]
_marked_2_gnu1:
	mov	ebx,mark1ptr
	cmp	ebx,edx
	ja	_m1more
	cmp	esi,ebx
	jbe	_put_prequad_space
	cmp	esi,edx
	ja	_put_prequad_space
	mov	ah,marked_c
	jmp	_put_prequad_space
_m1more:
	cmp	esi,edx
	jbe	_put_prequad_space
	cmp	esi,ebx
	ja	_put_prequad_space
	mov	ah,marked_c
_put_prequad_space:
	shl	eax,(CELLSIZE-2)*4
	pop	edx
	pop	ebx
	mov	al,' '
	sub	edi,CELLSIZE
	putcell
_no_quad:
	push	ecx
	movzx	ecx,activewindow	; mul ecx,4 (for screenoffset-
	shl	ecx,2			;  addressing with win-index...)
	mov	edx,filebufferptr[ebp*4]
	add	edx,filebufferpos[ebp*8+ecx]
	cmp	esi,edx
	jne	_notcurrentpos1
	mov	dh,dark_hexfield_c
	movzx	ecx,activewindow
	cmp	field[ebp*2+ecx],0
	jne	_currentpos1
	mov	dh,light_hexfield_c
	pushad
	cmp	trulyactive,1
	jne	_noputcursor
	shl	ecx,2
	mov	eax,esi
	sub	eax,filebufferptr[ebp*4]
	sub	eax,screenoffset[ebp*8+ecx]
	mov	ebx,eax
	and	ebx,0fh
	shr	eax,4
	mov	dh,al
	call	_get_screen_offset
	add	dh,cl
	add	dh,2			; statusrow+indexrow
	mov	dl,screenxoffsets[ebx]
_not2ndwin_42:
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	cmp	nibble[ebp*2+ebx],0
	jne	_putcursor_1
	inc	dl
_putcursor_1:
	call	_setcursorpos
_noputcursor:
	popad
	jmp	_currentpos1
_notcurrentpos1:
	mov	dh,orig_hexfield_c
_currentpos1:

	push	eax
	push	ebx
	movzx	ecx,activewindow
	shl	ecx,2
	mov	eax,filebufferptr[ebp*4]
	add	eax,filebufferpos[ebp*8+ecx]
	cmp	marked,0
	je	_nonemarked
	cmp	mark1file,bp
	jne	_nonemarked
	cmp	marked,1
	je	_marked1
	mov	ebx,mark1ptr
	cmp	mark2ptr,ebx
	ja	_abovemark1
	cmp	esi,mark1ptr
	ja	_nonemarked
	cmp	esi,mark2ptr
	jb	_nonemarked
	mov	dh,marked_c
	jmp	_nonemarked
_abovemark1:
	cmp	esi,mark1ptr
	jb	_nonemarked
	cmp	esi,mark2ptr
	ja	_nonemarked
	mov	dh,marked_c
	jmp	_nonemarked
_marked1:
	cmp	eax,mark1ptr
	ja	_a1
	cmp	mark1ptr,esi
	jb	_nonemarked
	cmp	esi,eax
	jb	_nonemarked
	mov	dh,marked_c
	jmp	_nonemarked
_a1:
	cmp	mark1ptr,esi
	ja	_nonemarked
	cmp	esi,eax
	ja	_nonemarked
	mov	dh,marked_c
	jmp	_nonemarked
_nonemarked:
	pop	ebx
	pop	eax


	lodsb
	mov	ebx,filebufferptr[ebp*4]	; check if at eof
	add	ebx,filesize[ebp*4]
	inc	ebx
	cmp	esi,ebx
	jb	_not_eof_yet

	cmp	brightlast,1
	je	notlast
	push	eax
	mov	eax,filebufferpos[ebp*8+ecx]
	cmp	eax,filesize[ebp*4]
	pop	eax
	jne	notlast
	shr	ecx,2
	mov	ah,light_hexfield_c
	cmp	field[ebp*2+ecx],0
	je	inhexgnu2
	mov	ah,dark_hexfield_c
inhexgnu2:
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	mov	ah,bkg_c
	shl	eax,(CELLSIZE-2)*4
	mov	brightlast,1
	jmp	last
notlast:
	mov	ah,bkg_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '                          ; put space if at eof
	putcell
last:
	putcell
	putcell
	jmp	_no_hexput
_not_eof_yet:
	mov	ebx,eax
	call	_printhex_byte
	add	edi,3*CELLSIZE
	mov	ah,bkg_c
	mov	al,' '

	push	ebx
	push	edx
	cmp	marked,0
	je	_put_prequad_space2
	cmp	mark1file,bp
	jne	_put_prequad_space2
	mov	edx,mark2ptr
	cmp	marked,2
	je	_marked_2_gnu2
	movzx	edx,activewindow
	shl	edx,2
	mov	edx,filebufferpos[ebp*8+edx]
	add	edx,filebufferptr[ebp*4]
_marked_2_gnu2:
	mov	ebx,mark1ptr
	cmp	ebx,edx
	ja	_m1more2
	cmp	esi,ebx
	jbe	_put_prequad_space2
	cmp	esi,edx
	ja	_put_prequad_space2
	mov	ah,marked_c
	jmp	_put_prequad_space2
_m1more2:
	cmp	esi,edx
	jbe	_put_prequad_space2
	cmp	esi,mark1ptr
	ja	_put_prequad_space2
	mov	ah,marked_c
_put_prequad_space2:
	shl	eax,(CELLSIZE-2)*4
	pop	edx
	pop	ebx

	sub	edi,CELLSIZE
	putcell
_no_hexput:
	pop	ecx
	loop	__puthex_lop0

	sub	esi,16				; put text-field
	add	edi,2*CELLSIZE
	mov	ah,bkg_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	sub	edi,3*CELLSIZE
	putcell
	putcell
	putcell
	mov	ecx,16
__puttext_lop0:
	push	ecx
	movzx	ecx,activewindow	; mul ecx,4 (for screenoffset-
	shl	ecx,2			;  addressing with win-index...)
	mov	edx,filebufferptr[ebp*4]
	add	edx,filebufferpos[ebp*8+ecx]
	cmp	esi,edx
	jne	_notcurrentpos2
	mov	ah,dark_textfield_c
	movzx	ecx,activewindow
	cmp	field[ebp*2+ecx],1
	jne	_currentpos2
	mov	ah,light_textfield_c
	pushad
	cmp	trulyactive,1
	jne	_noputcursor2
	shl	ecx,2
	mov	eax,esi
	sub	eax,filebufferptr[ebp*4]
	sub	eax,screenoffset[ebp*8+ecx]
	mov	dl,al
	and	dl,0fh
	shr	eax,4
	mov	dh,al
	add	dh,2			; statusrow+indexrow
	add	dl,64
	call	_get_screen_offset
	add	dh,cl
	call	_setcursorpos
_noputcursor2:
	popad
	jmp	_currentpos2
_notcurrentpos2:
	mov	ah,orig_textfield_c
_currentpos2:

	push	ebx
	push	edx
	mov	edx,filebufferptr[ebp*4]
	add	edx,filebufferpos[ebp*8+ecx]
	cmp	marked,0
	je	_nonemarked_2
	cmp	mark1file,bp
	jne	_nonemarked_2
	cmp	marked,1
	je	_marked1_2
	mov	ebx,mark1ptr
	cmp	mark2ptr,ebx
	ja	_abovemark1_2
	cmp	esi,mark1ptr
	ja	_nonemarked_2
	cmp	esi,mark2ptr
	jb	_nonemarked_2
	mov	ah,marked_c
	jmp	_nonemarked_2
_abovemark1_2:
	cmp	esi,mark1ptr
	jb	_nonemarked_2
	cmp	esi,mark2ptr
	ja	_nonemarked_2
	mov	ah,marked_c
	jmp	_nonemarked_2
_marked1_2:
	cmp	edx,mark1ptr
	ja	_a1_2
	cmp	mark1ptr,esi
	jb	_nonemarked_2
	cmp	esi,edx
	jb	_nonemarked_2
	mov	ah,marked_c
	jmp	_nonemarked_2
_a1_2:
	cmp	mark1ptr,esi
	ja	_nonemarked_2
	cmp	esi,edx
	ja	_nonemarked_2
	mov	ah,marked_c
	jmp	_nonemarked_2
_nonemarked_2:
	pop	edx
	pop	ebx

	shl	eax,(CELLSIZE-2)*4

	lodsb
	mov	ebx,filebufferptr[ebp*4]	; check if at eof
	add	ebx,filesize[ebp*4]
	inc	ebx
	cmp	esi,ebx
	jb	_not_eof_yet2
	mov	al,20h				; put space if at eof
_not_eof_yet2:
	putcell
	pop	ecx
	loop	__puttext_lop0
	add	edi,10*CELLSIZE
	pop	ecx
	loop	__putscreen_lop0
	call	_resetmouse

	call	_get_screen_offset
	mov	eax,ecx
	call	_getnumdatarows
	add	ecx,2
	call	_updaterows

	popad
	ret


;
_putscreen_text:
	pushad
	call	_get_screen_offset
	push	edi
	movzx	ebx,activewindow		; make sure we use the
	movzx	ebp,activefile[ebx]		;  correct variables
	shl	ebx,2

	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,'L'
	putcell
	mov	al,' '
	putcell

	mov	eax,textline[ebp*8+ebx]
	inc	eax
	mov	ch,headline_c
	call	_printdec_dword

	mov	edx,addededi
	add	edi,edx
	mov	ah,ch
	shl	eax,(CELLSIZE-2)*4
	mov	al,'/'
	putcell

	mov	eax,totaltextlines[ebp*8+ebx]
	inc	eax
	mov	ch,headline_c
	call	_printdec_dword

	add	edi,addededi
	add	edx,addededi
	shr	edx,(CELLSIZE/2)
	mov	ecx,18-2-1
	sub	ecx,edx
	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	rep				; bah. Tasm crashes if I put "rep" and
	putcell				; "putcell" on the same line

	mov	al,'C'
	putcell
	mov	al,' '
	putcell

	mov	eax,column[ebp*8+ebx]
	inc	eax
	mov	ch,headline_c
	call	_printdec_word
	or	eax,eax         ; update flags
	mov	ah,ch
	shl	eax,(CELLSIZE-2)*4
	jne	notzerocolumn	; use them
	mov	al,'0'
	putcell
	sub	edi,1*CELLSIZE
	mov	addededi,1*CELLSIZE
notzerocolumn:
	add	edi,addededi
	shr	addededi,CELLSIZE/2
	mov	ecx,7+1
	sub	ecx,addededi
	mov	al,' '
	rep
	putcell

	mov	eax,textline[ebp*8+ebx] 	; print % of total lines
	call	_getnumdatarows
	add	eax,ecx
	cmp	eax,totaltextlines[ebp*8+ebx]
	jbe	notmorethantotallines
	mov	eax,totaltextlines[ebp*8+ebx]
	inc	eax
notmorethantotallines:
	mov	ecx,100
	mul	ecx
	mov	ecx,totaltextlines[ebp*8+ebx]
	inc	ecx
	idiv	ecx
	call	_putpercent

	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	putcell

	mov	esi,offset filename	; print filename
	mov	edx,ebp
	shl	edx,7
	add	esi,edx
	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	cmp	filechanged[ebp],1
	jne	_dont_put_star2
	mov	al,'*'
	jmp	_put_marker2
_dont_put_star2:
	mov	al,' '
_put_marker2:
	putcell
	mov	ecx,-1
	push	esi
_chkpathlength2:
	lodsb
	inc	ecx
	or	al,al
	jnz	_chkpathlength2
	pop	esi
	mov	edx,28
	sub	edx,ecx
	cmp	ecx,28
	jbe	_putfilename&path2
	mov	edx,0
	add	esi,ecx
	sub	esi,25
	mov	al,'.'
	putcell
	putcell
	putcell
_putfilename&path2:
	lodsb
	putcell
	or	al,al
	jnz	_putfilename&path2
	mov	al,' '
	mov	ecx,edx
	inc	ecx
	rep
	putcell

	mov	esi,linefeedtype	; print linefeed-msg
	shl	esi,2
	add	esi,offset linefeedmsgs
	lodsb
	putcell
	lodsb
	putcell
	lodsb
	putcell
	lodsb
	putcell

	mov	al,' '
	putcell

	mov	esi,offset activemsg
	cmp	trulyactive,1
	je	activetxtwin
	mov	esi,offset inactivemsg
activetxtwin:
	mov	ecx,8
txtputalop:
	lodsb
	putcell
	loop	txtputalop

	mov	al,' '
	putcell

	shr	ebx,2
	mov	al,'W'                  ; print wrap-msg
	cmp	wrap[ebp*2+ebx],1
	je	wrapit
	mov	al,' '
wrapit:
	putcell

	pop	edi
	add	edi,80*CELLSIZE
	movzx	ebx,activewindow		; make sure we use the
	movzx	ebp,activefile[ebx]		;  correct variables
	shl	ebx,2

	push	filebufferpos[ebp*8+ebx]
	mov	eax,filebufferpos[ebp*8+ebx]
pstagaina:
	cmp	screenoffset[ebp*8+ebx],eax
	jna	pstna
	mov	ecx,1
	call	_xlinesup
	jmp	pstagaina
pstna:
	je	nicescoffs
pstagainb:
	mov	ecx,1
	mov	edx,screenoffset[ebp*8+ebx]
	call	_xlinesdown
	cmp	screenoffset[ebp*8+ebx],edx
	je	nicescoffs
	cmp	screenoffset[ebp*8+ebx],eax
	jb	pstagainb
	je	nicescoffs
	mov	ecx,1
	call	_xlinesup

nicescoffs:
	pop	filebufferpos[ebp*8+ebx]
	mov	templine,0
	mov	esi,filebufferptr[ebp*4]
	add	esi,screenoffset[ebp*8+ebx]

	push	filebufferpos[ebp*8+ebx]
	push	screenoffset[ebp*8+ebx]
	push	textline[ebp*8+ebx]
	mov	eax,filesize[ebp*4]
	add	eax,filebufferptr[ebp*4]
	mov	___putscreen_text_maxpos,eax
	call	_getnumdatarows

	mov	ah,textmode_c
	shl	eax,(CELLSIZE-2)*4

__putscreen_text_lop:
	push	ecx
	push	edi
	mov	___putscreen_text_scrxp,0
	mov	___putscreen_text_linexp,0
__putscreen_text_lop1:
	cmp	esi,___putscreen_text_maxpos
	jae	__putscreen_text_lop1end ;eof

	lodsb

	mov	ecx,linefeedtype
	shl	ecx,2
	mov	edx,dword ptr linefeed[ecx+1]
	cmp	al,dl
	jne	__putscreen_text_nolf
	cmp	byte ptr linefeed[ecx],1
	je	__putscreen_text_lop1end
	cmp	[esi],dh
	jne	__putscreen_text_nolf
	cmp	byte ptr linefeed[ecx],2
	je	__putscreen_text_lop1end
	shr	edx,8
	cmp	[esi+1],dh
	je	__putscreen_text_lop1end
__putscreen_text_nolf:

	cmp	al,9
	jne	__putscreen_text_notab
	movzx	ecx,tabsize
	jecxz	__putscreen_text_endofchar
	push	eax
	mov	eax,___putscreen_text_linexp
	xor	edx,edx
	div	ecx
	pop	eax
	sub	ecx,edx
	mov	al,' '
__putscreen_text_tablop:

	inc	___putscreen_text_linexp
	mov	edx,___putscreen_text_linexp
	cmp	edx,column[ebp*8+ebx]
	jbe	__putscreen_text_tablop_ok
	putcell
	inc	___putscreen_text_scrxp
__putscreen_text_tablop_ok:

	loop	__putscreen_text_tablop
	jmp	__putscreen_text_endofchar
__putscreen_text_notab:

	inc	___putscreen_text_linexp
	mov	edx,___putscreen_text_linexp
	cmp	edx,column[ebp*8+ebx]
	jbe	__putscreen_text_endofchar
	putcell
	inc	___putscreen_text_scrxp

__putscreen_text_endofchar:
	cmp	___putscreen_text_scrxp,80
	jb	__putscreen_text_lop1

__putscreen_text_lop1end:
	mov	ecx,80
	sub	ecx,___putscreen_text_scrxp
	jle	__putscreen_text_fullline
	mov	al,' '
	rep
	putcell
__putscreen_text_fullline:
	pop	edi
	add	edi,80*CELLSIZE
	mov	esi,___putscreen_text_maxpos
	mov	ecx,textline[ebp*8+ebx]
	cmp	ecx,totaltextlines[ebp*8+ebx]
	jae	__putscreen_text_nold
	mov	ecx,1
	call	_xlinesdown
	mov	esi,filebufferptr[ebp*4]
	add	esi,screenoffset[ebp*8+ebx]
__putscreen_text_nold:
	pop	ecx
	loop	__putscreen_text_lop

	pop	textline[ebp*8+ebx]
	pop	screenoffset[ebp*8+ebx]
	pop	filebufferpos[ebp*8+ebx]

	call	_get_screen_offset
	mov	eax,ecx
	call	_getnumdatarows
	inc	ecx
	call	_updaterows

	popad
	ret


;
; in:	EAX == percentage to write
;	EDI == address to write to
; out:	EDI == next address
_putpercent:
	push	eax ecx edx
	mov	ecx,eax
	mov	edx,3*CELLSIZE
	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	putcell
	cmp	ecx,100
	je	_notlessp2
	putcell
	sub	edx,1*CELLSIZE
	cmp	ecx,10
	jae	_notlessp2
	putcell
	sub	edx,1*CELLSIZE
_notlessp2:
	sub	edi,2*CELLSIZE
	push	eax
	mov	eax,ecx
	mov	ch,headline_c
	call	_printdec_byte
	or	eax,eax
	pop	eax
	jnz	_notzerop2
	mov	al,'0'
	putcell
	sub	edi,CELLSIZE
_notzerop2:
	add	edi,edx
	mov	al,'%'
	putcell
	pop	edx ecx eax
	ret


;
_drawtoprow:
	pushad
	mov	edi,textscreenstart
	mov	ah,topheadline_c
	shl	eax,(CELLSIZE-2)*4
	lea	esi,selectedmsg
__dtr_sellop:
	lodsb
	or	al,al
	jz	__dtr_sellop_end
	putcell
	jmp	__dtr_sellop
__dtr_sellop_end:
	movzx	ecx,activewindow
	movzx	ebp,activefile[ecx]
	shl	ecx,2

	mov	dh,topheadline_c
	mov	eax,mark1ptr
	xor	ebx,ebx
	cmp	marked,1
	jb	__dtr_selok
	mov	ebx,mark2ptr
	ja	__dtr_2marked
	mov	ebx,filebufferpos[ebp*8+ecx]
	add	ebx,filebufferptr[ebp*4]
__dtr_2marked:
	cmp	ebx,eax
	jae	__dtr_m2ae
	xchg	eax,ebx
__dtr_m2ae:
	mov	ecx,filebufferptr[ebp*4]
	add	ecx,filesize[ebp*4]
	cmp	ebx,ecx
	jb	__dtr_lastbyte
	dec	ebx
__dtr_lastbyte:
	sub	ebx,eax
	inc	ebx
__dtr_selok:
	call	_printhex_dword
	add	edi,8*CELLSIZE
	mov	ah,topheadline_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,'h'
	putcell

	mov	esi,offset headline	; print hexit and my name
printhlinfolop:
	lodsb
	or	al,al
	jz	donehlinfo
	putcell
	jmp	printhlinfolop
donehlinfo:

	mov	al,'I'                  ; print I or O
	cmp	insert,1
	je	_insert_active
	mov	al,'O'
_insert_active:
	putcell
	mov	al,'R'
	cmp	recmacro,1
	je	__drawtoprow_recactive
	mov	al,' '
__drawtoprow_recactive:
	putcell

	mov	al,' '
	putcell
	mov	al,''
	putcell
	mov	al,' '
	putcell
	putcell

	xchg	eax,edx
	call	_getmaxfreemem          ; print free himem
	xchg	eax,edx
	shr	edx,10			; print KB's
	mov	ebx,6*CELLSIZE
	cmp	edx,999999
	jbe	@@gigok
	mov	edx,999999
@@gigok:
	cmp	edx,100000
	jae	_notlessmem2
	putcell
	sub	ebx,1*CELLSIZE
	cmp	edx,10000
	jae	_notlessmem2
	putcell
	sub	ebx,1*CELLSIZE
	cmp	edx,1000
	jae	_notlessmem2
	putcell
	sub	ebx,1*CELLSIZE
	cmp	edx,100
	jae	_notlessmem2
	putcell
	sub	ebx,1*CELLSIZE
	cmp	edx,10
	jae	_notlessmem2
	putcell
	sub	ebx,1*CELLSIZE
_notlessmem2:
	xchg	eax,edx
	mov	ch,topheadline_c
	call	_printdec_dword
	or	eax,eax
	xchg	eax,edx
	jnz	_notzerokb
	mov	al,'0'
	putcell
_notzerokb:
	add	edi,ebx
	mov	al,'k'
	putcell

	mov	eax,0			; start on first row
	mov	ecx,1			; and process 1 row
	call	_updaterows		; make sure display is updated

	popad
	ret


;
_putscreen_dumpview:
	pushad
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	shl	ebx,2
	call	_get_screen_offset
	pushad					; ok, now put statusbar

	mov	ebx,filebufferpos[ebp*8+ebx]
	mov	eax,70
	call	_getnumdatarows
	mul	ecx
	add	ebx,eax
	cmp	ebx,filesize[ebp*4]
	jbe	__putscreen_dumpview_percentok
	mov	ebx,filesize[ebp*4]
__putscreen_dumpview_percentok:
	mov	eax,ebx
	mov	ebx,100
	mul	ebx
	mov	ebx,filesize[ebp*4]
	or	ebx,ebx
	jz	__putscreen_dumpview_dontdiv
	idiv	ebx
__putscreen_dumpview_dontdiv:
	call	_putpercent

	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	putcell

	mov	ebx,filesize[ebp*4]		; print filesize
	mov	dh,headline_c			; print filepos
	call	_printhex_dword

	add	edi,8*CELLSIZE
	mov	al,' '
	putcell
	putcell

	mov	bl,dumpviewlow
	call	_printhex_byte
	add	edi,2*CELLSIZE

	putcell
	mov	al,'<'
	putcell
	mov	al,'='
	putcell
	mov	al,' '
	putcell

	mov	bl,dumpviewreps
	call	_printhex_byte
	add	edi,2*CELLSIZE

	putcell
	mov	al,'x'
	putcell
	mov	al,' '
	putcell
	mov	al,'<'
	putcell
	mov	al,'='
	putcell
	mov	al,' '
	putcell

	mov	bl,dumpviewhigh
	call	_printhex_byte
	add	edi,2*CELLSIZE

	mov	al,' '
	putcell
	putcell


	mov	esi,offset filename
	mov	edx,ebp
	shl	edx,7
	add	esi,edx
	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	cmp	filechanged[ebp],1
	jne	__putscreen_dumpview_dont_put_star
	mov	al,'*'
	jmp	__putscreen_dumpview_put_marker
__putscreen_dumpview_dont_put_star:
	mov	al,' '
__putscreen_dumpview_put_marker:
	putcell
	mov	ecx,-1
	push	esi
__putscreen_dumpview_chkpathlength:
	lodsb
	inc	ecx
	or	al,al
	jnz	__putscreen_dumpview_chkpathlength
	pop	esi
	mov	edx,31				; maxlength of filename&path (previously 43)
	sub	edx,ecx
	cmp	ecx,31				; maxlength of filename&path
	jbe	__putscreen_dumpview_putfilename&path
	mov	edx,0
	add	esi,ecx
	sub	esi,28				; maxlength of filename&path-3
	mov	al,'.'
	putcell
	putcell
	putcell
__putscreen_dumpview_putfilename&path:
	lodsb
	putcell
	or	al,al
	jnz	__putscreen_dumpview_putfilename&path
	mov	al,' '
	mov	ecx,edx
	add	ecx,1+2
	rep
	putcell

	mov	ah,headline_c			; print "Active" or ""
	shl	eax,(CELLSIZE-2)*4

	mov	ecx,8
	mov	esi,offset inactivemsg
	cmp	trulyactive,1
	jne	__putscreen_dumpview_putactive_lop
	mov	esi,offset activemsg
__putscreen_dumpview_putactive_lop:
	lodsb
	putcell
	loop	__putscreen_dumpview_putactive_lop

	mov	al,' '
	putcell

	cmp	dumpviewmask,0
	je	__putscreen_dumpview_masknotactive
	mov	al,'M'
__putscreen_dumpview_masknotactive:
	putcell

	popad
	add	edi,80*CELLSIZE

	mov	esi,filebufferpos[ebp*8+ebx]
	mov	ebx,filebufferptr[ebp*4]
	mov	___putscreen_dumpview_blockvisible,0
	cmp	dumpviewmask,0
	je	__putscreen_dumpview_prelop
	or	esi,esi
	jz	__putscreen_dumpview_prelop
	mov	al,[ebx+esi]
	cmp	al,dumpviewlow
	jb	__putscreen_dumpview_prelop
	cmp	al,dumpviewhigh
	ja	__putscreen_dumpview_prelop
	cmp	dumpviewreps,1
	jbe	__putscreen_dumpview_initialblockvisible
	lea	edx,[ebx-1]
	mov	cl,1
__putscreen_dumpview_initialblockvisible_lop:
	mov	ch,[esi+edx]
	dec	edx
	cmp	ch,dumpviewlow
	jb	__putscreen_dumpview_initialblockvisible_fw
	cmp	ch,dumpviewhigh
	ja	__putscreen_dumpview_initialblockvisible_fw
	inc	cl
	and	ecx,0ffh
	cmp	cl,dumpviewreps
	jae	__putscreen_dumpview_initialblockvisible
	cmp	ecx,esi
	jb	__putscreen_dumpview_initialblockvisible_lop
	jmp	__putscreen_dumpview_prelop
__putscreen_dumpview_initialblockvisible_fw:
	lea	edx,[ebx+1]
__putscreen_dumpview_initialblockvisible_fwlop:
	mov	ch,[esi+edx]
	inc	edx
	cmp	ch,dumpviewlow
	jb	__putscreen_dumpview_prelop
	cmp	ch,dumpviewhigh
	ja	__putscreen_dumpview_prelop
	inc	cl
	and	ecx,0ffh
	cmp	cl,dumpviewreps
	jae	__putscreen_dumpview_initialblockvisible
	lea	eax,[edx+esi]
	sub	eax,filebufferptr[ebp*4]
	cmp	eax,filesize[ebp*4]
	jb	__putscreen_dumpview_initialblockvisible_fwlop
	jmp	__putscreen_dumpview_prelop

__putscreen_dumpview_initialblockvisible:
	mov	___putscreen_dumpview_blockvisible,-1
__putscreen_dumpview_prelop:
	call	_getnumdatarows
__putscreen_dumpview_lop:
	cmp	esi,filesize[ebp*4]
	jbe	__putscreen_dumpview_putaddress
	push	ecx
	mov	ah,colors_dumpviewbkg
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	mov	ecx,10
	rep
	putcell
	pop	ecx
	jmp	__putscreen_dumpview_address_end
__putscreen_dumpview_putaddress:
	mov	dh,colors_dumpviewaddress
	push	ebx
	mov	ebx,esi
	call	_printhex_dword
	pop	ebx
	add	edi,8*CELLSIZE
	mov	ah,colors_dumpviewbkg
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	putcell
__putscreen_dumpview_address_end:
	mov	dh,___putscreen_dumpview_blockvisible
	mov	dl,70		; dl = width
	mov	ah,colors_dumpviewtext
	shl	eax,(CELLSIZE-2)*4
	push	ecx
__putscreen_dumpview_textlop:
	mov	al,' '
	inc	esi
	cmp	esi,filesize[ebp*4]
	ja	__putscreen_dumpview_textlop_end
	mov	al,[ebx+esi-1]
	cmp	dumpviewmask,0
	je	__putscreen_dumpview_textlop_end
	cmp	al,dumpviewlow
	jb	__putscreen_dumpview_textlop_mask
	cmp	al,dumpviewhigh
	ja	__putscreen_dumpview_textlop_mask
	or	dh,dh
	jnz	__putscreen_dumpview_textlop_end
	cmp	dumpviewreps,1
	jbe	__putscreen_dumpview_textlop_end

	movzx	ecx,dumpviewreps
	dec	ecx
	neg	ecx
	add	ecx,filesize[ebp*4]
	cmp	esi,ecx
	ja	__putscreen_dumpview_textlop_mask
	movzx	ecx,dumpviewreps
	lea	ecx,[ecx+ebx-1]
__putscreen_dumpview_repslop:
	mov	dh,[esi+ecx-1]
	cmp	dh,dumpviewlow
	jb	__putscreen_dumpview_textlop_mask
	cmp	dh,dumpviewhigh
	ja	__putscreen_dumpview_textlop_mask
	dec	ecx
	cmp	ecx,ebx
	ja	__putscreen_dumpview_repslop
	mov	dh,-1
	jmp	__putscreen_dumpview_textlop_end
__putscreen_dumpview_textlop_mask:
	mov	al,dumpviewfill ;' '
	xor	dh,dh
__putscreen_dumpview_textlop_end:
	putcell
	dec	dl
	jnz	__putscreen_dumpview_textlop
	mov	___putscreen_dumpview_blockvisible,dh
	pop	ecx
	loop	__putscreen_dumpview_lop
__putscreen_dumpview_end:

	call	_get_screen_offset
	mov	eax,ecx
	call	_getnumdatarows
	inc	ecx
	call	_updaterows

	popad
	ret


;
_putscreen_codeview:
	pushad
	movzx	ebx,activewindow
	movzx	ebp,activefile[ebx]
	shl	ebx,2
	call	_get_screen_offset
	mov	___headlinerow,cl
	pushad					; ok, now put statusbar

	push	ebx

	mov	dh,headline_c			; print filepos
	mov	ebx,filebufferpos[ebp*8+ebx]
	call	_printhex_dword
	add	edi,8*CELLSIZE
	mov	ah,dh
	shl	eax,(CELLSIZE-2)*4
	mov	al,'/'
	putcell


	mov	ebx,filesize[ebp*4]		; print filesize
	mov	dh,headline_c
	call	_printhex_dword
	add	edi,8*CELLSIZE

	mov	al,' '
	putcell
	putcell

	pop	ebx

	mov	eax,filebufferpos[ebp*8+ebx]
	mov	ebx,100
	mul	ebx
	mov	ebx,filesize[ebp*4]
	or	ebx,ebx
	jz	__putscreen_codeview_dontdiv
	idiv	ebx
__putscreen_codeview_dontdiv:
	call	_putpercent

	mov	ah,headline_c
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	putcell

	cmp	nibblemove,0
	je	__putscreen_codeview_notnibblemove
	mov	al,''
__putscreen_codeview_notnibblemove:
	putcell

	mov	al,' '
	putcell
	putcell
	putcell

	cmp	dazmitsegsize,DA_SEGSIZE16
	je	__putscreen_codeview_sz16
	mov	al,'3'
	putcell
	mov	al,'2'
	putcell
	jmp	__putscreen_codeview_szok
__putscreen_codeview_sz16:
	mov	al,'1'
	putcell
	mov	al,'6'
	putcell
__putscreen_codeview_szok:

	mov	al,' '
	putcell
	putcell
	putcell

	mov	esi,offset filename
	mov	edx,ebp
	shl	edx,7
	add	esi,edx
	mov	ah,headline_c
	cmp	filechanged[ebp],1
	jne	__putscreen_codeview_dont_put_star
	mov	al,'*'
	jmp	__putscreen_codeview_put_marker
__putscreen_codeview_dont_put_star:
	mov	al,' '
__putscreen_codeview_put_marker:
	putcell
	mov	ecx,-1
	push	esi
__putscreen_codeview_chkpathlength:
	lodsb
	inc	ecx
	or	al,al
	jnz	__putscreen_codeview_chkpathlength
	pop	esi
	mov	edx,31				; maxlength of filename&path (previously 43)
	sub	edx,ecx
	cmp	ecx,31				; maxlength of filename&path
	jbe	__putscreen_codeview_putfilename&path
	mov	edx,0
	add	esi,ecx
	sub	esi,28				; maxlength of filename&path-3
	mov	al,'.'
	putcell
	putcell
	putcell
__putscreen_codeview_putfilename&path:
	lodsb
	putcell
	or	al,al
	jnz	__putscreen_codeview_putfilename&path
	mov	al,' '
	mov	ecx,edx
	add	ecx,1+2
	rep
	putcell

	mov	ecx,8
	mov	esi,offset inactivemsg
	cmp	trulyactive,1
	jne	__putscreen_codeview_putactive_lop
	mov	esi,offset activemsg
__putscreen_codeview_putactive_lop:
	lodsb
	putcell
	loop	__putscreen_codeview_putactive_lop

	mov	al,' '
	putcell

	mov	al,'N'
	cmp	dazmitcomments,0
	je	__putscreen_cm_commentsput
	mov	al,'S'
	cmp	dazmitcomments,1
	je	__putscreen_cm_commentsput
	mov	al,'A'
__putscreen_cm_commentsput:
	putcell

	popad
	add	edi,80*CELLSIZE

	mov	esi,screenoffset[ebp*8+ebx]
	mov	edx,filesize[ebp*4]
	sub	edx,esi
	add	esi,filebufferptr[ebp*4]
	mov	eax,filebufferpos[ebp*8+ebx]
	mov	___tmpfilebufferpos,eax
	call	_getnumdatarows
	mov	___tmpnumdatarows,cl
	shr	ebx,2
	mov	al,nibble[ebp*2+ebx]
	neg	al
	inc	al
	mov	___tmpnibbleadd,al

__putscreen_codeview_lop:
	mov	___putscreen_cmactiveline,0
	push	ecx		; this val is used later
	mov	ecx,edx
	mov	ebx,esi
	sub	ebx,filebufferptr[ebp*4]
	call	_parseinstruction
	mov	___instlen,ecx
	mov	___putscreen_cmorigesi,esi
	setc	___putscreen_codeview_carry
;	 jecxz	 __putscreen_codeview_fill  ; jc      __putscreen_codeview_fill
	sub	edx,ecx

	push	edx edi
	add	edi,10*CELLSIZE
	mov	dl,cl
	mov	ch,-1
	cmp	ebx,___tmpfilebufferpos
	ja	__putscreen_codeview_puthex_lop
	add	ebx,___instlen			; ecx
	sub	ebx,___tmpfilebufferpos
	ja	__putscreen_codeview_afterlastinst
	cmp	___instlen,0
	je	__putscreen_codeview_afterlastinst
	cmp	___putscreen_codeview_carry,0
	jne	__putscreen_codeview_afterlastinst
	jmp	__putscreen_codeview_puthex_lop
__putscreen_codeview_afterlastinst:
	xchg	ebx,edx
	and	edx,0ffh
	mov	ch,dl
	neg	dl
	shl	dl,1
	add	dl,cl
	add	dl,cl
	mov	dh,___headlinerow
	add	dh,___tmpnumdatarows
	add	dh,1
	sub	dh,[esp+2*4]	; pushed ecx
	add	dl,10
	add	dl,___tmpnibbleadd
	cmp	dl,10+14*2+1
	jbe	__putscreen_codeview_linelenok
	mov	dl,10+14*2+1
__putscreen_codeview_linelenok:
	mov	___cursorpos,dx
	mov	edx,ebx

__putscreen_codeview_puthex_lop:
	lodsb
	mov	bl,al
	mov	dh,colors_cmbytes
	cmp	trulyactive,0
	je	__putscreen_codeview_nocursor
	push	edx
	mov	dx,___cursorpos
	call	_setcursorpos
	pop	edx
__putscreen_codeview_nocursor:
	cmp	cl,ch
	jne	__putscreen_codeview_puthex_lop_notcurrent
	mov	dh,colors_cmactivebytes
	mov	___putscreen_cmactiveline,1
__putscreen_codeview_puthex_lop_notcurrent:

	cmp	___instlen,0
	je	__putscreen_cm_putaddress

	mov	eax,___instlen
	sub	al,cl
	cmp	al,14
	ja	__putscreen_codeview_linetoolong2
	call	_printhex_byte
__putscreen_codeview_linetoolong2:
	add	edi,2*CELLSIZE
	dec	cl
	jnz	__putscreen_codeview_puthex_lop
	movzx	ecx,dl
	neg	ecx
	add	ecx,30
	jle	__putscreen_cm_putaddress
;	 jecxz	 __putscreen_cm_putaddress
	push	eax
	mov	ah,colors_cmbkg
	and	ah,0f0h
	mov	al,colors_cmactivebytes
	and	al,0fh
	or	ah,al
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	rep
	putcell
	pop	eax

__putscreen_cm_putaddress:
	pop	edi
	push	ebx
	mov	dh,colors_cmactiveaddress
	cmp	___putscreen_codeview_carry,0
	je	__putscreen_cm_notlast2
	mov	eax,___tmpfilebufferpos
	add	eax,filebufferptr[ebp*4]
	cmp	eax,___putscreen_cmorigesi
	jb	__putscreen_cm_notlast2
	mov	___putscreen_cmactiveline,1
	jmp	__putscreen_cm_active2
__putscreen_cm_notlast2:
	cmp	___putscreen_cmactiveline,0
	jne	__putscreen_cm_active2
	mov	dh,colors_cmaddress
__putscreen_cm_active2:
	mov	ah,dh
	mov	ebx,___putscreen_cmorigesi
	sub	ebx,filebufferptr[ebp*4]
	call	_printhex_dword
	add	edi,8*CELLSIZE
	mov	ah,colors_cmbkg
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	putcell
	putcell
	pop	ebx

	cmp	___instlen,0
	jne	__putscreen_codeview_notnoinst2
	add	esp,1*4 	; scrap pushed edx
	pop	eax
	imul	ecx,eax,80
	sub	ecx,10
	jmp	__putscreen_codeview_partialfill
__putscreen_codeview_notnoinst2:

	sub	edi,10*CELLSIZE

	mov	ah,colors_cmactiveinsts
	cmp	___putscreen_cmactiveline,0
	jne	__putscreen_cm_notactive1
	mov	ah,colors_cminsts
__putscreen_cm_notactive1:
	shl	eax,(CELLSIZE-2)*4

__putscreen_codeview_puthex_dontfill:
	neg	ecx
	add	ecx,41
	push	edi esi
	add	edi,40*CELLSIZE
	lea	esi,dazmitbuf
__putscreen_codeview_putinstruction_lop:
	dec	ecx
	jz	__putscreen_codeview_putinstruction_lop_endofrow
	lodsb
	or	al,al
	jz	__putscreen_codeview_putinstruction_lop_end
	cmp	al,';'
	jne	__putscreen_cm_pilopnotcomment
	mov	ah,colors_cmcomments
	cmp	___putscreen_cmactiveline,0
	je	__putscreen_cm_pilopcomment
	mov	ah,colors_cmactivecomments
__putscreen_cm_pilopcomment:
	shl	eax,(CELLSIZE-2)*4
	mov	al,';'
__putscreen_cm_pilopnotcomment:
	putcell
	jmp	__putscreen_codeview_putinstruction_lop
__putscreen_codeview_putinstruction_lop_end:
	mov	ah,colors_cmbkg
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	rep
	putcell
__putscreen_codeview_putinstruction_lop_endofrow:
	pop	esi edi edx
	add	edi,80*CELLSIZE
	cmp	___putscreen_codeview_carry,0
	jne	__putscreen_codeview_fill
	pop	ecx
	loop	__putscreen_codeview_lop
	jmp	__putscreen_codeview_end

__putscreen_codeview_fill:
	pop	eax
	imul	ecx,eax,80
	sub	ecx,80
	ja	__putscreen_codeview_fill_subok
	add	ecx,80
__putscreen_codeview_fill_subok:
__putscreen_codeview_partialfill:
	mov	ah,colors_cmbkg
	and	ah,0f0h
	mov	al,colors_cmactivebytes
	and	al,0fh
	or	ah,al
	shl	eax,(CELLSIZE-2)*4
	mov	al,' '
	rep
	putcell

__putscreen_codeview_end:

	call	_get_screen_offset
	mov	eax,ecx
	call	_getnumdatarows
	inc	ecx
	call	_updaterows

	popad
	ret


;
_putscreen:
	cmp	screenupdating,0
	je	_ret
	call	_drawtoprow
	cmp	pastinit,0
	je	_ret

	push	ebx
	movzx	ebx,activewindow
	cmp	mode[ebx],MODE_TEXTVIEW
	jne	__putscreen_nottextview
	pop	ebx
	jmp	_putscreen_text
__putscreen_nottextview:
	cmp	mode[ebx],MODE_DUMPVIEW
	jne	__putscreen_notdumpview
	pop	ebx
	jmp	_putscreen_dumpview
__putscreen_notdumpview:
	cmp	mode[ebx],MODE_CODEMODE
	jne	__putscreen_notcodeview
	pop	ebx
	jmp	_putscreen_codeview
__putscreen_notcodeview:
	pop	ebx
	jmp	_putscreen_hex


;
_putbothscreens&cursor:
	cmp	screenupdating,0
	je	_ret
	call	_putbothscreens
_putcursor:
	push	ebx
	movzx	ebx,activewindow
	cmp	mode[ebx],MODE_HEXMODE
	je	__putbothscreens&cursor_cursor
	cmp	mode[ebx],MODE_CODEMODE
	je	__putbothscreens&cursor_cursor
	pop	ebx
	call	_hidecursor
	ret
__putbothscreens&cursor_cursor:
	pop	ebx
	cmp	insert,1
	je	__putbothscreens&cursor_insert
	call	_setoverwritecursor
	ret
__putbothscreens&cursor_insert:
	call	_setinsertcursor
	ret


;
_putbothscreens:
	cmp	screenupdating,0
	je	_ret
	pushad
	movzx	ax,activewindow 	; update data-areas
	push	eax			; put active-msg in active win
	cmp	numberofwindows,2
	je	_1st_win
	cmp	activewindow,1
	je	_2nd_win
_1st_win:
	cmp	activewindow,0
	je	_its_active1
	mov	trulyactive,0
_its_active1:
	mov	activewindow,0
	call	_putscreen
	pop	eax
	mov	activewindow,al
	push	eax
	cmp	numberofwindows,2
	jne	_not2windows
_2nd_win:
	mov	trulyactive,1
	cmp	activewindow,1
	je	_its_active2
	mov	trulyactive,0
_its_active2:
	mov	activewindow,1
	call	_putscreen
_not2windows:
	pop	eax
	mov	activewindow,al
	mov	trulyactive,1
	push	-1
	call	_drawbottomrow
	popad
	ret


;
_init:
	pushad
        call    _sysinit                        ; OS specific initializations

	mov	ecx,offset init_x_end		; zero some variables
	mov	edi,offset init_x_start
	sub	ecx,edi
	shr	ecx,2
	xor	eax,eax
	rep	stosd

	lea	edi,firstconfigbyte		; copy default config
	lea	ecx,lastconfigbyte
	sub	ecx,edi
	lea	esi,defaultall
	rep	movsb

        call    _getexefullpath
	mov	edi,offset configpath
	mov	ebp,edi
lop1:
        lodsb
	stosb
	or	al,al
	jnz	lop1
	std
	mov	al,'\'
	dec	edi
	mov	ecx,65535
	repne	scasb
	add	edi,2
	mov	esi,offset configname
	mov	ecx,10
	cld
	rep	movsb

	mov	ecx,edi
	sub	ecx,ebp
	mov	esi,offset configpath
	mov	edi,offset helppath
	rep	movsb
	mov	byte ptr [edi-4],'D'
	mov	byte ptr [edi-3],'O'
	mov	byte ptr [edi-2],'C'

	mov	edx,offset configpath
	call	_openfilereadonly
	jc	_configread
	mov	edx,offset tempdw
	mov	ecx,4
	call	_readfile
	call	_filesize
	sub	eax,4
	cmp	eax,tempdw
	jne	_corruptcfgfile
	mov	ecx,tempdw
	mov	edx,offset lastconfigbyte
	sub	edx,tempdw
_tryagain:
	cmp	edx,offset firstconfigbyte
	jae	_oknotmorebytes
	dec	ecx
	jz	_corruptcfgfile
	inc	edx
	mov	eax,1
	mov	bl,1
	call	_lseekfile
	jmp	_tryagain
_oknotmorebytes:
	call	_readfile
	call	_closefile
	jmp	_configread

_corruptcfgfile:
	mov	edx,offset corruptcfgfilemsg
	call	_puts
	mov	edx,offset pressanykeymsg
	call	_puts
	call	_getkey
_configread:
	inc	timesopened
	mov	al,startinsert
	mov	insert,al
	mov	al,startwindows
	mov	numberofwindows,al
	movzx	eax,startlinefeed
	mov	linefeedtype,eax
	mov	al,startmode0
        mov     mode[0],al
        mov     ah,startmode1
        mov     mode[1],ah
	mov	al,misc_nibblemove
	mov	nibblemove,al
	mov	al,misc_dumpviewreps
	mov	dumpviewreps,al
	mov	al,misc_dumpviewlow
	mov	dumpviewlow,al
	mov	al,misc_dumpviewhigh
	mov	dumpviewhigh,al
	mov	al,misc_dumpviewfill
	mov	dumpviewfill,al
	mov	al,misc_dumpviewmask
	mov	dumpviewmask,al
	mov	al,misc_tabsize
	mov	tabsize,al
	mov	al,misc_cmsegsize
	mov	dazmitsegsize,al
	mov	al,misc_cmcomments
	mov	dazmitcomments,al
	mov	al,startwrap
	mov	ah,al
	mov	ecx,MAXFILES
	mov	edi,offset wrap
	rep	stosw

; keyinitialization

	mov	ebp,hexitversion
	mov	esi,offset versionkeys-8
__init_key_versionlop:
	add	esi,8
	cmp	ebp,[esi]
	jb	__init_key_versionlop
	mov	hexitversion,CURRENT_HEXIT_VERSION
	mov	ebp,[esi+4]

	mov	edi,offset keys-SIZEOF_KEYS
__init_key_prelop:
	add	edi,SIZEOF_KEYS
	cmp	byte ptr [edi],0
	je	__init_key_prelop_end
	cmp	byte ptr [edi],MODE_HEXMODE
	je	__init_key_prelop
	cmp	byte ptr [edi],MODE_TEXTVIEW
	je	__init_key_prelop
	cmp	byte ptr [edi],MODE_DUMPVIEW
	je	__init_key_prelop
	cmp	byte ptr [edi],MODE_CODEMODE
	je	__init_key_prelop
	mov	byte ptr [edi],MODE_GLOBAL
	jmp	__init_key_prelop

__init_key_prelop_end:
					; now edi points to where the new
					; keydata should be inserted

	mov	esi,offset defaultkeys-SIZEOF_KEYS
__init_key_lop:
	add	esi,SIZEOF_KEYS
	cmp	esi,ebp 		; keys after versionkeys_xxx can only
	jae	__init_key_end		; be updated, not added
	cmp	byte ptr [esi],0
	je	__init_key_end
	cmp	edi,offset keys + ( MAXKEYS - 1 ) * SIZEOF_KEYS
	jae	__init_key_error
	mov	ax,[esi+1]
	mov	dh,[esi+3]
	mov	dl,[esi]
	push	offset keys
	call	_getkeyfunction
	cmp	ebx,-1
	jne	__init_key_lop
	push	esi
	mov	ecx,SIZEOF_KEYS
	rep	movsb
	pop	esi
	jmp	__init_key_lop
__init_key_error:			; too many keys!
	mov	edx,offset toomanykeyserrmsg
	call	_puts
	call	_getkey
__init_key_end:
	mov	ecx,SIZEOF_KEYS
	xor	al,al
	rep	stosb

; end of keyinitialization

	call	_saveconfigwithnopopups ; save config, incl. possible new keys

	mov	edx,0100h
	call	_setcursorpos
	
	xor	al,al
	lea	edx,filename
	xor	esi,esi 	; win# affected by args
	xor	edi,edi 	; file# affected by args
__init_args_lop:
	call	_getarg
	jc	_no_more_args
	push	eax
	or	bl,bl
	jz	__init_args_argstr
	cmp	bh,SWI_FILE
	jne	__init_args_notswi_file
	mov	ecx,switch_file
	dec	ecx
	cmp	ecx,MAXFILES
	jae	__init_args_nextarg
	mov	edi,ecx
	jmp	__init_args_nextarg
__init_args_notswi_file:
	cmp	bh,SWI_WIN
	jne	__init_args_notswi_win
	mov	ecx,switch_win
	dec	ecx
	cmp	ecx,MAXWINDOWS
	jae	__init_args_nextarg
	mov	esi,ecx
	jmp	__init_args_nextarg
__init_args_notswi_win:
	cmp	bh,SWI_VM
	jne	__init_args_notswi_vm
	mov	ecx,switch_vm
	dec	ecx
	cmp	cl,MODE_LASTVIEWNUMBER
	jae	__init_args_nextarg
	mov	al,1
	shl	al,cl
	mov	mode[esi],al
	jmp	__init_args_nextarg
__init_args_notswi_vm:
	cmp	bh,SWI_SS
	jne	__init_args_notswi_ss
	mov	ecx,switch_ss
	inc	ecx
	cmp	cl,MAXWINDOWS
	ja	__init_args_nextarg
	mov	numberofwindows,cl
	jmp	__init_args_nextarg
__init_args_notswi_ss:
	cmp	bh,SWI_O
	jne	__init_args_notswi_o
	mov	ecx,switch_o
	or	ecx,ecx
	js	__init_args_nextarg
	shl	esi,2
	mov	filebufferpos[esi+edi*8],ecx
	shr	esi,2
	jmp	__init_args_nextarg
__init_args_notswi_o:

	jmp	__init_args_nextarg

__init_args_argstr:
	call	_expandwildcards
	or	ecx,ecx
	jnz	__init_args_ecxok
	cmp	numberoffiles,MAXFILES
	jae	_no_more_args		; otherwise files will be deleted!
	inc	ecx
__init_args_ecxok:
	add	numberoffiles,ecx
	shl	ecx,7
	add	edx,ecx
__init_args_nextarg:
	pop	eax
	inc	al
	jmp	__init_args_lop

_no_more_args:
IFDEF   MSDOS
	movzx	eax,_filebuflen 	; allocate lo memory, otherwise
	call	_getlomem		; fileread for example will not work
	jnc	gotlomem1
	add	eax,16*64		; for videostate-table (allocated later)
	mov	edx,offset littlememmsg1
	call	_puts
	call	_printdec_dwordt
	mov	edx,offset littlememmsg2
	call	_puts
	mov	edx,offset littlelomemmsg
	call	_puts
	mov	edx,offset littlememmsg3
	call	_puts
	jmp	_end_restorecursor
gotlomem1:
	mov	_filebufloc,eax
ENDIF

	mov	eax,16*64		; allocate mem for old
	call	_getlomem		; videostate-table
	jnc	gotlomem2
	mov	edx,offset littlememmsg1
	call	_puts
	call	_printdec_dwordt
	mov	edx,offset littlememmsg2
	call	_puts
	mov	edx,offset littlelomemmsg
	call	_puts
	mov	edx,offset littlememmsg3
	call	_puts
	jmp	_end_restorecursor
gotlomem2:
	mov	old_video_ptr,eax

	call	_initmem
	jnc	__init_enoughhimem
	mov	edx,offset littlememmsg1
	call	_puts
	call	_printdec_dwordt
	mov	edx,offset littlememmsg2
	call	_puts
	mov	edx,offset littlememmsg2
	call	_puts
	jmp	popad&stc&ret
__init_enoughhimem:

        call    _allocmainmem
	mov	filebufferptr[0],eax	; store pointer to first buffer

IF     LOGGING
	mov	edx,offset logfile
	call	_createfile
	jc	initlog_end
	call	_closefile
initlog_end:
ENDIF

	call	_savevideo		; save videostate
	call	_setvideo		; init videomode
	call	_putbothscreens&cursor

	cmp	numberoffiles,0
	jne	__init_somefilesloaded
	cmp	misc_createnew,0
	je	__init_queryfilename
	lea	edi,filename
	lea	esi,newfilename
__init_newfilelop:
	lodsb
	stosb
	or	al,al
	jnz	__init_newfilelop
	inc	numberoffiles
	jmp	__init_somefilesloaded
__init_queryfilename:
	mov	___init_nofilesloaded,1
	mov	edx,eax
	call	_nofileloadedfix
	jmp	_nomorefilestoload
__init_somefilesloaded:

	push	edx
	lea	edx,loadingmsg
	call	_puts
	lea	edx,filename
	call	_puts
	pop	edx
	
	call	_loadfile		; load 1st file
	jnc	__init_1stfileloaded
	lea	edi,filename
	lea	esi,[edi+MAXFILENAMELENGTH]
	mov	ecx,( MAXFILES - 1 ) * MAXFILENAMELENGTH
	rep	movsb
	dec	numberoffiles
	cmp	numberoffiles,0
	je	popad&stc&ret
	jmp	__init_somefilesloaded
__init_1stfileloaded:
	mov	ebx,1
	mov	edx,filebufferptr[0]
	add	edx,filesize[0]
	mov	activefile[0],1

_loadmorefiles:
	cmp	numberoffiles,ebx
	jbe	_nomorefilestoload
	mov	filebufferptr[ebx*4],edx

	push	ebx edx
	mov	dword ptr temp128bytes,0000a0dh
	lea	edx,temp128bytes
	call	_puts
	lea	edx,loadingmsg
	call	_puts
	shl	ebx,7
	lea	edx,[filename+ebx]
	call	_puts
	pop	edx ebx

	call	_loadfile
	mov	edx,filebufferptr[ebx*4]
	jnc	__init_loadmoreok
	mov	edi,ebx
	shl	edi,7
	add	edi,offset filename
	lea	esi,[edi+MAXFILENAMELENGTH]
	push	edx
	mov	eax,MAXFILES - 1
	sub	eax,ebx
	imul	ecx,eax,MAXFILENAMELENGTH
	pop	edx
	rep	movsb
	dec	numberoffiles
	jmp	_loadmorefiles
__init_loadmoreok:
	inc	activefile[0]
	add	edx,filesize[ebx*4]
	inc	ebx
	jmp	_loadmorefiles

_nomorefilestoload:
	mov	clipptr,edx
        call    _getmainmemtop
	sub	eax,edx
	mov	maxclipsize,eax

	mov	clipsize,0
	mov	activefile[0],0
	cmp	numberofwindows,1
	je	__init_1win
	cmp	numberoffiles,2
	jb	__init_1win
	mov	activefile[1],1
__init_1win:

	mov	ecx,numberoffiles
	jecxz	__init_verifyfbpos_end
__init_verifyfbpos_lop:
	mov	eax,filesize[ecx*4-4]
	cmp	filebufferpos[ecx*8+0-8],eax
	jbe	__init_verifyfbpos_n1
	mov	filebufferpos[ecx*8+0-8],eax
__init_verifyfbpos_n1:
	cmp	filebufferpos[ecx*8+4-8],eax
	jbe	__init_verifyfbpos_n2
	mov	filebufferpos[ecx*8+4-8],eax
__init_verifyfbpos_n2:
	loop	__init_verifyfbpos_lop
__init_verifyfbpos_end:

	call	_checkDPMI
	cmp	usemouse,1
	jne	__init_nomouse
        call    _initmouse
        or      ax,ax
	je	__init_nomouse
	mov	mouseavailable,1
        call    _resetmouse
__init_nomouse:

	cmp	mode[0],MODE_TEXTVIEW
	jne	__init_nottxt1
	call	_hidecursor
	call	_pretextmoderoutine
__init_nottxt1:
	cmp	mode[1],MODE_TEXTVIEW
	jne	__init_nottxt2
	mov	activewindow,1
	call	_pretextmoderoutine
	mov	activewindow,0
__init_nottxt2:

	cmp	mode[0],MODE_CODEMODE
	jne	__init_notcv1
	call	_hidecursor
	call	_do_codeviewinit
__init_notcv1:
	cmp	mode[1],MODE_CODEMODE
	jne	__init_notcv2
	mov	activewindow,1
	call	_do_codeviewinit
	mov	activewindow,0
__init_notcv2:

	mov	esi,offset firstconfigbyte	; copy config to oldcfg
	mov	edi,offset oldconfig
	mov	ecx,bytesincfg
	rep	movsb

        mov     ax,word ptr mode[0]
        lea     edi,filevm
        mov     ecx,MAXFILES
        rep     stosw

	mov	pastinit,1			; indicate that ALL has been
						; done correctly in _INIT
	jmp	popad&clc&ret

;
; _initmem( void );
;
; Out:
;	CF set if not enough mem
;		EAX = bytes more mem needed
;
;	CF clear if everything went extremely well
;
_initmem:
	pushad
	mov	ecx,MAX_KEYSINBUFFER * 4 * 2 + MAX_LINEOFFSETS * 4
	mov	eax,MAX_KEYSINBUFFER * 4
	call	_gethimem
	jc	__initmem_err
	mov	pkeybuffer,eax
	sub	ecx,MAX_KEYSINBUFFER * 4

	mov	eax,MAX_KEYSINBUFFER * 4
	call	_gethimem
	jc	__initmem_err
	mov	precbuffer,eax
	sub	ecx,MAX_KEYSINBUFFER * 4

	mov	eax,MAX_LINEOFFSETS * 4
	call	_gethimem
	jc	__initmem_err
	mov	plineoffset,eax
	sub	ecx,MAX_LINEOFFSETS * 4

	popad
	clc
	ret

__initmem_err:
	mov	[esp+7*4],ecx	; pushed eax
	popad
	stc
	ret

;
_nofileloadedfix:
	pushad
	xor	eax,eax
	mov	filesize[0],eax
	mov	screenoffset[0],eax
	mov	screenoffset[4],eax
	mov	filechanged[0],al
	mov	filebufferpos[0],eax
	mov	filebufferpos[4],eax
	mov	textline[0],eax
	mov	textline[4],eax
	mov	column[0],eax
	mov	column[4],eax
	mov	totaltextlines[0],eax
	mov	totaltextlines[4],eax

	mov	esi,offset nofileloadedfilename
	mov	edi,offset filename
__nofileloadedfix_lop:
	movsb
	cmp	byte ptr [esi-1],0
	jne	__nofileloadedfix_lop
	popad
	ret

;
; Displays the "Trying to write on a write-protected media!"-popup.
; The filename is filled with the name of the current file.
; Out:
;	DL = 1 if user selected "Try again", 2 otherwise.
_cantcreatefile:
	pushad
	movzx	ebp,activewindow
	movzx	ebp,activefile[ebp]
	shl	ebp,7
	lea	esi,filename[ebp]
	mov	edi,esi
	xor	al,al
	mov	ecx,-1
	repne	scasb
	lea	edx,[edi-37]
	lea	edi,cantcreatestr_filename
	mov	ecx,35
	cmp	edx,esi
	jb	__cantcreatefile_shortfilename
	mov	esi,edx
__cantcreatefile_shortfilename:
	lodsb
	or	al,al
	jz	__cantcreatefile_lop_end
	stosb
	loop	__cantcreatefile_shortfilename
__cantcreatefile_lop_end:
	jecxz	__cantcreatefile_longfilename
	mov	al,' '
	rep	stosb
__cantcreatefile_longfilename:
	mov	esi,offset cantcreatestr
	call	_popupmenu
	call	_putbothscreens&cursor
	mov	[esp+5*4],edx
	popad
	ret

;
; Loads file into buffer
_loadfile:
	pushad
	call	_makefullpathname

	movzx	ebp,activewindow
	movzx	ebp,activefile[ebp]		; this will be used a lot...

	mov	edx,offset filename		; open file
	mov	eax,ebp 			; mul 128 to get the correct
	shl	eax,7				;  filename
	add	edx,eax
	
__loadfile_tryopenorcreate:
	call	_openfilereadonly
        jnc     fileisopened
        call    _createfile
	jnc	fileiscreated
	push	edx
	call	_cantcreatefile
	cmp	dl,1
	pop	edx
	je	__loadfile_tryopenorcreate
	jmp	popad&stc&ret
fileiscreated:
	mov	created,1
fileisopened:
	call	_filesize
	jc	popad&stc&ret
_filelengthnotzero:
	mov	filesize[ebp*4],eax
	mov	eax,freehimemory		; check if file will fit
	cmp	eax,filesize[ebp*4]		; in available hi mem.
	jae	fitsok
	neg	eax
	add	eax,filesize[ebp*4]
	call	_reallocmainmem
	jnc	fitsok
	mov	edx,offset filememerrmsg1
	call	_puts
	call	_printdec_dwordt
	mov	edx,offset filememerrmsg2
	call	_puts
@@waitkey:
	call	_getkey
	jc	@@waitkey
	jmp	popad&stc&ret
fitsok:
	mov	edx,filebufferptr[ebp*4]
	pushad
	add	edx,filesize[ebp*4]
        call    _getmainmemtop
	sub	eax,edx

	cmp	clipsize,eax
	jbe	loadfileclipok

	pushad
	mov	esi,offset cliptruncstr
	call	_popupmenu
	call	_putbothscreens&cursor
	cmp	dl,1
	je	__loadfile_truncclipboard
	add	esp,8*4*2	; popad popad
	jmp	popad&stc&ret

__loadfile_truncclipboard:
	popad
	mov	clipsize,eax

loadfileclipok:
	mov	maxclipsize,eax
	mov	esi,clipptr
	mov	edi,edx
	mov	ecx,clipsize
	jecxz	loadfileclipnoclipsize
	std
	lea	esi,[esi+ecx-1]
	lea	edi,[edi+ecx-1]
	rep	movsb
	cld
loadfileclipnoclipsize:
	mov	clipptr,edx
	popad
	mov	ecx,filesize[ebp*4]
	call	_readfile
	jnc	fileisread
	mov	edx,offset readfileerrmsg	; display a menu saying so
	call	_puts				;  instead
@@wk:
	call	_getkey
	jc	@@wk
	jmp	popad&stc&ret

fileisread:
	mov	ecx,filesize[ebp*4]
	sub	freehimemory,ecx
	call	_closefile
	cmp	created,0
	je	popad&clc&ret
	mov	created,0
	mov	edx,offset filename
	mov	eax,ebp 			; mul 128 to get the correct
	shl	eax,7				;  filename
	add	edx,eax
	call	_deletefile
popad&clc&ret:
	popad
	clc
	ret

popad&stc&ret:
	popad
	stc
	ret


;
; Prints some hexdigits
; In:	(E)B(X/L)	=	Number to print in 2/4/8 hexdigits
;	DH		=	Attribute
;	[EDI]		->	Address to print to
_printhex_dword:
	pushad
	push	ebx
	shr	ebx,16
	call	_printhex_word
	pop	ebx
	add	edi,4*CELLSIZE
	call	_printhex_word
	popad
	ret

_printhex_word:
	pushad
	push	ebx
	shr	bx,8
	call	_printhex_byte
	pop	ebx
	add	edi,2*CELLSIZE
	call	_printhex_byte
	popad
	ret

_printhex_byte:
	pushad
	mov	al,bl
	shr	al,4
	call	_printhex_nibble
	add	edi,1*CELLSIZE
	mov	al,bl
	call	_printhex_nibble
	popad
	ret

_printhex_nibble:
	push	eax edi
	mov	ah,dh
	shl	eax,(CELLSIZE-2)*4
	shr	ax,(CELLSIZE-2)*4
	and	al,0fh
	cmp	al,10
	sbb	al,69h
	das
	putcell
	pop	edi eax
	ret


;
; Prints some hexdigits to the console
; In:	EAX/AX/AL       =	Number to print in 2/4/8 hexdigits
_printhex_dwordt:
	push	eax
	shr	eax,16
	call	_printhex_wordt
	pop	eax

_printhex_wordt:
	push	eax
	shr	eax,8
	call	_printhex_bytet
	pop	eax

_printhex_bytet:
        push    eax
	shr	eax,4
	call	_printhex_nibblet
        pop     eax

_printhex_nibblet:
	push    eax
	and	al,0fh
        cmp     al,10
        sbb     al,69h
        das
	call    _putch
	pop     eax
	ret


;
; This piece of code turns a hexdigit into it's real value
; The digit to be translated should be in AL
;
; Input 	Output
; '0'           0 or NULL
; '1'           1 or ''
; '2'           2 or ''
; '3'           3 or ''
; '4'           4 or ''
; '5'           5 or ''
; '6'           6 or ''
; '7'           7 or BEEP
; '8'           8 or BS
; '9'           9 or TAB
; 'A'          10 or LF
; 'B'          11 or ''
; 'C'          12 or ''
; 'D'          13 or CR
; 'E'          14 or ''
; 'F'          15 or ''
_hex2bin:
	sub	al,41h
	jnc	$+4
	add	al,7
	add	al,10
	ret


;IFDEF	MSDOS
;
; In:	EAX/AX/AL  =  Decimal number to print
;	EDI	  ->  Screenpos to write to
;	CH	   =  Attrib
_printdec_dword:
	pushad
	mov	edx,1000000000
	mov	esi,9*4
	jmp	__printdec

_printdec_word:
	pushad
	movzx	eax,ax
	mov	edx,10000
	mov	esi,4*4
	jmp	__printdec

_printdec_byte:
	pushad
	movzx	eax,al
	mov	edx,100
	mov	esi,2*4
	jmp	__printdec

__printdec:
	shl	ecx,(CELLSIZE-2)*4
	mov	addededi,0
	mov	ebp,0
__printdecloop0:
	mov	ebx,0
__printdecloop1:
	inc	ebx
	sub	eax,edx
	jnc	__printdecloop1

	add	eax,edx
	dec	ebx
	jnz	__printdecwrite
	cmp	esi,0				; always output a zero if it's
	je	__printdecwrite 		; the last digit!
	cmp	ebp,1
	jne	__printdecdivedx

__printdecwrite:
	mov	cl,bl
	add	cl,'0'
IFDEF	MSDOS
	mov	[edi],cx
ENDIF
IFDEF	WIN32
	mov	[edi],ecx
ENDIF
	add	edi,1*CELLSIZE
	add	addededi,1*CELLSIZE
	mov	ebp,1

__printdecdivedx:
	sub	esi,1*4
	js	_popad&ret
	mov	edx,printdeclimits[esi]
	jmp	__printdecloop0
;ENDIF


;
; In:	EAX/AX/AL  =  hexadecimal number to print
;	EDI	  ->  Screenpos to write to
;	CH	   =  Attrib
_printhexx_dword:
	pushad
	mov	edx,10000000h
	mov	esi,7*4
	jmp	__printhexx

_printhexx_word:
	pushad
	cwde
	mov	edx,1000h
	mov	esi,3*4
	jmp	__printhexx

_printhexx_byte:
	pushad
	cbw
	cwde
	mov	edx,10h
	mov	esi,1*4
	jmp	__printhexx

__printhexx:
	mov	addededi,0
	mov	ebp,0
__printhexxloop0:
	mov	ebx,0
__printhexxloop1:
	inc	ebx
	sub	eax,edx
	jnc	__printhexxloop1

	add	eax,edx
	dec	ebx
	jnz	__printhexxwrite
	cmp	esi,0				; always output a zero if it's
	je	__printhexxwrite		; the last digit!
	cmp	ebp,1
	jne	__printhexxdivedx

__printhexxwrite:
	push	eax
	mov	ah,ch
	shl	eax,(CELLSIZE-2)*4
	mov	al,bl
	cmp	al,10
	sbb	al,69h
	das
	putcell
	pop	eax
	add	addededi,1*CELLSIZE
	mov	ebp,1

__printhexxdivedx:
	sub	esi,1*4
	js	_popad&ret
	mov	edx,printhexlimits[esi]
	jmp	__printhexxloop0


;
; In:	EAX/AX/AL  =  Octal number to print
;	EDI	  ->  Screenpos to write to
;	CH	   =  Attrib
_printoct_dword:
	pushad
	mov	edx,10000000000o
	mov	esi,10*4
	jmp	__printoct

_printoct_word:
	pushad
	cwde
	mov	edx,100000o
	mov	esi,5*4
	jmp	__printoct

_printoct_byte:
	pushad
	cbw
	cwde
	mov	edx,100o
	mov	esi,2*4
	jmp	__printoct

__printoct:
	and	ecx,0ff00h
	shl	ecx,(CELLSIZE-2)*4
	mov	addededi,0
	mov	ebp,0
__printoctloop0:
	mov	ebx,0
__printoctloop1:
	inc	ebx
	sub	eax,edx
	jnc	__printoctloop1

	add	eax,edx
	dec	ebx
	jnz	__printoctwrite
	cmp	esi,0				; always output a zero if it's
	je	__printoctwrite 		; the last digit!
	cmp	ebp,1
	jne	__printoctdivedx

__printoctwrite:
	push	eax
	lea	eax,[ecx+ebx+'0']
	putcell
	pop	eax
	add	addededi,1*CELLSIZE
	mov	ebp,1

__printoctdivedx:
	sub	esi,1*4
	js	_popad&ret
	mov	edx,printoctlimits[esi]
	jmp	__printoctloop0


;
; In:	EAX/AX/AL  =  Binary number to print
;	EDI	  ->  Screenpos to write to
;	CH	   =  Attrib
_printbin_dword:
	pushad
	mov	edx,1 shl 31
	jmp	__printbin

_printbin_word:
	pushad
	cwde
	mov	edx,1 shl 15
	jmp	__printbin

_printbin_byte:
	pushad
	cbw
	cwde
	mov	edx,1 shl 7
	jmp	__printbin

__printbin:
	and	ecx,0ff00h
	shl	ecx,(CELLSIZE-2)*4
	mov	addededi,0
	xor	ebp,ebp
__printbinlop:
	test	eax,edx
	setnz	cl
	shr	edx,1
	jz	__printbinwrite

	or	cl,cl
	jnz	__printbinwrite
	or	ebp,ebp
	jz	__printbinlop

__printbinwrite:
	push	eax
	lea	eax,[ecx+'0']
	putcell
	pop	eax
	add	addededi,1*CELLSIZE
	inc	ebp
	or	edx,edx
	jnz	__printbinlop
	popad
	ret


;
; In:	EAX/AX/AL  =  Decimal number to print to stdout
_printdec_dwordt:
	pushad
	mov	edx,1000000000
	mov	esi,9*4
	jmp	__printdect

_printdec_wordt:
	pushad
	movzx	eax,ax
	mov	edx,10000
	mov	esi,4*4
	jmp	__printdect

_printdec_bytet:
	pushad
	movzx	eax,al
	mov	edx,100
	mov	esi,2*4
	jmp	__printdect

__printdect:
	mov	ebp,0
__printdecloop0t:
	mov	ebx,0
__printdecloop1t:
	inc	ebx
	sub	eax,edx
	jnc	__printdecloop1t

	add	eax,edx
	dec	ebx
	jnz	__printdecwritet
	cmp	ebp,1
	jne	__printdecdivedxt

__printdecwritet:
	push	eax
	lea	eax,[ebx+'0']
        call    _putch
	pop	eax
	mov	ebp,1

__printdecdivedxt:
	sub	esi,1*4
	js	_popad&ret
	mov	edx,printdeclimits[esi]
	jmp	__printdecloop0t


;
; Converts a letter to its uppercase (only a-z)
; In:	AL = Letter
; Out:	AL = Uppercase letter
_toupper:
	cmp	al,'a'
	jb	_ret
	cmp	al,'z'
	ja	_ret
	sub	al,32
	ret


;
; Checks if the character in AL is a hexadecimal one ('A'-'F','a'-'f','0'-'9')
; In:	AL = Letter
; Out:	CF = 0 -> hex
;	CF = 1 -> not hex
_ishex:
	cmp	al,'0'
	jb	_stc&ret
	cmp	al,'9'
	jbe	_clc&ret
	cmp	al,'A'
	jb	_stc&ret
	cmp	al,'F'
	jbe	_clc&ret
	cmp	al,'a'
	jb	_stc&ret
	cmp	al,'f'
	jbe	_clc&ret
_stc&ret:
	stc
	ret
_clc&ret:
	clc
	ret


;
; D a t a 
;
IFDEF   WIN32
.data
ENDIF

endmsg1 		label
db	' HexIt ',version,' ',BUILD,' (C) ',YEAR,' Mikael Klasson',13,10
db	'             fluff@geocities.com  *  http://mklasson.cjb.net',13,10
db	'      ',13,10
db	'        Final touch occured: ',??date,' ',??time,13,10
db	'       You''ve been HexIted: ',36
endmsg2 		label
db	' times',13,10
db	'          ',13,10
db	' Thanks for using HexIt!',13,10,36

activemsg	db	'<Active>'
inactivemsg	db	'        '

filememerrmsg1	db	13,10,'[ERROR] To load that file, you need ',36
filememerrmsg2	db	' bytes more free memory!',13,10,36
readfileerrmsg	db	13,10,'[ERROR] Couldn''t read file!',13,10,36
toomanykeyserrmsg db	13,10,'[NOTE] You have too many keys configured!',13,10
		db	'Contact Fluff, he''s probably screwed up somewhere...',13,10,36
corruptcfgfilemsg db	13,10,'[ERROR] Your config file seems to be corrupt!',13,10
		db	'Enter the Setup inside HexIt and create a new one.'
		db	13,10,36
littlememmsg1	db	13,10,'[ERROR] You need ',36
littlememmsg2	db	' bytes more ',36
littlememmsg3	db	'mem to be able to start HexIt!',13,10,36
littlelomemmsg	db	'conv ',36
pressanykeymsg	db	13,10,'Press any key to continue...',13,10,36

printdeclimits	dd	1,10,100,1000
		dd	10000,100000,1000000,10000000
		dd	100000000,1000000000
printoctlimits	dd	1,10o,100o,1000o
		dd	10000o,100000o,1000000o,10000000o
		dd	100000000o,1000000000o,10000000000o
printhexlimits	dd	1,10h,100h,1000h
		dd	10000h,100000h,1000000h,10000000h
screenxoffsets	db	11,14,17,20
		db	24,27,30,33
		db	37,40,43,46
		db	50,53,56,59
trulyactive	db	1		; 1 means print "ACTIVE"
					;  otherwise 0
					
loadingmsg	db	'Loading $'

align   4
numberoffiles	dd	0		; start with no files if not
					;  more specified on cmdline
numberofrows	dd	25		; start with 25 rows per default
nibble		db	2*MAXFILES dup(1) ; 1=high, 0=low (win #1&2)
videosaved	dd	1		; -1=not saved, 0=saved,
					;  1=not initialized

configname	db	'hexit.cfg',0
newfilename	db	'newfile',0

IF	LOGGING
logfile 	db	'hexit.log',0
ENDIF

nofileloadedfilename db '(no file loaded)',0

linefeed	db	2,13,10,?	; CR+LF
		db	1,13, ?,?	; CR
		db	1,10, ?,?	; LF
		db	1, 0, ?,?	; NULL
					; add 4 bytes for every alternative
					; first byte is length

selectedmsg	db	'Selected : ',0
headline	db	'   HexIt ',version,' (C) Mikael Klasson ',SHORTYEAR,'   ',0

textmsg 	db	'Text'
hexmsg		db	'Hex '

linefeedmsgs	db	'CRLF'
		db	'CR  '
		db	'LF  '
		db	'NULL'
		db	'Spec'

keybarempty	db	'      ','      ','      ','      ','      ','      ','      ','      ','      ','      '

frame1data	db	'Ŀ'
frame2data	db	'͸'
frame3data	db	'Ŀ;'
frame4data	db	'͸;'
frame5data	db	'ķĽ'
frame6data	db	'ķͼ'
frame7data	db	'ͻĽ'
frame8data	db	'ͻͼ'
frame9data	db	''
frame10data	db	''
frame11data	db	''
frame12data	db	''
frame13data	db	''

screenupdating	dd	-1

configsavedstr	db	41,3
		db	1
		db	0
		db	1
		db	1,1
		db	0
		db	-1,0
		db	'Config successfully saved',0
		db	'Your new configuration is now active!',0
		db	0

keyexistsmenu	db	32,6
		db	2
		db	2
		db	1
		db	21,21
		db	49,1
		db	0
		db	-1,-1,1,1,0
		db	'Key already exists!',0
		db	'Do you want to overwrite it?',0
		db	' ',0
		db	'Yes',0
		db	'No',0
		db	0

macrotoolongstr db	33,3
		db	1
		db	1
		db	1
		db	23,1
		db	0
		db	1,0
		db	'Macro too long!',0
		db	'Wake up Fluff, time to die...',0
		db	0

; max 64 chars in an error msg
getxprerrors		label	byte
			db	'OK!',0
getxprerrors_generic	db	'Generic error!',0
			db	'Missing end-parenthesis!',0
			db	'Division by zero!',0
			db	'Missing operand!',0
			db	0	; end of list

keynamesshift	db	'<Shift>+'
keynamesctrl	db	'<Ctrl>+'
keynamesalt	db	'<Alt>+'
keynamesnone	db	'(none)'
keynamesunknown db	'(unknown)'

keynamesesc	db	3,'Esc'
keynameshome	db	4,'Home'
keynamesend	db	3,'End'
keynamesleft	db	4,'Left'
keynamesright	db	5,'Right'
keynamesup	db	2,'Up'
keynamesdown	db	4,'Down'
keynamespageup	db	6,'PageUp'
keynamespagedown db	8,'PageDown'
keynamestab	db	3,'Tab'
keynamesbs	db	9,'BackSpace'
keynamesdel	db	3,'Del'
keynamesins	db	3,'Ins'
keynamesgrayminus db	6,'Gray -'
keynamesgrayplus db	6,'Gray +'
keynamesgraymultiply db 6,'Gray *'
keynamesgraydivide db	6,'Gray /'
keynamesgraydivideorenter db   15,'Gray / or Enter'
keynamesgrayenter db	10,'Gray Enter'
keynamesenter	db	5,'Enter'
keynames1	db	1,'1'
keynames2	db	1,'2'
keynames3	db	1,'3'
keynames4	db	1,'4'
keynames5	db	1,'5'
keynames6	db	1,'6'
keynames7	db	1,'7'
keynames8	db	1,'8'
keynames9	db	1,'9'
keynames0	db	1,'0'
keynamesf1	db	2,'F1'
keynamesf2	db	2,'F2'
keynamesf3	db	2,'F3'
keynamesf4	db	2,'F4'
keynamesf5	db	2,'F5'
keynamesf6	db	2,'F6'
keynamesf7	db	2,'F7'
keynamesf8	db	2,'F8'
keynamesf9	db	2,'F9'
keynamesf10	db	3,'F10'
keynamesf11	db	3,'F11'
keynamesf12	db	3,'F12'
keynamesa	db	1,'A'
keynamesb	db	1,'B'
keynamesc	db	1,'C'
keynamesd	db	1,'D'
keynamese	db	1,'E'
keynamesf	db	1,'F'
keynamesg	db	1,'G'
keynamesh	db	1,'H'
keynamesi	db	1,'I'
keynamesj	db	1,'J'
keynamesk	db	1,'K'
keynamesl	db	1,'L'
keynamesm	db	1,'M'
keynamesn	db	1,'N'
keynameso	db	1,'O'
keynamesp	db	1,'P'
keynamesq	db	1,'Q'
keynamesr	db	1,'R'
keynamess	db	1,'S'
keynamest	db	1,'T'
keynamesu	db	1,'U'
keynamesv	db	1,'V'
keynamesw	db	1,'W'
keynamesx	db	1,'X'
keynamesy	db	1,'Y'
keynamesz	db	1,'Z'
keynamesaa	db	1,''
keynamesae	db	1,''
keynamesoe	db	1,''

keynames	label
	db	KEY_ESC
	dd	offset keynamesesc

	db	KEY_HOME
	dd	offset keynameshome
	db	KEY_END
	dd	offset keynamesend
	db	KEY_LEFT
	dd	offset keynamesleft
	db	KEY_RIGHT
	dd	offset keynamesright
	db	KEY_UP
	dd	offset keynamesup
	db	KEY_DOWN
	dd	offset keynamesdown
	db	KEY_PAGEUP
	dd	offset keynamespageup
	db	KEY_PAGEDOWN
	dd	offset keynamespagedown
	db	KEY_CTRL_HOME
	dd	offset keynameshome
	db	KEY_CTRL_END
	dd	offset keynamesend
	db	KEY_CTRL_LEFT
	dd	offset keynamesleft
	db	KEY_CTRL_RIGHT
	dd	offset keynamesright
	db	KEY_CTRL_UP
	dd	offset keynamesup
	db	KEY_CTRL_DOWN
	dd	offset keynamesdown
	db	KEY_CTRL_PAGEUP
	dd	offset keynamespageup
	db	KEY_CTRL_PAGEDOWN
	dd	offset keynamespagedown
	db	KEY_ALT_HOME
	dd	offset keynameshome
	db	KEY_ALT_END
	dd	offset keynamesend
	db	KEY_ALT_LEFT
	dd	offset keynamesleft
	db	KEY_ALT_RIGHT
	dd	offset keynamesright
	db	KEY_ALT_UP
	dd	offset keynamesup
	db	KEY_ALT_DOWN
	dd	offset keynamesdown
	db	KEY_ALT_PAGEUP
	dd	offset keynamespageup
	db	KEY_ALT_PAGEDOWN
	dd	offset keynamespagedown

	db	KEY_F1
	dd	offset keynamesf1
	db	KEY_F2
	dd	offset keynamesf2
	db	KEY_F3
	dd	offset keynamesf3
	db	KEY_F4
	dd	offset keynamesf4
	db	KEY_F5
	dd	offset keynamesf5
	db	KEY_F6
	dd	offset keynamesf6
	db	KEY_F7
	dd	offset keynamesf7
	db	KEY_F8
	dd	offset keynamesf8
	db	KEY_F9
	dd	offset keynamesf9
	db	KEY_F10
	dd	offset keynamesf10
	db	KEY_F11
	dd	offset keynamesf11
	db	KEY_F12
	dd	offset keynamesf12
	db	KEY_CTRL_F1
	dd	offset keynamesf1
	db	KEY_CTRL_F2
	dd	offset keynamesf2
	db	KEY_CTRL_F3
	dd	offset keynamesf3
	db	KEY_CTRL_F4
	dd	offset keynamesf4
	db	KEY_CTRL_F5
	dd	offset keynamesf5
	db	KEY_CTRL_F6
	dd	offset keynamesf6
	db	KEY_CTRL_F7
	dd	offset keynamesf7
	db	KEY_CTRL_F8
	dd	offset keynamesf8
	db	KEY_CTRL_F9
	dd	offset keynamesf9
	db	KEY_CTRL_F10
	dd	offset keynamesf10
	db	KEY_CTRL_F11
	dd	offset keynamesf11
	db	KEY_CTRL_F12
	dd	offset keynamesf12
	db	KEY_ALT_F1
	dd	offset keynamesf1
	db	KEY_ALT_F2
	dd	offset keynamesf2
	db	KEY_ALT_F3
	dd	offset keynamesf3
	db	KEY_ALT_F4
	dd	offset keynamesf4
	db	KEY_ALT_F5
	dd	offset keynamesf5
	db	KEY_ALT_F6
	dd	offset keynamesf6
	db	KEY_ALT_F7
	dd	offset keynamesf7
	db	KEY_ALT_F8
	dd	offset keynamesf8
	db	KEY_ALT_F9
	dd	offset keynamesf9
	db	KEY_ALT_F10
	dd	offset keynamesf10
	db	KEY_ALT_F11
	dd	offset keynamesf11
	db	KEY_ALT_F12
	dd	offset keynamesf12
	db	KEY_SHIFT_F1
	dd	offset keynamesf1
	db	KEY_SHIFT_F2
	dd	offset keynamesf2
	db	KEY_SHIFT_F3
	dd	offset keynamesf3
	db	KEY_SHIFT_F4
	dd	offset keynamesf4
	db	KEY_SHIFT_F5
	dd	offset keynamesf5
	db	KEY_SHIFT_F6
	dd	offset keynamesf6
	db	KEY_SHIFT_F7
	dd	offset keynamesf7
	db	KEY_SHIFT_F8
	dd	offset keynamesf8
	db	KEY_SHIFT_F9
	dd	offset keynamesf9
	db	KEY_SHIFT_F10
	dd	offset keynamesf10
	db	KEY_SHIFT_F11
	dd	offset keynamesf11
	db	KEY_SHIFT_F12
	dd	offset keynamesf12

	db	KEY_TAB
	dd	offset keynamestab
	db	KEY_BS
	dd	offset keynamesbs
	db	KEY_DEL
	dd	offset keynamesdel
	db	KEY_INS
	dd	offset keynamesins

	db	KEY_CTRL_TAB
	dd	offset keynamestab
	db	KEY_CTRL_INS
	dd	offset keynamesins
	db	KEY_CTRL_DEL
	dd	offset keynamesdel

	db	KEY_ALT_INS
	dd	offset keynamesins
	db	KEY_ALT_DEL
	dd	offset keynamesdel

	db	KEY_MINUS
	dd	offset keynamesgrayminus
	db	KEY_PLUS
	dd	offset keynamesgrayplus
	db	KEY_MULTIPLY
	dd	offset keynamesgraymultiply
	db	KEY_DIVIDE
	dd	offset keynamesgraydivideorenter

	db	KEY_CTRL_MINUS
	dd	offset keynamesgrayminus
	db	KEY_CTRL_PLUS
	dd	offset keynamesgrayplus
	db	KEY_CTRL_MULTIPLY
	dd	offset keynamesgraymultiply
	db	KEY_CTRL_DIVIDE
	dd	offset keynamesgraydivide

	db	KEY_ALT_DIVIDE
	dd	offset keynamesgraydivide

	db	KEY_ENTER
	dd	offset keynamesenter

	db	KEY_ALT_GRAY_ENTER
	dd	offset keynamesgrayenter

	db	KEY_1
	dd	offset keynames1
	db	KEY_2
	dd	offset keynames2
	db	KEY_3
	dd	offset keynames3
	db	KEY_4
	dd	offset keynames4
	db	KEY_5
	dd	offset keynames5
	db	KEY_6
	dd	offset keynames6
	db	KEY_7
	dd	offset keynames7
	db	KEY_8
	dd	offset keynames8
	db	KEY_9
	dd	offset keynames9
	db	KEY_0
	dd	offset keynames0

	db	KEY_ALT_1
	dd	offset keynames1
	db	KEY_ALT_2
	dd	offset keynames2
	db	KEY_ALT_3
	dd	offset keynames3
	db	KEY_ALT_4
	dd	offset keynames4
	db	KEY_ALT_5
	dd	offset keynames5
	db	KEY_ALT_6
	dd	offset keynames6
	db	KEY_ALT_7
	dd	offset keynames7
	db	KEY_ALT_8
	dd	offset keynames8
	db	KEY_ALT_9
	dd	offset keynames9
	db	KEY_ALT_0
	dd	offset keynames0

	db	KEY_A
	dd	offset keynamesa
	db	KEY_B
	dd	offset keynamesb
	db	KEY_C
	dd	offset keynamesc
	db	KEY_D
	dd	offset keynamesd
	db	KEY_E
	dd	offset keynamese
	db	KEY_F
	dd	offset keynamesf
	db	KEY_G
	dd	offset keynamesg
	db	KEY_H
	dd	offset keynamesh
	db	KEY_I
	dd	offset keynamesi
	db	KEY_J
	dd	offset keynamesj
	db	KEY_K
	dd	offset keynamesk
	db	KEY_L
	dd	offset keynamesl
	db	KEY_M
	dd	offset keynamesm
	db	KEY_N
	dd	offset keynamesn
	db	KEY_O
	dd	offset keynameso
	db	KEY_P
	dd	offset keynamesp
	db	KEY_Q
	dd	offset keynamesq
	db	KEY_R
	dd	offset keynamesr
	db	KEY_S
	dd	offset keynamess
	db	KEY_T
	dd	offset keynamest
	db	KEY_U
	dd	offset keynamesu
	db	KEY_V
	dd	offset keynamesv
	db	KEY_W
	dd	offset keynamesw
	db	KEY_X
	dd	offset keynamesx
	db	KEY_Y
	dd	offset keynamesy
	db	KEY_Z
	dd	offset keynamesz
	db	KEY_AA
	dd	offset keynamesaa
	db	KEY_AE
	dd	offset keynamesae
	db	KEY_OE
	dd	offset keynamesoe

	db	-1	; end of list

align	4
___putscreen_text_maxpos	dd	?
___putscreen_text_scrxp 	dd	?
___putscreen_text_linexp	dd	?

messpecial1	dd	?
messpecial2	dd	?
messpecial3	dd	?
messpecial4	dd	?
messpecial5	dd	?

mgkretval       label   word
mgk_al          db      ?
mgk_ah          db      ?


IFDEF   MSDOS
        code32 ends
ENDIF

end _main

;

I _really_ should allow mouse-defs in the key-setup...

       Information on TXTxBUTTON variables
       

These are the possible values and what they mean:

	0	Bring up Info-Screen			(F1)
	1	Bring up Help on Keys			(Alt+H)
	2	Wrap / Unwrap				(F2)
	3	Choose File to Edit			(F3)
	4	Edit Previous File			(Alt+P)
	5	Edit Next File				(Alt+N)
	6	Goto HexMode				(F4)
	7	Change LineFeed 			(F6)
	8	Search					(F7)
	9	Replace 				(F8)
	10	Find Next				(Ctrl+L)
	11	Choose Videomode			(Ctrl+F1)
	12	Enter Setup				(Ctrl+F9)
	13	Scroll One Line Up			(CursUp)
	14	Scroll One Line Down			(CursDown)
	15	Scroll Together with MouseMovement
	16	Scroll One Page Up			(PgUp)
	17	Scroll One Page Down			(PgDown)
	18	Go to First Row 			(Home)
	19	Go to Last Row				(End)


       Information on HEXxBUTTON variables
       

These are the possible values and what they mean:

	0	Bring up Info-Screen				(F1)
	1	Bring up Help on Keys				(Alt+H)
	2	Filecompare					(Ctrl+F2)
	3	Choose File to Edit				(F3)
	4	Edit Previous File				(Alt+P)
	5	Edit Next File					(Alt+N)
	6	Goto TextMode					(F4)
	7	Goto Offset					(F5)
	8	Search						(F7)
	9	Replace 					(F8)
	10	Find Next					(Ctrl+L)
	11	Choose Videomode				(Ctrl+F1)
	12	Enter Setup					(Ctrl+F9)
	13	Move Pos 1 Line Up and Scroll Screen		(CursUp)
	14	Move Pos 1 Line Down and Scroll Screen		(CursDown)
	15	Scroll Together with MouseMovement
	16	Move Pos 16 Lines Up and Scroll Screen
	17	Move Pos 16 Lines Down and Scroll Screen
	18	Move Pos 16 Lines Up				(PgUp)
	19	Move Pos 16 Lines Down				(PgDown)
	20	Go to First Line				(Home)
	21	Go to Last Line 				(End)

